#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <random>
#include <stack>
#include <climits>
#include <chrono>
#include <fstream>
#include <algorithm>
#include <cassert>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

#define _ << " " <<
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define ff first
#define ss second
#define pb push_back
#define debug(x) cout << (#x) << " is " << (x) << endl

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const double eps = 1e-8;
const ll INF = 2e9;

//#define int ll

int solve(int n, int k, vector<string> &a) {
    struct node {
        int cnt = 0;
        int p = -1;
        int del = 0;
        map<char, int> next;
    };

    vector<node> trie(301000);
    int ptr = 1;

    auto add = [&](string &s) {
        int cur = 0;
        trie[cur].cnt++;
        for (int i = 0; i < s.size(); i++) {
            if (trie[cur].next.find(s[i]) == trie[cur].next.end()) {
                assert(ptr < 301000);
                trie[cur].next[s[i]] = ptr++;
            }
            int prev = cur;
            cur = trie[cur].next[s[i]];
            trie[cur].p = prev;
            trie[cur].cnt++;
        };
    };

    ll ans = 0;

    int to_minus = 0;

    function <void(int, int)> dfs = [&](int v, int k) {
        if (trie[v].p != -1 && trie[trie[v].p].cnt - trie[v].del - trie[trie[v].p].del <= k) return;
        if (trie[v].cnt - trie[v].del <= k) {
            trie[v].del += trie[v].cnt - trie[v].del;
            ans++;
            return;
        }

        vector<pii> candidates;
        for (auto &i: trie[v].next) candidates.pb({trie[i.ss].cnt, i.ss});
        std::random_device rd;
        std::mt19937 g(rd());
        std::shuffle(candidates.begin(), candidates.end(), g);
        //sort(all(candidates));
        for (auto &i: candidates) {
            dfs(i.ss, k);
            trie[v].del += trie[i.ss].del;
            if (trie[v].p != -1 && trie[trie[v].p].cnt - trie[v].del - trie[trie[v].p].del <= k) return;
            if (trie[v].cnt - trie[v].del <= k) {
                trie[v].del += trie[v].cnt - trie[v].del;
                ans++;
                return;
            }
        }
    };

    for (auto &i : a) add(i);
    dfs(0, k);
    return ans;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output_false.txt", "w", stdout); //outs
#endif
    int n, k;
    cin >> n >> k;
    vector<string> a(n);
    for (string &i : a) cin >> i;
    int ans = INF;
    for (int i = 0; i < 10; i++) ans = min(ans, solve(n, k, a));
    assert(ans != INF);
    cout << ans << endl;
    return 0;
}