﻿// C.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <algorithm>

using namespace std;

string files[300000];
bool deleted[300000];
int markedAsDeleted[300000];
//char* alphabet = ['a','b','c','d','e']

int findMinLength(string arr[], int n, int offset)
{
	int min = INT_MAX;

	for (int i = 0; i <= n - 1; i++) 
	{
		if (deleted[i + offset])
			continue;
		if (arr[i].length() < min)
			min = arr[i].length();
	}
	return(min);
}

bool allContainsPrefix(string arr[], int n, string str,
	int start, int end, int offset)
{
	for (int i = 0; i <= n - 1; i++)
		for (int j = start; j <= end; j++) 
		{
			if (deleted[i + offset])
				continue;
			if (arr[i][j] != str[j])
				return (false);
		}
	return (true);
}

// A Function that returns the longest common prefix
// from the array of strings
string commonPrefix(string arr[], int n, int offset)
{
	int index = findMinLength(arr, n, offset);
	string prefix; // Our resultant string

	// We will do an in-place binary search on the
	// first string of the array in the range 0 to
	// index
	int low = 0, high = index;

	while (low <= high)
	{
		// Same as (low + high)/2, but avoids overflow
		// for large low and high
		int mid = low + (high - low) / 2;

		if (allContainsPrefix(arr, n, arr[0], low, mid, offset))
		{
			// If all the strings in the input array contains
			// this prefix then append this substring to
			// our answer
			prefix = prefix + arr[0].substr(low, mid - low + 1);

			// And then go for the right part
			low = mid + 1;
		}

		else // Go for the left part
			high = mid - 1;
	}

	return (prefix);
}


int deleteByPrefix(string prefix, int k, int n)
{
	int cnt = 0;
	int markedLength = 0;
	for (int i = 0; i < n; i++)
	{
		if (files[i].rfind(prefix, 0) == 0)
		{
			cnt++;
			if (cnt > k)
				return -1;
			markedAsDeleted[markedLength++] = i;
		}
	}
	for (int i = 0; i < markedLength; i++)
	{
		deleted[markedAsDeleted[i]] = true;
	}
	return cnt;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, k;
    cin >> n >> k;
	int totalStrings = n;

	for (int i = 0; i < n; i++)
    {
        std::cin >> files[i];
    }

	std::sort(files, files + n);

	int beginning = 0;

	/*for (int i = 0; i < n; i++)
	{
		std::cout << files[i] << endl;
	}*/

	int rmCount = 0;
	while (totalStrings > 0)
	{
		for (int start = beginning; start < n;)
		{
			if (deleted[start])
			{
				start++;
				continue;
			}

			int largestStemLen = files[start].length();
			int largestStemEnd = start;
			string largestStem = files[start];
			for (int end = start + 1; end < n && end - start + 1 <= k; end++)
			{
				string stem = commonPrefix(files + start, end - start + 1, start);
				int len = stem.length();
				if (len != 0)
				{
					largestStemLen = len;
					largestStemEnd = end;
					largestStem = stem;
				}
				else
				{
					break;
				}
			}

			int amountDeleted = deleteByPrefix(largestStem, k, n);
			if (amountDeleted != -1)
			{
				totalStrings -= amountDeleted;
				start = largestStemEnd + 1;
				rmCount++;
			}
			else
			{
				start++;
			}

			if (totalStrings <= k && totalStrings != 0)
			{
				rmCount++;
				totalStrings = 0;
				break;
			}
		}
	}

	std::cout << rmCount;
}