#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//-----------------------------------------------
#define LOG
#ifdef LOG
  #define db(x)     cerr << #x << ": " << x << endl;
  #define dbA(x, s) cerr << #x << ": "; for (int i = 0; i < s; i++) cerr << x[i] << " "; cerr << endl;
#else
  #define db(x)
  #define dbA(x, s)
#endif
//-----------------------------------------------
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
//-----------------------------------------------
template<class K, class V> ostream& operator << (ostream& out, const pair<K, V>& obj) { out << "{ " << obj.first << ", " << obj.second << " }"; return out; }
template<class T> ostream& operator << (ostream& out, const vector<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const deque<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const unordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const ordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const unordered_map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
//-----------------------------------------------
#define all(x)  x.begin(), x.end()
#define sz(x)   (int)x.size()
#define sq(x)   (x) * (x)
#define fr      first
#define sc      second
#define newline puts("")
//-----------------------------------------------
using ll128 = __int128_t;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
//-----------------------------------------------
const int N   = 1000 * 1000 + 5;
const ll mod  = 1000000007;
const ll mod3 = 998244353;
const ll INFL = 2000000000 * 1ll * 1000000000 + 500000;
const ll INF  = 1000000000;
// const ld pi   = acosl(-1.0);
//-----------------------------------------------

struct Node {
  static int index;
  int children[26];
  int count;
  int parent;

  Node() {
    count = 0;
    for (int i = 0; i < 26; i++) {
      children[i] = -1;
    }
    parent = -1;
  }
}tr[N];

int Node::index = 1;

void add_string(string& s) {
  int current = 0;
  for (int i = 0; i < s.length(); i++) {
    if (tr[current].children[s[i] - 'a'] == -1) {
      tr[Node::index].parent = current;
      tr[current].children[s[i] - 'a'] = Node::index++;
    }
    tr[current].count++;
    current = tr[current].children[s[i] - 'a'];
  }
  tr[current].count++;
}

set<pair<int, int>> counts;
int n, k;
string s;

void traverse(int v) {
  if (v == -1) return;
  counts.emplace(tr[v].count, v);
  for (int i = 0; i < 26; i++) {
    if (tr[v].children[i] == -1) continue;
    traverse(tr[v].children[i]);
  }
}

void input() {
  cin >> n >> k;
  for (int i = 0; i < n; i++) {
    cin >> s;
    add_string(s);
  }
  traverse(0);
}

void free_subtree(int v) {
  if (v == -1 || tr[v].count == 0) return;
  counts.erase({tr[v].count, v});
  for (int i = 0; i < 26; i++) {
    if (tr[v].children[i] == -1) continue;
    free_subtree(tr[v].children[i]);
  }
}

void update(int v, int removed_cnt) {
  if (v == -1) return;
  counts.erase({ tr[v].count, v });
  tr[v].count -= removed_cnt;

  if (tr[v].count != 0) {
    counts.emplace(tr[v].count, v);
  }

  update(tr[v].parent, removed_cnt);
}

void solve(int test_id) {
  int ans = 0, v, removed = 0, val;
  while (removed < n) {
    auto it = counts.upper_bound({k, INF});
    --it;
    v = it->second;

    removed += it->first;
    val = it->first;

    ans++;
    free_subtree(v);
    update(tr[v].parent, val);
  }
  cout << ans << endl;
}

int main() {
  int testcases = 1;
  // scanf("%d", &testcases);
  for(int test_id = 1; test_id <= testcases; test_id++) {
    input();
    solve(test_id);
  }
  return 0;
}