#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const int MOD = 998244353;

long long binpow(long long a, long long p){
	return p?binpow(a*a%MOD, p>>1)*(p&1?a:1)%MOD:1;
}

long long bininv(long long a){
	return binpow(a, MOD-2);
}

vector<vector<vector<long long> > > dp; // contestant -> problem -> minute -> num cases (contestant solved problem at minute) 
vector<long long> fct;

void calc(int ind, vector<int>& a, int k, int c){
	for (int frst=0;frst<a.size();++frst){
		if (a[frst] == 0) continue;
		vector<vector<long long> > cnt(k + 1, vector<long long>(a.size(), 0));
		vector<vector<long long> > cnt2;
		cnt[0][0] = 1;
		for (int i=0;i<a.size();++i){
			if (i == frst) continue;
			if (a[i] == 0) continue;
			cnt2 = cnt;
			for (int q=i+1;q>0;--q){
				for (int j=k - a[i];j>=0;--j){
					(cnt2[j + a[i]][q] += cnt[j][q-1]) %= MOD;
				}
			}
			swap(cnt, cnt2);
		}
		for (int j=k-a[frst];j>=0;--j){
			for (int q=0;q<a.size();++q){
				(dp[ind][frst][j + a[frst]] += cnt[j][q] * fct[c - q - 1]) %= MOD;
			}
		}
	}
}

void solve(int test_ind){
	int n, m, k;
	cin >> n >> m >> k;

	vector<long long> idenom(n);

	fct = vector<long long>(27, 1);
	for (int i=1;i<=26;++i){
		fct[i] = fct[i-1] * i % MOD;
	}

	vector<vector<int> > a(n, vector<int>(m));
	dp = vector<vector<vector<long long> > >(n, vector<vector<long long> >(m, vector<long long>(k+1, 0)));
	for (int i=0;i<n;++i){
		int c = 0;
		for (int j=0;j<m;++j){
			cin >> a[i][j];
			if (a[i][j] != 0) ++c;
		}
		idenom[i] = bininv(fct[c]);
		calc(i, a[i], k, c);
	}

	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			for (int l=1;l<=k;++l){
				// cout << i << " " << j << " " << l << " " << dp[i][j][l] << endl;
				(dp[i][j][l] += dp[i][j][l-1]) %= MOD;
			}
		}
	}
	// dp -> dp pref sum

	vector<vector<long long> > unsolved(m, vector<long long>(k+1, 0));
	for (int prob=0;prob<m;++prob){
		for (int j=0;j<=k;++j){
			long long p = 1;
			for (int i=0;i<n;++i){
				if (a[i][prob] == 0) continue;
				(p *= 1 + MOD - dp[i][prob][j] * idenom[i] % MOD) %= MOD;
			}
			unsolved[prob][j] = p % MOD;
		}
	}

	vector<long long> ans(n, 0);

	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			for (int l=1;l<=k;++l){
				long long d = (dp[i][j][l] - dp[i][j][l-1] + MOD) % MOD * idenom[i] % MOD;
				(ans[i] += d * unsolved[j][l - 1] % MOD * bininv(1 + MOD - dp[i][j][l-1] * idenom[i] % MOD) % MOD) %= MOD;
			}
		}
	}

	for (long long p: ans){
		cout << p << endl;
	}
}

int main(){
	int t=1;
	//cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
