#include <iostream>
#include <vector>

void getData(std::vector<std::vector<char>> &data){
    for(int i = 0; i < data.size(); ++i)
        for(int j = 0; j < data[0].size(); ++j)
            std::cin>>data[i][j];
}

void printData(const std::vector<std::vector<char>> &data){
    for(int i = 0; i < data.size(); ++i){
        for(int j = 0; j < data[0].size(); ++j)
            std::cout<<data[i][j]<<"";
    std::cout<<"\n";
    }
    std::cout<<"\n";
}

bool checkq(int i, int j, std::vector<std::vector<char>> &grid){
    std::vector<std::vector<char>> q = {{'#', '#', '#'},
                                        {'#', '.', '#'},
                                        {'#', '#', '#'},
                                        {'.', '.', '#'},
                                        {'.', '.', '#'},};
    if(i - 4 < 0 || j - 2 < 0)
        return false;
    for(int x = i; x >= i - 4; --x)
        for(int y = j; y >= j - 2; --y)
            if(q[x - i + 4][y - j + 2] == '#' && grid[x][y] == '.')
                return false;

    for(int x = i; x >= i - 4; --x)
        for(int y = j; y >= j - 2; --y)
            if(q[x - i + 4][y - j + 2] == '#')
                grid[x][y] = 'x';

//    printData(grid);
   return true;
}

bool checkf(int i, int j, std::vector<std::vector<char>> &grid){
    std::vector<std::vector<char>> f = {{'#', '#', '#'},
                                        {'#', '.', '.'},
                                        {'#', '#', '.'},
                                        {'#', '.', '.'},
                                        {'#', '.', '.'}};

    if(i - 4 < 0 || j + 3 > grid[0].size())
        return false;
    for(int x = i; x >= i - 4; --x)
        for(int y = 0; y < j + 3; ++y)
            if(f[x - i + 4][y - j] == '#' && grid[x][y] == '.')
                return false;

    for(int x = i; x >= i - 4; --x)
        for(int y = 0; y < j + 3; ++y)
            if(f[x - i + 4][y - j] == '#')
                grid[x][y] = 'x';

//    printData(grid);
    return true;
}



int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0); std::cout.tie(0);

    int n, m;
    int q = 0, f = 0;

    std::cin>>n>>m;

    std::vector<std::vector<char>> grid(n, std::vector(m, '.'));
    getData(grid);

    for(int i = n - 1; i >= 0; --i)
        for(int j = m - 1; j >= 0; --j){
            if(grid[i][j] == '#'){
                q += checkq(i, j, grid);
                if(grid[i][j] == '#')
                    f += checkf(i, j, grid);
            }
        }

    std::cout<<q<<" "<<f<<"\n";
    return 0;
}

//5 8
//###..###
//#....#.#
//##...###
//#......#
//#......#

//5 6
//######
//#..#.#
//##.###
//#....#
//#....#

//10 8
//###.....
//#.###...
//###.#...
//#.###...
//#...#...
//###.#...
//#.......
//##......
//#.......
//#.......

//5 6
//######
//#.##..
//#####.
//..##..
//..##..

//5 6
//######
//#.##.#
//######
//..#..#
//..#..#

//5 6
//######
//#..#..
//##.##.
//#..#..
//#..#..

//5 3
//###
//#..
//##.
//#..
//#..

//9 8
//.....###
//###..#.#
//#....###
//##..####
//#####.##
//##..###.
//.##...#.
//.#....#.
//.#......

//40 8
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..
//###..###
//#.#..#..
//###..##.
//..#..#..
//..#..#..

//9 8
//........
//........
//..###...
//..#.#...
//..###...
//..#.....
//..#.....
//........
//........

//8 7
//###....
//#......
//##.....
//####...
//##.....
//.##....
//.#.....
//.#.....

//8 7
//.......
//...###.
//####...
//#.###..
//####...
//..##...
//..#....
//.......

//9 7
//.###...
//.#.###.
//.###.#.
//.#.###.
//.#####.
//..#..#.
//..##...
//..#....
//..#....