// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;

template<typename TI, typename TF>
class generic_point {
public:
    TI x, y;

    generic_point() = default;

    generic_point(TI _x, TI _y) : x(_x), y(_y) {}

    generic_point<TI, TF> operator+(const generic_point<TI, TF>& other) const {
        return generic_point<TI, TF>(x + other.x, y + other.y);
    }

    generic_point<TI, TF> operator-(const generic_point<TI, TF>& other) const {
        return generic_point<TI, TF>(x - other.x, y - other.y);
    }

    generic_point<TI, TF> operator+() const {
        return *this;
    }

    generic_point<TI, TF> operator-() const {
        return generic_point<TI, TF>(-x, -y);
    }

    generic_point<TI, TF> operator*(TI k) const {
        return generic_point<TI, TF>(x * k, y * k);
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value, generic_point<TI, TF>>::type
    operator/(TF k) const {
        return generic_point<TI, TF>(x / k, y / k);
    }

    TI operator*(const generic_point<TI, TF>& other) const {
        return x * other.x + y * other.y;
    }

    TI operator%(const generic_point<TI, TF>& other) const {
        return x * other.y - y * other.x;
    }

    TI lenSqr() const {
        return x * x + y * y;
    }

    TF len() const {
        return sqrt(lenSqr());
    }

    TI distSqr(const generic_point<TI, TF>& other) const {
        return (other - *this).lenSqr();
    }

    TF dist(const generic_point<TI, TF>& other) const {
        return sqrt(distSqr(other));
    }

    generic_point<TI, TF> norm() const {
        return *this / len();
    }

    // Counterclockwise rotation by 90 degrees
    generic_point<TI, TF> ort() const {
        return generic_point<TI, TF>(-y, x);
    }

    // Counterclockwise rotation by c = cos(alpha), s = sin(alpha)
    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value, generic_point<TI, TF>>::type
    rot(TF c, TF s) const {
        return *this * c + ort() * s;
    }

    // Counterclockwise rotation by alpha
    generic_point<TI, TF> rot(TF alpha) const {
        return rot(cos(alpha), sin(alpha));
    }

    TF arg() const {
        return atan2(y, x);
    }

    int quad() const {
        if (x >= 0 && y >= 0) {
            return 1;
        } else if (x < 0 && y >= 0) {
            return 2;
        } else if (x < 0 && y < 0) {
            return 3;
        } else if (x >= 0 && y < 0) {
            return 4;
        }
        throw;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value>::type
    scan() {
        double _x, _y;
        scanf("%lf%lf", &_x, &_y);
        x = _x;
        y = _y;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_integral<T>::value>::type
    scan() {
        ll _x, _y;
        scanf("%lld%lld", &_x, &_y);
        x = _x;
        y = _y;
    }

    template<typename T = TI>
    typename std::enable_if<std::is_floating_point<T>::value>::type
    print() {
        printf("%.10lf %.10lf\n", (double)x, (double)y);
    }

    template<typename T = TI>
    typename std::enable_if<std::is_integral<T>::value>::type
    print() {
        printf("%lld %lld\n", (ll)x, (ll)y);
    }
};

using point = generic_point<double, double>;

class line {
public:
	double a, b, c;

	line() = default;

	line(double _a, double _b, double _c) : a(_a), b(_b), c(_c) {}

	line(const point& p1, const point& p2) {
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -a * p1.x - b * p1.y;
	}
};

point intersect(const line& l1, const line& l2) {
	double d = l1.a * l2.b - l2.a * l1.b;
	double dx = -l1.c * l2.b + l2.c * l1.b;
	double dy = -l1.a * l2.c + l2.a * l1.c;
	return point(dx / d, dy / d);
}

const int N = 10100;
const double EPS = 1e-9;
const int ITERS = 32;

int n;
point a[N];

double calc(double optX, double optY) {
	point p(optX, optY);

	double res = 0.0;
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		while (true) {
			int nxt = ptr + 1;
			if (nxt == n) {
				nxt = 0;
			}

			if ((a[nxt] - a[i]) % (p - a[i]) > -EPS) {
				ptr = nxt;
			} else {
				break;
			}
		}

		int nxt = ptr + 1;
		if (nxt == n) {
			nxt = 0;
		}

		point where = intersect(line(a[i], p), line(a[ptr], a[nxt]));
		double d1 = a[i].dist(p);
		double d2 = p.dist(where);

		if (d1 < d2) {
			std::swap(d1, d2);
		}

		smax(res, d1 / d2);
	}

	return res;
}

double findY(double optX) {
	double l = INF;
	double r = -INF;

	for (int i = 0; i < n; ++i) {
		if (std::min(a[i].x, a[i + 1].x) <= optX && optX <= std::max(a[i].x, a[i + 1].x)) {
			auto pt = intersect(line(1.0, 0.0, -optX), line(a[i], a[i + 1]));
			smin(l, pt.y);
			smax(r, pt.y);
		}
	}

	for (int it = 0; it < ITERS; ++it) {
		if (r - l < EPS) {
			break;
		}
		double m1 = (2.0 * l + r) / 3.0;
		double m2 = (l + 2.0 * r) / 3.0;

		double c1 = calc(optX, m1);
		double c2 = calc(optX, m2);

		if (c1 < c2) {
			r = m2;
		} else {
			l = m1;
		}
	}

	return (l + r) / 2.0;
}

double findX() {
	double l = INF;
	double r = -INF;

	for (int i = 0; i < n; ++i) {
		smin(l, a[i].x);
		smax(r, a[i].x);
	}

	for (int it = 0; it < ITERS; ++it) {
		if (r - l < EPS) {
			break;
		}
		double m1 = (2.0 * l + r) / 3.0;
		double m2 = (l + 2.0 * r) / 3.0;

		double y1 = findY(m1);
		double y2 = findY(m2);

		if (calc(m1, y1) < calc(m2, y2)) {
			r = m2;
		} else {
			l = m1;
		}
	}

	return (l + r) / 2.0;
}

void run() {
    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
    	a[i].scan();
    }
    a[n] = a[0];

    double optX = findX();
    double optY = findY(optX);
    double ans = calc(optX, optY);

    printf("%.10lf\n", ans);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
