#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<long long, long long>;

const int inf = 1e9;
const ll inf64 = 1e18;

struct output {
    vector<int> res;

    void print() {
        for (auto x : res)
            cout << x << " ";
        cout << "\n";
    }

    bool operator == (const output& o) const {
        throw;
    }
};

struct input {
    int n, m;
    vector<vector<pii>> g;

    input() = default;

    void read() {
        cin >> n >> m;
        g.resize(n + 1);
        for (int u, v, w, i = 0; i < m; i++) {
            cin >> u >> v >> w;
            g[u].emplace_back(v, w);
            g[v].emplace_back(u, w);
        }
    }

    void print() {

    }

    void gen() {
        // use static
    }

    vector<tuple<int, int, int>> find(int s) {
        vector<int> dist(n + 1, inf), from(n + 1, -1);
        {
            dist[s] = 0;
            queue<int> q;
            q.push(s);
            while (!q.empty()) {
                int v = q.front();
                q.pop();
                for (auto [to, w] : g[v]) {
                    if (dist[to] > dist[v] + 1) {
                        dist[to] = dist[v] + 1;
                        q.push(to);
                    }
                }
            }
        }
        vector<int> perm(n);
        iota(perm.begin(), perm.end(), 1);
        sort(perm.begin(), perm.end(), [&](int u, int v) {
            return dist[u] < dist[v];
        });
        vector<int> dp(n + 1);
        for (int v : perm) {
            for (auto [to, w] : g[v]) {
                if (dist[to] + 1 == dist[v]) {
                    int tmp = max({dp[v], dp[to], w});
                    if (tmp > dp[v]) {
                        dp[v] = tmp;
                        from[v] = to;
                    }
                }
            }
        }
        vector<tuple<int, int, int>> res(n + 1);
        for (int v = 1; v <= n; v++)
            res[v] = {dist[v], dp[v], from[v]};
        return res;
    }

    output fast() {
        vector<tuple<int, int, int>> a = find(1), b = find(n);
        int bu = -1, bv = -1, best_diff = -1;
        for (int u = 1; u <= n; u++) {
            for (auto [v, w] : g[u]) {
                if (get<0>(a[u]) + 1 + get<0>(b[v]) != get<0>(a[n]))
                    continue;
                int mn = w;
                int mx = max({w, get<1>(a[u]), get<1>(b[v])});
                int tmp_diff = mx - mn;
                if (tmp_diff > best_diff) {
                    best_diff = tmp_diff;
                    bu = u;
                    bv = v;
                }
            }
        }
        vector<int> pa, pb;
        for (int x = bu;;x = get<2>(a[x])) {
            pa.push_back(x);
            if (x == 1)
                break;
        }
        for (int x = bv;;x = get<2>(b[x])) {
            pb.push_back(x);
            if (x == n)
                break;
        }
        reverse(pa.begin(), pa.end());
        for (int x : pb)
            pa.push_back(x);
        return output{pa};
    }

    output slow() {
        return output();
    }
};

void test_case() {
    input in;
    in.read();
    output res = in.fast();
    res.print();
}

void work() {
    int t = 1;
    while (t--)
        test_case();
}

void test() {
    for (int t = 1;;t++) {
        input in;
        in.gen();
        input in_fs = in;
        input in_sl = in;
        output fs = in_fs.fast();
        output sl = in_sl.slow();
        if (fs == sl) {
            cout << "OK" << endl;
            fs.print();
            cout << "\n=========" << endl;
        } else {
            cout << "WA " << t << "\n";
            cout << "exp\n";
            sl.print();
            cout << "\n=========\n";
            cout << "fnd\n";
            fs.print();
            cout << "\n=========\n";
            in.print();
            break;
        }
    }
}

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    work();
//    test();

    return 0;
}
