#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

using ld = long double;
#define double ld

const double EPS = 1e-9;

struct point {
	double x, y;
	point(double a, double b) : x(a), y(b) {}
	point() : point(0, 0) {}
};

double operator%(point a, point b) {
	return a.x * b.y - a.y * b.x;
}
double operator*(point a, point b) {
	return a.x * b.x + a.y * b.y;
}
point vec(point a, point b) {
	return point(b.x - a.x, b.y - a.y);
}
point operator*(point a, double k) {
	return point(a.x * k, a.y * k);
}
point operator+(point a, point b) {
	return point(a.x + b.x, a.y + b.y);
}
point cross(point a, point b, point c, point d) {
	double acd = vec(a, c) % vec(a, d);
	double bdc = vec(b, d) % vec(b, c);
	if (abs(acd + bdc) < EPS) {
		assert(false);
	}
	return a + vec(a, b) * (acd / (acd + bdc));
}
double dist(point a, point b) {
	return hypot(a.x - b.x, a.y - b.y);
}
istream &operator>>(istream &in, point &p) {
	return in >> p.x >> p.y;
}
ostream &operator<<(ostream &out, point p) {
	return out << p.x << " " << p.y;
}

double area(vector<point> p) {
	if (p.size() < 3) {
		return 0;
	}
	double s = 0;
	int n = (int)p.size();
	p.push_back(p[0]);
	for (int i = 0; i < n; ++i) {
		s += p[i] % p[i + 1];
	}
	return abs(s) / 2;
}

vector<point> cut(vector<point> p, point a, point b) {
	vector<point> res;
	int n = (int)p.size();
	p.push_back(p[0]);
	auto f = [&](point x) {
		return vec(a, b) % vec(a, x);
	};
	for (int i = 0; i < n; ++i) {
		if (f(p[i]) >= 0) {
			res.push_back(p[i]);
		}
		if (f(p[i]) * f(p[i + 1]) < 0) {
			res.push_back(cross(p[i], p[i + 1], a, b));
		}
	}
	return res;
}



ld find_govno(vector<point>& a, point p) {
	int r = 1;
	int n = a.size();
	ld res = 1e18;
	for (int l = 0; l < n; ++l) {
		while (r == l || (r + 1) % n == l || dist(a[r], cross(a[l], p, a[r], a[(r + 1) % n])) > dist(a[r], a[(r + 1) % n]) + EPS) {
			point p1 = cross(a[l], p, a[r], a[(r + 1) % n]);
			ld d = dist(a[r], cross(a[l], p, a[r], a[(r + 1) % n]));
			r = (r + 1) % n;
		}
		point p1 = cross(a[l], p, a[r], a[(r + 1) % n]);
		ld d1 = dist(p, cross(a[l], p, a[r], a[(r + 1) % n]));
		ld d2 = dist(p, a[l]);
		if (d1 < d2)
			swap(d1, d2);
		res = min(res, d1 / d2);
	}
	return res;
}

vector<point> p;

const double MAXC = 1.1e5;

double x_func(double x) {
	point a = p[0], b = p[0] + vec(cos(x), sin(x));
	auto fi = cut(p, a, b);
	auto se = cut(p, b, a);
	return area(fi) - area(se);
}

double y_func(double x) {
	point a = p[1], b = p[1] + vec(cos(x), sin(x));
	auto fi = cut(p, a, b);
	auto se = cut(p, b, a);
	return area(fi) - area(se);
}

double find_coord(double (*func)(double), double l0, double r0) {
	double l = l0, r = r0;
	assert(func(l) < 0 && func(r) > 0);
	for (int it = 0; it < 100; ++it) {
		double m = (l + r) / 2;
		if (func(m) < 0) {
			l = m;
		} else {
			r = m;
		}
	}
	return (l + r) / 2;
}



signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);

	int n;
	cin >> n;
	p.resize(n);
	double x = 0, y = 0;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		x += p[i].x;
		y += p[i].y;
	}
	// double cx = find_coord(x_func, vec(p[0], p[n - 1]).ang(), vec(p[0], p[1]).ang());
	// double cy = find_coord(y_func, vec(p[1], p[0]).ang(), vec(p[1], p[2]).ang());
	// point center(cx, cy);
	// cout << sqrt(2) / 6 << endl;
	// cout << center << endl;
	cout << fixed << setprecision(20) << find_govno(p, point(x / n, y / n)) << endl;
	return 0;
}