#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


class trie
{
	struct node
	{
		array<int, 26> nxt{};
		int cnt = 0, subtree = 0;

		node()
		{
			fill(nxt.begin(), nxt.end(), -1);
		}
	};

	vector<node> mem;


	[[nodiscard]] pair<int, int> solve(int v, int k) const
	{
		if (v == -1)
			return {0, 0};

		vector<pair<int, int>> ch(26);

		for (int j = 0; j < ch.size(); j++)
			ch[j] = solve(mem[v].nxt[j], k);

		sort(ch.begin(), ch.end(), [](auto a, auto b)
		{
			return a.second < b.second;
		});

		int cnt = mem[v].cnt;
		int ans = 0;

		for (auto[dp, rem]: ch)
		{
			ans += dp;

			if (cnt + rem <= k)
				cnt += rem;
			else
				ans++;
		}

		return {ans, cnt};
	}

public:
	trie() : mem(1)
	{}


	void add_string(string_view sv)
	{
		int cur = 0;

		for (auto it: sv)
		{
			mem[cur].subtree++;

			auto j = it - 'a';

			if (auto &q = mem[cur].nxt[j]; q == -1)
			{
				q = mem.size();
				mem.emplace_back();
			}

			cur = mem[cur].nxt[j];
		}

		mem[cur].cnt++;
	}


	int operator()(int k) const
	{
		auto ans = solve(0, k);

		if (ans.second > 0)
			ans.first++;

		return ans.first;
	}
};


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, k;

	cin >> n >> k;

	trie tr;

	for (int i = 0; i < n; i++)
	{
		string tmp;

		cin >> tmp;

		tr.add_string(tmp);
	}

	cout << tr(k) << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
