#include <bits/stdc++.h>
using namespace std;

// #define constexpr(...) (__VA_ARGS__)  
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
// for matching the kactl notes
#define sz(x) ((int)x.size())
#define rep(i,a,b) for (int i = (int)(a); i < (int)(b); ++i) 
#define all(a) (a).begin(), (a).end()
#define print_op(...) ostream& operator<<(ostream& out, const __VA_ARGS__& u)
// DEBUGING TEMPLETE ////////////////////////////////////////////////////////////////////////{{{
// What? You wanted to see how this template works?  Check this out:
// https://quangloc99.github.io/2021/07/30/my-CP-debugging-template.html
#define db(val) "["#val" = "<<(val)<<"] "
#define CONCAT_(x, y) x##y
#define CONCAT(x, y) CONCAT_(x, y)
#ifdef LOCAL_DEBUG   
#   define clog cerr << setw(__db_level * 2) << setfill(' ') << "" << setw(0)
#   define DB() debug_block CONCAT(dbbl, __LINE__)
    int __db_level = 0;
    struct debug_block {
        debug_block() { clog << "{" << endl; ++__db_level; }
        ~debug_block() { --__db_level; clog << "}" << endl; }
    };
#else
#   define clog if (0) cerr
#   define DB(...)
#endif

template<class U, class V> print_op(pair<U, V>) {
    return out << "(" << u.first << ", " << u.second << ")";
}
template<class Con, class = decltype(begin(declval<Con>()))>
typename enable_if<!is_same<Con, string>::value, ostream&>::type
operator<<(ostream& out, const Con& con) { 
    out << "{";
    for (auto beg = con.begin(), it = beg; it != con.end(); ++it)
        out << (it == beg ? "" : ", ") << *it;
    return out << "}";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")"; 
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup); 
}
template<class ...U> print_op(tuple<U...>) {
    return print_tuple_utils<0, tuple<U...>>(out, u);
}
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////}}}

const int maxn = 101010;
const ll inf = (ll)1e15;
int n, m;
vector<pair<int, ll>> gr[maxn];

struct BFS {
    vector<int> trace;
    vector<int> dist;
    vector<ll> mx_edge;
    BFS(int start, ll factor = 1) {  // -1 for minimum
        trace.resize(n + 1, -1);
        dist.resize(n + 1, 0);
        mx_edge.resize(n + 1, -inf);
        queue<int> qu;
        qu.push(start);
        trace[start] = start;
        for (; qu.size(); qu.pop()) {
            int u = qu.front();
            for (auto [v, c]: gr[u]) {
                ll cur_mx = max(mx_edge[u], factor * c);
                if (trace[v] == -1) {
                    trace[v] = u;
                    dist[v] = dist[u] + 1;
                    mx_edge[v] = cur_mx;
                    qu.push(v);
                } else if (dist[u] + 1 == dist[v] and mx_edge[v] < cur_mx) {
                    trace[v] = u;
                    mx_edge[v] = cur_mx;
                }
            }
        }
    }
    
    vector<int> get_path(int u) {
        vector<int> res = {u};
        while (trace[u] != u) {
            u = trace[u];
            res.push_back(u);
        }
        return res;
    }
};

struct AnsT {
    ll range;
    int mid, start_fac;
};

bool operator<(const AnsT& u, const AnsT& v) {
    return u.range < v.range;
}

int main() {
#ifdef LOCAL
    freopen("main.inp", "r", stdin); 
    freopen("main.out", "w", stdout);  
    freopen(".log", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    cin >> n >> m;
    rep(i, 0, m) {
        int u, v, c;
        cin >> u >> v >> c;
        gr[u].emplace_back(v, c);
        gr[v].emplace_back(u, c);
    }
    
    AnsT ans{-inf, -1, 0};
    for (auto start_fac: {-1, 1}) {
        BFS from_start(1, start_fac);
        BFS from_end(n, -start_fac);
        if (from_start.dist[n] == 1) {
            cout << "1\n" << 1 << ' ' << n << endl;
            return 0;
        }
        rep(mid, 2, n) {
            auto u = from_start.mx_edge[mid];
            auto v = from_end.mx_edge[mid];
            clog << db(start_fac) << db(mid) << db(u) << db(v) << db(abs(u + v)) << endl;
            AnsT cur{abs(u + v), mid, start_fac};
            ans = max(ans, cur);
        }
    }
    
    BFS from_start(1, ans.start_fac);
    BFS from_end(n, -ans.start_fac);
    
    auto p1 = from_start.get_path(ans.mid);
    auto pn = from_end.get_path(ans.mid);
    reverse(all(p1));
    p1.pop_back();
    cout << from_start.dist[n] << '\n';
    for (auto x: p1) cout << x << ' ';
    for (auto x: pn) cout << x << ' ';
    
    return 0;
}

// vim: foldmethod=marker

