#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

const int N = (int) 3e5 + 100;

int b[N];
int w[N];

void solve() {
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) {
    b[i] = 0;
    w[i] = 0;
  }
  vector<tuple<int, int, char>> res;
  int sumW = 0, sumB = 0;
  for (int i = 0; i < n; i++) {
    cin >> w[i] >> b[i];
    sumW += w[i];
    sumB += b[i];
    if (n != 1 && w[i] + b[i] == 0) {
      cout << "No\n";
      return;
    }
  }
  if (sumW % 2 == 1 || sumB % 2 == 1 || sumW + sumB != 2 * (n - 1)) {
    cout << "No\n";
    return;
  }

  vector<int> order(n);
  iota(order.begin(), order.end(), 0);
  sort(order.begin(), order.end(), [&](int i, int j) {
    return w[i] + b[i] < w[j] + b[j];
  });

  vector<int> leaveW, leaveB;
  for (int v: order) {
    while (w[v] + b[v] > (v != order.back())) {
      bool found = false;
      if (w[v] > 0 && !leaveW.empty()) {
        int u = leaveW.back();
        res.emplace_back(u + 1, v + 1, 'W');
        leaveW.pop_back();
        w[v]--;
        found = true;
      }
      if (w[v] + b[v] > (v != order.back()) && b[v] > 0 && !leaveB.empty()) {
        int u = leaveB.back();
        res.emplace_back(u + 1, v + 1, 'B');
        leaveB.pop_back();
        b[v]--;
        found = true;
      }
      if (!found) {
        cout << "No\n";
        return;
      }
    }
    if (w[v] == 1) {
      leaveW.push_back(v);
    } else if (b[v] == 1) {
      leaveB.push_back(v);
    } else if (w[v] + b[v] != 0) {
      cout << "No\n";
      return;
    }
  }

  if (res.size() + 1 != n) {
    cout << "No\n";
    return;
  }

  cout << "Yes\n";
  for (auto[u, v, c]: res) {
    cout << u << " " << v << " " << c << "\n";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int test;
  cin >> test;
  while (test--) {
    solve();
  }

  return 0;
}
