#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <random>
 
#define ft first
#define sc second
#define pb push_back
#define int ll
#define len(v) (int)v.size()
 
using namespace std;
typedef long long ll;
typedef long double ld;


vector<vector<pair<int, int>>> g;
int inf = 1e9 + 100;

vector<int> dst(int st, int n) {
    vector<int> ans(n, inf);
    deque<int> q;
    q.pb(st);
    ans[st] = 0;
    while (!q.empty()) {
        auto cur = q.front();
        q.pop_front();
        for (auto x : g[cur]) {
            if (ans[x.ft] != inf) 
                continue;
            ans[x.ft] = ans[cur] + 1;
            q.pb(x.ft);
        }
    }
    return ans;
}


signed main() {
	#ifdef PC
	    freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    g = vector<vector<pair<int, int>>> (n);
    vector<int> max0(n, -inf);
    vector<int> maxn(n, -inf);
    vector<int> min0(n, inf);
    vector<int> minn(n, inf);

    vector<int> predMax0(n, -1);
    vector<int> predMin0(n, -1);
    vector<int> predMaxn(n, -1);
    vector<int> predMinn(n, -1);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        g[u].pb({v, c});
        g[v].pb({u, c});
    }

    auto dst0 = dst(0, n);
    auto dstn = dst(n - 1, n);
    if (dst0[n - 1] == 1) {
        cout << 1 << endl;
        cout << 1 << " " << n << endl;
        return 0;
    }
    vector<pair<int, int>> fs;
    for (int i = 1; i < n; i++) {
        fs.pb({dst0[i], i});
    }
    sort(fs.begin(), fs.end());
    for (auto [_, x] : fs) {
        for (auto [v, c] : g[x]) {
            if (dst0[v] + 1 != dst0[x])
                continue;
            if (min0[x] > min(min0[v], c)) {
                min0[x] = min(min0[v], c);
                predMin0[x] = v;
            }
            if (max0[x] < max(max0[v], c)) {
                max0[x] = max(max0[v], c);
                predMax0[x] = v;
            }
        }
    }

    fs.clear();
     for (int i = 0; i < n - 1; i++) {
        fs.pb({dstn[i], i});
    }
    sort(fs.begin(), fs.end());
    for (auto [_, x] : fs) {
        for (auto [v, c] : g[x]) {
            if (dstn[v] + 1 != dstn[x])
                continue;
            if (minn[x] > min(minn[v], c)) {
                minn[x] = min(minn[v], c);
                predMinn[x] = v;
            }
            if (maxn[x] < max(maxn[v], c)) {
                maxn[x] = max(maxn[v], c);
                predMaxn[x] = v;
            }
        }
    }
    maxn[n - 1] = minn[n - 1] = 0;
    min0[0] = max0[0] = 0;

    int maxd = -1;
    int ansv = 0;
    int type = 0;

    for (int i = 1; i < n - 1; i++) {
        if (dst0[i] + dstn[i] != dst0[n - 1]) 
            continue;
        if (maxd < max0[i] - minn[i]) {
            maxd = max0[i] - minn[i];
            ansv = i;
            type = 0;
        }
        if (maxd < maxn[i] - min0[i]) {
            maxd = maxn[i] - min0[i];
            ansv = i;
            type = 1;
        }
    }
    if (type == 0) {
        vector<int> p1;
        vector<int> p2;
        auto curv = ansv;
        while (curv != -1) {
            p1.pb(curv);
            curv = predMax0[curv];
        }
        curv = ansv;
        while (curv != -1) {
            p2.pb(curv);
            curv = predMinn[curv];
        }
        reverse(p1.begin(), p1.end());
        for (int i = 1; i < len(p2); i++) 
            p1.pb(p2[i]);
        cout << len(p1) - 1 << endl;
        for (auto x : p1) 
            cout << x + 1 << " ";
        return 0;
    } else {
        vector<int> p1;
        vector<int> p2;
        auto curv = ansv;
        while (curv != -1) {
            p1.pb(curv);
            curv = predMin0[curv];
        }
        curv = ansv;
        while (curv != -1) {
            p2.pb(curv);
            curv = predMaxn[curv];
        }
        reverse(p1.begin(), p1.end());
        for (int i = 1; i < len(p2); i++) 
            p1.pb(p2[i]);
        cout << len(p1) - 1 << endl;
        for (auto x : p1) 
            cout << x + 1 << " ";
        return 0;
    }
}	  