#include <iostream>
#include <cstdio>
#include <cassert>
#include <algorithm>
#include <fstream>
#include <vector>
#include <unordered_map>

using namespace std;

const int MAXN = 3e5 + 10;

struct Bor {
    Bor() {
        _last = 1;
        root = 0;
        is_terminal.resize(MAXN);
    }

    void add(const string &s) {
        int x = root;
        for (char c : s) {
            if (!gr[x].count(c))
                gr[x][c] = _last++;
            x = gr[x][c];
        }
        is_terminal[x] = true;
    }

    void print() {
        for (int i = 0; i < _last; i++) {
            for (pair <char, int> nxt : gr[i]) {
                cout << i << " -> " << nxt.second << " : " << nxt.first << endl;
            }
        }
    }

    int _last = 1;
    int root = 0;
    unordered_map <char, int> gr[MAXN];
    vector <int> is_terminal;
} bor;

int k;

int dp1[MAXN];
int dp2[MAXN];

void calc_dp(int x) {
    vector <int> dps;
    int sum = 0;
    for (pair <char, int> nxt : bor.gr[x]) {
        int v = nxt.second;
        calc_dp(v);
        sum += dp1[v];
        dps.push_back(dp2[v]);
    }
    sort(dps.begin(), dps.end());
    int kek = k;
    if (bor.is_terminal[x])
        kek = k - 1;
    int mem = 0, i;
    for (i = 0; i < (int)dps.size(); i++) {
        if (mem > kek) {
            break;
        }
        mem += dps[i];
    }
    if (mem > kek) {
        mem -= dps[i - 1];
        i -= 1;
    }
    dp1[x] = sum + (int)dps.size() - i;
    dp2[x] = mem + (k - kek);
//    cout << "dp[" << x << "] = " << dp1[x] << " " << dp2[x] << endl;
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    int n; cin >> n >> k;
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        bor.add(s);
    }

//    bor.print();

    calc_dp(bor.root);

    cout << dp1[bor.root] + 1 << endl;

    return 0;
}
