#pragma GCC optimize("Ofast")

#include <assert.h>

#include <iostream>
#include <chrono>
#include <cmath>
#include <complex>
#include <memory.h>
#include <random>
#include<algorithm>
#include <iomanip>
#include <map>
#include <set>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

vector<int> xc;
vector<int> yc;
vector<int> xyc;

const int N = 9;


long long f(int x, int y) {
    long long res = 0;
    long long stepx = 1;
    long long stepy = 1;
    for (int i = 0; i < xc.size(); i++) {
        res += xc[i] * stepx;
        res += yc[i] * stepy;
        res += xyc[i] * stepx * stepy;
        stepx *= x;
        stepy *= y;
    }
    return res;
}

map<tuple<bool, bool, bool>, pair<vector<int>, vector<int>>> ans;

tuple<bool, bool, bool> check() {
    int hasmin = 0;
    for (int x = -9; x < 10; x++) {
        for (int y = -9; y < 10; y++) {
            if (f(x, y) < f(x - 1, y) && f(x, y) < f(x + 1, y) && f(x, y) < f(x, y - 1) && f(x, y) < f(x, y + 1)) {
                hasmin++;
            }
        }
    }
    int hasmax = 0;
    for (int x = -9; x < 10; x++) {
        for (int y = -9; y < 10; y++) {
            if (f(x, y) > f(x - 1, y) && f(x, y) > f(x + 1, y) && f(x, y) > f(x, y - 1) && f(x, y) > f(x, y + 1)) {
                hasmax++;
            }
        }
    }
    bool hasplato = 0;
    for (int x = -9; x <= 10; x++) {
        for (int y = -10; y <= 10; y++) {
            if (f(x, y) == f(x - 1, y)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x < 10; x++) {
        for (int y = -10; y <= 10; y++) {
            if (f(x, y) == f(x + 1, y)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x <= 10; x++) {
        for (int y = -9; y <= 10; y++) {
            if (f(x, y) == f(x, y - 1)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x <= 10; x++) {
        for (int y = -10; y < 10; y++) {
            if (f(x, y) == f(x, y + 1)) {
                hasplato = true;
                break;
            }
        }
    }
    return {hasmax >= 2, hasmin >= 2, hasplato};
}

void brute(int left) {
    auto res = check();
    if (!ans.count(res)) ans[res] = {xc, yc};
    if (res == make_tuple(true, true, true)) {
        {
            auto p = res;
            auto q = make_pair(xc, yc);
            cout << "{\"" << get<0>(p) << get<1>(p) << get<2>(p) << "\" , \"";
            for (int i = 0; i < q.first.size(); i++) {
                cout << q.first[i] << " ";
                cout << "x " << i << " ^ * ";
            }
            for (int i = 0; i < q.second.size(); i++) {
                cout << q.second[i] << " ";
                cout << "y " << i << " ^ * ";
            }
            for (int i = 0; i < xyc.size(); i++) {
                cout << xyc[i] << " ";
                cout << "x y * " << i << " ^ * ";
            }
            for (int i = 0; i < q.first.size() + q.second.size() + xyc.size() - 1; i++) {
                cout << "+ ";
            }
            cout << "\"},\n";
        }
        exit(0);
    }
    if (left == 0) {
        return;
    }
    vector<int> ar, br;
    for (int a = -N; a <= N; a++) ar.push_back(a);
    for (int a = -N; a <= N; a++) br.push_back(a);
    random_shuffle(ar.begin(), ar.end());
    random_shuffle(br.begin(), br.end());
    for (int a : ar) {
        for (int b  : br) {
            for (int c : br) {
                xc.push_back(a);
                yc.push_back(b);
                xyc.push_back(c);
                brute(left - 1);
                xyc.pop_back();
                xc.pop_back();
                yc.pop_back();
            }
        }
    }
}

void Solve() {
    // brute(5);
    map<string, string> ans = {
            {"000", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * -1 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * -5 y 3 ^ * 5 y 4 ^ * + + + + + + + + + "},
            {"001", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * -6 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * -5 y 3 ^ * -5 y 4 ^ * + + + + + + + + + "},
            {"010", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * 4 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * 6 y 3 ^ * 2 y 4 ^ * + + + + + + + + + "},
            {"011", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * 7 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * 1 y 3 ^ * 1 y 4 ^ * + + + + + + + + + "},
            {"100", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * -1 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * -5 y 3 ^ * -3 y 4 ^ * + + + + + + + + + "},
            {"101", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -7 x 3 ^ * -1 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * 6 y 3 ^ * -1 y 4 ^ * + + + + + + + + + "},
            {"110", "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * -1 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * 6 y 3 ^ * 2 y 4 ^ * + + + + + + + + + "},
            {"111" , "5 x 0 ^ * 5 x 1 ^ * 3 x 2 ^ * -2 x 3 ^ * -9 x 4 ^ * 4 y 0 ^ * -6 y 1 ^ * -6 y 2 ^ * -5 y 3 ^ * -8 y 4 ^ * 4 x y * 0 ^ * -6 x y * 1 ^ * -6 x y * 2 ^ * -7 x y * 3 ^ * 2 x y * 4 ^ * + + + + + + + + + + + + + + "},
    };
    string first, second, third;
    getline(cin, first);
    getline(cin, second);
    getline(cin, third);
    if (first.back() == 'o') first = "0";
    else first = "1";
    if (second.back() == 'o') second = "0";
    else second = "1";
    if (third.back() == 'o') third = "0";
    else third = "1";
    // cout << first + second + third << endl;
    cout << ans[first + second + third];
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    Solve();
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}