﻿#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

bool isLeaf(int v, map <char, vi>& cnt) {
    return (cnt['W'][v] == 1 && cnt['B'][v] == 0) || (cnt['W'][v] == 0 && cnt['B'][v] == 1);
}

void Solve() {
    int n;
    cin >> n;
    vi w(n), b(n);
    vi leaf;
    int sum = 0;
    map <char, vi> big, low;
    map <char, vi> cnt;
    cnt['W'].resize(n);
    cnt['B'].resize(n);
    forn(i, n) {
        cin >> w[i] >> b[i];
        sum += w[i] + b[i];
        cnt['W'][i] = w[i];
        cnt['B'][i] = b[i];
        if (isLeaf(i, cnt)) {
            leaf.eb(i);
        } else {
            if (cnt['W'][i] != 0) {
                big['W'].eb(i);
            }
            if (cnt['B'][i] != 0) {
                big['B'].eb(i);
            }
        }
        low['W'].eb(i);
        low['B'].eb(i);
    }
    if (sum != 2 * n - 2) {
        cout << "No\n";
        return;
    }
    vi wasw = w, wasb = b;
    vector <tuple <int, int, bool>> edges;
    while (!leaf.empty()) {
        int v = leaf.back();
        leaf.pop_back();
        if (cnt['W'][v] == 0 && cnt['B'][v] == 0) {
            continue;
        }
        char need = 'B';
        if (cnt['B'][v] == 0) {
            need = 'W';
        }
        int u = -1;
        while(!big[need].empty()) {
            int x = big[need].back();
            if (isLeaf(x, cnt) || cnt[need][x] == 0) {
                big[need].pop_back();
                continue;
            } else {
                u = x;
                break;
            }
        }
        if (u == -1) {
            while (!low[need].empty()) {
                int x = low[need].back();
                if (x == v || cnt[need][x] == 0) {
                    low[need].pop_back();
                    continue;
                } else {
                    u = x;
                    break;
                }
            }
        }
        if (u == -1) {
            cout << "No\n";
            return;
        }
        cnt[need][u]--;
        cnt[need][v]--;
        if (need == 'B') {
            edges.eb(v, u, 1);
        } else {
            edges.eb(v, u, 0);
        }
        if (isLeaf(u, cnt)) {
            leaf.eb(u);
        }
    }
    vi curw(n, 0), curb(n, 0);
    for (auto [x, y, z] : edges) {
        if (z) {
            curb[x]++;
            curb[y]++;
        } else {
            curw[x]++;
            curw[y]++;
        }
    }
    if (curw != wasw || curb != wasb) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (auto [x, y, z] : edges) {
            cout << x + 1 << ' ' << y + 1 << ' ';
            if (z) {
                cout << "B\n";
            } else {
                cout << "W\n";
            }
        }
    }
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        //        cout << "Case #" << i << ": ";
        Solve();
    }
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}