#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iomanip>
#include <map>
#include <complex>
#include <queue>
#include <cassert>
#include <chrono>
#include <random>
#include <climits>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define debug(x) cout << #x << " = " << x << endl
#define all(a) begin(a), end(a)
#define sqr(x) ((x) * (x))
#define int long long

using namespace std;

template<class Iter> 
void print(Iter l, Iter r) {
    cout << "[";
    for (auto it = l; it != r; ++it) {
        if (it != l) {
            cout << ", ";   
        }
        cout << *it;
    }
    cout << "]" << endl;
}

template<class C, class F> 
ostream& operator<<(ostream &out, pair<C, F> p) {
    return out << "(" << p.first << ", " << p.second << ")";
}

using ll = long long;

mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); 

    int n, m, c;
    cin >> n >> m >> c;
    int res = 1e18;

    int resA=-1, resB=-1;
    forn(i, 1e6) {
        if(n < 0) break;
        int k = n / c;

        int w1 = c * k;
        int w2 = c * (k + 1);

        if (abs(w1-n) < res) {
            res=abs(w1-n);
            resA = i;
            resB = k;
        }

        if (abs(w2-n) < res) {
            res=abs(w2-n);
            resA = i;
            resB = k + 1;
        }

        n -= m;
    }

    cout << resA << " " << resB << "\n";

    return 0;
}