﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
using namespace std;

#define X real()
#define Y imag()
#define endl '\n'
//#define int long long
#define all(X) (X).begin(), (X).end()
#define rall(X) (X).rbegin(), (X).rend()
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

const int INF = 1e9 + 10;

struct node
{
	vector<pair<int, int>> edges;
};

void DJSMIN(int start, vector<node> &d, vector<pair<int, int>> &dist, vector<int> &links)
{
	priority_queue<pair<int, pair<int, int>>> que;

	dist[start] = { 0, INF };
	que.push(make_pair(start, dist[start]));

	while (!que.empty()) {
		pair<int, pair<int, int>> top = que.top();
		que.pop();
		if (dist[top.first] != top.second)
			continue;
		int first = top.first;
		for (auto j : d[first].edges) {
			if (make_pair(dist[first].first + 1, min(dist[first].second, j.second)) < dist[j.first]) {
				dist[j.first] = make_pair(dist[first].first + 1, min(dist[first].second, j.second));
				que.push(make_pair(j.first, dist[j.first]));
				links[j.first] = first;
			}
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int n, m;
	cin >> n >> m;

	vector<node> d(n);
	for (int i = 0; i < m; i++)
	{
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		d[u].edges.push_back(make_pair(v, c));
		d[v].edges.push_back(make_pair(u, c));
	}

	vector<int> link1MIN(n), linknMIN(n);
	vector<pair<int, int>> dist1MIN(n, { INF, INF }), distnMIN(n, { INF, INF });
	DJSMIN(0, d, dist1MIN, link1MIN);
	DJSMIN(n - 1, d, distnMIN, linknMIN);

	int delt = INT_MIN, a = -1, b = -1;
	int mindist = dist1MIN[n - 1].first;

	for (int i = 0; i < n; i++) {
		for (auto &j : d[i].edges) {
			if (dist1MIN[i].first + distnMIN[j.first].first + 1 == mindist) {
				int maxim = j.second;
				int minim = min(dist1MIN[i].second, distnMIN[j.first].second);
				if (delt < maxim - minim) {
					delt = maxim - minim;
					a = i; b = j.first;
				}
			}
		}
	}

	vector<int> left, right;
	for (int i = a; i != 0; i = link1MIN[i])
		left.push_back(i);
	left.push_back(0);
	reverse(all(left));
	for (int i = b; i != n - 1; i = linknMIN[i])
		right.push_back(i);
	right.push_back(n - 1);

	cout << mindist << endl;
	for (auto &i : left)
		cout << i + 1 << " ";
	for (auto &i : right)
		cout << i + 1 << " ";
	return 0;
}