#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iomanip>
#include <map>
#include <complex>
#include <queue>
#include <cassert>
#include <chrono>
#include <random>
#include <climits>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define debug(x) cout << #x << " = " << x << endl
#define all(a) begin(a), end(a)
#define sqr(x) ((x) * (x))
//#define int long long

using namespace std;

template<class Iter> 
void print(Iter l, Iter r) {
    cout << "[";
    for (auto it = l; it != r; ++it) {
        if (it != l) {
            cout << ", ";   
        }
        cout << *it;
    }
    cout << "]" << endl;
}

template<class C, class F> 
ostream& operator<<(ostream &out, pair<C, F> p) {
    return out << "(" << p.first << ", " << p.second << ")";
}

using ll = long long;

mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

using pi = pair<int, int>;

void solve() {
    int n;
    cin >> n;

    vector<pair<pair<int, int>, int>> ans;
    
    vector<int> deg(n);
    vector<vector<int>> cols(n, vector<int>(2));

    set<pi> st;
    set<pair<pi, int>> have[2];

    forn(i, n) {
        forn(j, 2) {
            cin >> cols[i][j];
            deg[i] += cols[i][j];
        }
        st.insert({deg[i], i});

        forn(j, 2) {
            if (cols[i][j]) {
                have[j].insert({{cols[i][j], deg[i]}, i});
            }
        }
    }

    while (st.size()) {
        auto [_, u] = *st.begin();
        st.erase(st.begin());

      //  debug(u);

        forn(j, 2) {
            if (cols[u][j] == 0) continue;
            have[j].erase({{cols[u][j], 1}, u});

            if (have[j].empty()) {
                cout << "No\n";
                return;
            }

            auto rb = *have[j].rbegin();
            have[j].erase(rb);
            int node = rb.second;

            ans.push_back({{u, node}, j});

            if (cols[node][1-j] > 0) {
                have[1-j].erase({{cols[node][1-j], deg[node]}, node});
            }
            st.erase({deg[node], node});

            deg[node]--;

            // debug(node);
            // debug(deg[node]);

            cols[node][j]--;

            if (deg[node] > 0) {
                st.insert({deg[node], node});
            }
            forn(k, 2) {
                if (cols[node][k] > 0) {
                    have[k].insert({{cols[node][k], deg[node]}, node});
                }
            }
        }
    }

    cout << "Yes\n";
    for (auto i : ans) {
        cout << i.first.first + 1 << " " << i.first.second + 1 << " " << "WB"[i.second] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); 

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}