#define FS first
#define SC second

#include <random>
#include <iostream>
#include <iomanip>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>

using namespace std;

mt19937 gen(339264);

const int MAXN = 1050;
int d[MAXN][MAXN];

typedef pair<int, int> pii;

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    uniform_int_distribution<int> rand(0,100500);

    int t;
    cin >> t;

    for (int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;

        if (n == 1) {
            int w, b;
            cin >> w >> b;
            if (w == 0 && b == 0) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }

            continue;
        }

        set<pair<pii, int>> white_first;
        set<pair<pii, int>> black_first;


        bool poss = true;
        for (int i = 0; i < n; i++) {
            int w, b;
            cin >> w >> b;
            if (w == 0 && b == 0) {
                poss = false;
            }
            white_first.insert({{w, b}, i});
            black_first.insert({{b, w}, i});
        }

        if (!poss) {
            cout << "No\n";
            continue;
        }

        vector<pair<pii, int>> edges;
        while (white_first.size() > 1) {
            // cerr << "WHITE FIRST" << endl;
            // for (auto p: white_first) {
            //     cerr << p.SC << ": " << p.FS.FS << " " << p.FS.SC << endl;
            // }
            // cerr << endl;

            // cerr << "BLACK FIRST" << endl;
            // for (auto p: black_first) {
            //     cerr << p.SC << ": " << p.FS.FS << " " << p.FS.SC << endl;
            // }
            // cerr << endl;

            
            if (white_first.begin()->first == pii(0, 1)) {
                auto p = *white_first.begin();
                auto q = *black_first.rbegin();
                white_first.erase(p);
                black_first.erase({{p.FS.SC, p.FS.FS}, p.SC});
                black_first.erase(q);
                white_first.erase({{q.FS.SC, q.FS.FS}, q.SC});

                edges.push_back({{p.SC, q.SC}, 1});
                q.FS.FS--;
                if (q.FS.FS > 0 || q.FS.SC > 0) {
                    black_first.insert(q);
                    white_first.insert({{q.FS.SC, q.FS.FS}, q.SC});
                }

            } else if (black_first.begin()->first == pii(0, 1)) {
                auto p = *black_first.begin();
                auto q = *white_first.rbegin();
                black_first.erase(p);
                white_first.erase({{p.FS.SC, p.FS.FS}, p.SC});
                white_first.erase(q);
                black_first.erase({{q.FS.SC, q.FS.FS}, q.SC});

                edges.push_back({{p.SC, q.SC}, 0});
                q.FS.FS--;
                if (q.FS.FS > 0 || q.FS.SC > 0) {
                    white_first.insert(q);
                    black_first.insert({{q.FS.SC, q.FS.FS}, q.SC});
                }
            } else {
                poss = false;
                break;
            }
        }

        if (white_first.size() == 1 || edges.size() != n - 1) {
            poss = false;
        }

        // cerr << "WHITE FIRST" << endl;
        // for (auto p: white_first) {
        //     cerr << p.SC << ": " << p.FS.FS << " " << p.FS.SC << endl;
        // }
        // cerr << endl;

        // cerr << "BLACK FIRST" << endl;
        // for (auto p: black_first) {
        //     cerr << p.SC << ": " << p.FS.FS << " " << p.FS.SC << endl;
        // }
        // cerr << endl;

        if (poss) {
            cout << "Yes\n";
            for (auto p: edges) {
                cout << p.FS.FS + 1 << " " << p.FS.SC + 1 << " " << (p.SC == 1 ? "B" : "W") << endl;
            }
        } else {
            cout << "No\n";
        }

    }

    return 0;
}
