//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O4")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ld = long double;
using ui = unsigned int;
using ull = unsigned long long;
using pp = pair<int, int>;
using tt = tuple<int, int, int>;

const int inf = (int) 1e9 + 1;
const int mod = 998244353;
//const ll inf = (ll) 1e18;


#define umap unordered_map
#define uset unordered_set
#define Power ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define pb push_back


template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

template<typename T>
T lcm(T a, T b) {
    return a * b / gcd(a, b);
}

mt19937_64 mers((random_device()) ());

struct Node {
    ll l;
    ll r;
    int y;
    Node* left;
    Node* right;

    Node(ll l, ll r) : l(l), r(r), y(mers()) {
        left = right = nullptr;
    }
};

using Tree = Node*;

void split(Tree t, Tree& l, Tree& r, ll key) {
    if (!t) {
        l = r = nullptr;
        return;
    }
    if (t->l <= key) {
        split(t->right, t->right, r, key);
        l = t;
    } else {
        split(t->left, l, t->left, key);
        r = t;
    }
}

void merge(Tree& t, Tree l, Tree r) {
    if (!l || !r) {
        t = l ? l : r;
        return;
    }
    if (l->y > r->y) {
        merge(l->right, l->right, r);
        t = l;
    } else {
        merge(r->left, l, r->left);
        t = r;
    }
}

ll ans = 0;
ll ans_timezone = 0;
ll cur_timezone = 0;

void add(Tree& t, ll l, ll r) {
    if (r - l + 1 > ans) {
        ans = r - l + 1;
        ans_timezone = cur_timezone;
    }
    Tree node = new Node(l, r);
    Tree left, right;
    split(t, left, right, l);
    merge(left, left, node);
    merge(t, left, right);
}

std::pair<ll, ll> extract(Tree& t, ll value) {
    if (!t)
        return {-1, -1};
    if (t->l <= value && value <= t->r) {
        ll l = t->l;
        ll r = t->r;
        merge(t, t->left, t->right);
        return {l, r};
    } else if (t->r < value) {
        return extract(t->right, value);
    } else {
        return extract(t->left, value);
    }
}

void solve() {

    ans = 0;
    cur_timezone = 0;
    ans_timezone = 0;

    ll n, m;
    cin >> n >> m;
    std::vector<ll> a(n);
    std::vector<ll> d(n);
    std::vector<int> ord(n);
    std::map<ll, int> cnt;
    Tree t = nullptr;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ll x = a[i] / m;
        d[i] = (x + 1) * m - a[i];
        ord[i] = i;
        a[i] = x;
        cnt[a[i]]++;
    }
    sort(all(ord), [&](int i, int j) {
        return d[i] < d[j];
    });

    ll prev = -1;
    ll cur_left = -1;
    for (auto &[k, v] : cnt) {
        if (prev == -1) {
            cur_left = k;
        } else {
            if (prev + 1 != k) {
                add(t, cur_left, prev);
                cur_left = k;
            }
        }
        prev = k;
    }
    add(t, cur_left, prev);

    auto move = [&](int i) {
        cnt[a[i]]--;
        cnt[a[i] + 1]++;
        if (cnt[a[i]] == 0) {
            auto [l, r] = extract(t, a[i]);
            if (l != r) {
                if (l == a[i]) {
                    add(t, l + 1, r);
                } else if (r == a[i]) {
                    add(t, l, r - 1);
                    if (cnt[a[i] + 1] == 1) {
                        if (cnt[a[i] + 2] == 0) {
                            add(t, a[i] + 1, a[i] + 1);
                        } else {
                            auto [l2, r2] = extract(t, a[i] + 2);
                            add(t, l2 - 1, r2);
                        }
                    }
                } else {
                    add(t, l, a[i] - 1);
                    add(t, a[i] + 1, r);
                }
            } else {
                if (cnt[a[i] + 1] == 1) {
                    if (cnt[a[i] + 2] == 0) {
                        add(t, a[i] + 1, a[i] + 1);
                    } else {
                        auto [l2, r2] = extract(t, a[i] + 2);
                        add(t, l2 - 1, r2);
                    }
                }
            }
        } else {
            if (cnt[a[i] + 1] == 1) {
                auto [l, r] = extract(t, a[i]);
                if (cnt[a[i] + 2] == 0) {
                    add(t, l, r + 1);
                } else {
                    auto [l2, r2] = extract(t, a[i] + 2);
                    add(t, l, r2);
                }
            }
        }
    };

    int i = 0;
    while (i < n) {
        if (d[ord[i]] >= m)
            break;
        cur_timezone = d[ord[i]];
        move(ord[i]);
        while (i + 1 < n && d[ord[i]] == d[ord[i + 1]]) {
            i++;
            move(ord[i]);
        }
        i++;
    }

    std::cout << ans << " " << ans_timezone << "\n";

}


signed main() {

    Power;


#ifdef _DEBUG
    (void) freopen("input.txt", "r", stdin);
    (void) freopen("output.txt", "w", stdout);
#else
    //  (void)freopen("lwdb.in", "r", stdin);
    //  (void)freopen("lwdb.out", "w", stdout);
#endif

    int queue_counter = 1;
    cin >> queue_counter;
    while (queue_counter--) {
        solve();
    }

    return 0;
}