#include <bits/stdc++.h>

using namespace std;

#define len(x) (int)(x).size()
#define all(x) x.begin(), x.end()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    cout.setf(ios::fixed), cout.precision(20);
}

constexpr int mod = 1000000007;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<array<int, 3>>> g(n);
//                      to   c  valid
    map<int, int> rho;
    for (int i = 0; i < m; i++) {
        int from, to, c;
        cin >> from >> to >> c;
        from--;
        to--;
        g[from].push_back({to, c, 1});
        g[to].push_back({from, c, 1});
    }

    if (n == 2) {
        cout << "1\n1 2";
        return;
    }
    int DIST = INT_MAX;


    {
        queue<array<int, 2>> q;
        vector<int> used(n, false);
        q.push({0, 0});
        used[0] = true;

        while (!q.empty()) {
            auto p = q.front();
            q.pop();
            int v, dist;
            v = p[0];
            dist = p[1];
            used[v] = true;
            rho[v] = dist;
            if (v == n - 1) {
                DIST = dist;
                continue;
            }
            for (auto &x: g[v]) {
                if (!used[x[0]]) {
                    q.push({x[0], dist + 1});
                    used[x[0]] = true;
                }
            }
        }
    }

    {
        queue<array<int, 2>> q;
        q.push({n - 1, DIST});
        while (!q.empty()) {
            auto p = q.front();
            q.pop();
            int v, dist;
            v = p[0];
            dist = p[1];
            for (auto &x: g[v]) {
                int rhoo = rho[x[0]];
                if (rhoo == dist - 1) {
                    q.push({x[0], rhoo});
                } else if (rhoo != dist + 1) {
                    x[2] = 0;
                }
            }
        }
    }

    vector<vector<array<int, 2>>> new_g(n);
    for (int i = 0; i < n; i++) {
        for (auto &x: g[i]) {
            if (x[2]) {
                new_g[i].push_back({x[0], x[1]});
            }
        }
    }


    map<int, array<int, 2> *> mxAndCntFromStart;
    map<int, array<int, 2> *> mxAndCntFromEnd;
    for (int i = 0; i < n; i++) {
        mxAndCntFromEnd[i] = new array<int, 2>{-1, -1};
        mxAndCntFromStart[i] = new array<int, 2>{-1, -1};
    }
//                 mx   cnt
    {
        queue<array<int, 3>> q;
        vector<int> used(n, false);
        q.push({0, -1, 1});
        while (!q.empty()) {
            int v, mx, cnt;
            auto p = q.front();
            q.pop();
            v = p[0];
            mx = p[1];
            cnt = p[2];
            used[v] = true;
            if ((*(mxAndCntFromStart[v]))[0] == mx) {
                (*mxAndCntFromStart[v])[1] += cnt;
            } else if ((*mxAndCntFromStart[v])[0] < mx)
                mxAndCntFromStart[v] = new array<int, 2>{mx, cnt};
            for (auto &x: new_g[v]) {
                if (used[x[0]]) continue;
                if (x[1] > mx) {
                    q.push({x[0], x[1], 1});
                }
                if (x[1] == mx) {
                    q.push({x[0], mx, cnt + 1});
                }
                if (x[1] < mx) {
                    q.push({x[0], mx, cnt});
                }
            }
        }

        for (auto &x: used) x = false;
        q.push({n - 1, -1, 0});

        while (!q.empty()) {
            int v, mx, cnt;
            auto p = q.front();
            q.pop();
            v = p[0];
            mx = p[1];
            cnt = p[2];
            used[v] = true;
            if ((*mxAndCntFromEnd[v])[0] == mx) {
                (*mxAndCntFromEnd[v])[1] += cnt;
            } else if ((*mxAndCntFromEnd[v])[0] < mx)
                mxAndCntFromEnd[v] = new array<int, 2>{mx, cnt};
            for (auto &x: new_g[v]) {
                if (used[x[0]]) continue;
                if (x[1] > mx) {
                    q.push({x[0], x[1], 1});
                }
                if (x[1] == mx) {
                    q.push({x[0], mx, cnt + 1});
                }
                if (x[1] < mx) {
                    q.push({x[0], mx, cnt});
                }
            }
        }
    }

    set<array<int, 3>> q;
    for (int i = 0; i < n; i++) {
        for (auto &x: new_g[i]) {
            if (rho[x[0]] > rho[i])
                q.insert({x[1], i, x[0]});
            else q.insert({x[1], x[0], i});
        }
    }

    int Res = -1;
    int From = -1;
    int To = -1;
    int LeftW = -1;
    int RightW = -1;

    for (auto &x: q) {
        int curMin = x[0];
        int from = x[1];
        int to = x[2];
        auto l = *mxAndCntFromStart[from];
        auto r = *mxAndCntFromEnd[to];
        int curMax = curMin;

        bool usingLeft = true;
        if (l[1] != 0) {
            curMax = max(curMax, l[0]);
        } else if (r[1] != 0) {
            curMax = max(curMax, r[0]);
            if (curMax == r[0]) {
                usingLeft = false;
            }
        } else continue;
        if (Res < curMax - curMin) {
            Res = curMax - curMin;
            From = from;
            To = to;
            if (usingLeft) {
                LeftW = l[0];
                RightW = -1;
            } else {
                RightW = r[0];
                LeftW = -1;
            }
        }
        Res = max(Res, curMax - curMin);
        l = *mxAndCntFromStart[to];
        r = *mxAndCntFromEnd[from];
        if (l[0] == curMin) {
            l[1]--;
        }
        if (r[0] == curMin) {
            r[1]--;
        }
    }
    cout << DIST << "\n";

    auto findEdge = [&](int from, int targetW, int diff) {
        queue<int> q;
        q.push(from);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto &x: new_g[v]) {
                if (rho[v] - rho[x[0]] == diff) {
                    if (x[1] == targetW) {
                        if (rho[v] < rho[x[0]])
                            return array<int, 2>{v, x[0]};
                        else return array<int, 2>{x[0], v};
                    }
                    q.push(x[0]);
                }
            }
        }
        assert(false);
    };

    vector<int> path;

    auto printAnyPath = [&](int from, int to) {

        vector<vector<int>> GG(n);
        queue<int> q;
        q.push(to);

        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto &x: new_g[v]) {
                if (rho[x[0]] == rho[v] - 1)
                    GG[v].push_back(x[0]), GG[x[0]].push_back(v);
            }
        }
        int cur = from;
        while(cur != to) {
            path.push_back(cur);
            cur = GG[cur][0];
        }
    };

    if (LeftW != -1) {
        auto e = findEdge(From, LeftW, 1);
        printAnyPath(0, e[0]);
        printAnyPath(e[0], e[1]);
        printAnyPath(e[1], From);
        printAnyPath(From, To);
        printAnyPath(To, n - 1);
    } else if (RightW != -1) {
        auto e = findEdge(To, RightW, -1);
        printAnyPath(0, From);
        printAnyPath(From, To);
        printAnyPath(To, e[0]);
        printAnyPath(e[0], e[1]);
        printAnyPath(e[1], n - 1);
    } else
        assert(false);
    for (auto &x: path) cout << x + 1 << " ";
    cout << n;
}

int main() {
#ifdef SIGUSR1
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    fastio();

    int cases = 1;
//    cin >> cases;
    for (int case_i = 1; case_i <= cases; ++case_i) {
        solve();
    }

    return 0;
}
