#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void calc_data(vector<pair<pair<pair<int, int>, int>, int>> &tree, const vector<int> &vert_in_sub, int p, int ind) {
    if (ind >= p) {
        int v = tree[ind].second;
        if (v > 0) {
            tree[ind] = {{{1, 1}, 1}, v};
        } else {
            tree[ind] = {{{0, 0}, 0}, v};
        }
    } else {
        auto left = tree[2 * ind];
        auto right = tree[2 * ind + 1];
        int pref;
        if (left.first.first.first == vert_in_sub[2 * ind]) {
            pref = left.first.first.first + right.first.first.first;
        } else {
            pref = left.first.first.first;
        }
        int suf;
        if (right.first.first.second == vert_in_sub[2 * ind + 1]) {
            suf = right.first.first.second + left.first.first.second;
        } else {
            suf = right.first.first.second;
        }
        int mx = max(left.first.first.second + right.first.first.first, max(left.first.second, right.first.second));
        int v = left.second + right.second;
        tree[ind] = {{{pref, suf}, mx}, v};
    }
}

void incr(vector<pair<pair<pair<int, int>, int>, int>> &tree, const vector<int> &vert_in_sub, int p, int ind) {
    int now = p + ind;
    tree[now].second++;
    while (now > 0) {
        calc_data(tree, vert_in_sub, p, now);
        now >>= 1;
    }
}

void decr(vector<pair<pair<pair<int, int>, int>, int>> &tree, const vector<int> &vert_in_sub, int p, int ind) {
    int now = p + ind;
    tree[now].second--;
    while (now > 0) {
        calc_data(tree, vert_in_sub, p, now);
        now >>= 1;
    }
}

pair<int, int> solve_subtask(vector<int> &a, int m) {
    int n = a.size();
    vector<pair<int, int>> available_answers;
    for (int j = 0; j < n; ++j) {
        int elem = a[j];
        if (elem % m != 0) {
            int day = elem / m;
            int shift = (day + 1) * m - elem;
            available_answers.push_back({shift, day});
        }
    }
    sort(available_answers.begin(), available_answers.end());
    int ans_d = 0;
    int day_cnt = a[n - 1] / m + 2;
    int p = 1;
    while (p < day_cnt) {
        p <<= 1;
    }
    vector<int> vert_in_sub(2 * p);
    for (int i = 2 * p - 1; i >= 1; --i) {
        if (i >= p) {
            vert_in_sub[i] = 1;
        } else {
            vert_in_sub[i] = vert_in_sub[2 * i] + vert_in_sub[2 * i + 1];
        }
    }
    vector<pair<pair<pair<int, int>, int>, int>> tree(2 * p);
    for (int i = 0; i < n; ++i) {
        incr(tree, vert_in_sub, p, a[i] / m);
    }
    int ans = tree[1].first.second;
    for (int i = 0; i < available_answers.size(); ++i) {
        decr(tree, vert_in_sub, p, available_answers[i].second);
        incr(tree, vert_in_sub, p, available_answers[i].second + 1);
        if (i == available_answers.size() - 1 || available_answers[i].first != available_answers[i + 1].first) {
            if (ans < tree[1].first.second) {
                ans = tree[1].first.second;
                ans_d = available_answers[i].first;
            }
        }
    }
    return {ans, ans_d};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        for (int j = 0; j < n; ++j) {
            cin >> a[j];
        }
        vector<vector<int>> subtasks;
        for (int j = 0; j < n; ++j) {
            if (subtasks.empty() || a[j] - subtasks.back().back() > 2 * m) {
                vector<int> subtask;
                subtask.push_back(a[j]);
                subtasks.push_back(subtask);
            } else {
                subtasks.back().push_back(a[j]);
            }
        }
        for (int j = 0; j < subtasks.size(); ++j) {
            int start_time = subtasks[j].front() / m * m;
            for (int k = 0; k < subtasks[j].size(); ++k) {
                subtasks[j][k] = subtasks[j][k] - start_time;
            }
        }
        for (auto &subtask : subtasks) {
            auto p = solve_subtask(subtask, m);
            cout << p.first << " " << p.second << endl;
        }
    }
    return 0;
}
