#include <bits/stdc++.h>

using namespace std;

struct node {
    int w;
    vector<int> go;

    node() : w(0), go(30, -1) {}
};

struct bor {
    vector<node> nodes;

    bor() : nodes(1, node()) {}

    void add_str(string &s) {
        int cur = 0;
        for (char c : s) {
            if (nodes[cur].go[c - 'a'] != -1) {
                cur = nodes[cur].go[c - 'a'];
            } else {
                nodes.emplace_back();
                nodes[cur].go[c - 'a'] = (int)nodes.size() - 1;
                cur = (int)nodes.size() - 1;
            }
        }
        nodes[cur].w++;
    }

    void dfs(int i, vector<pair<int, int>> &sizes, vector<int> &parent) {
        sizes[i] = {nodes[i].w, i};
        for (int c = 0; c < 30; c++) {
            if (nodes[i].go[c] != -1) {
                dfs(nodes[i].go[c], sizes, parent);
                parent[nodes[i].go[c]] = i;
                sizes[i].first += sizes[nodes[i].go[c]].first;
            }
        }
    }

    void mark(int i, vector<bool> &used) {
        if (used[i]) {
            return;
        }
        used[i] = true;
        for (int c = 0; c < 30; c++) {
            if (nodes[i].go[c] != -1) {
                mark(nodes[i].go[c], used);
            }
        }
    }

    pair<vector<pair<int, int>>, vector<int>> get() {
        vector<pair<int, int>> sizes(nodes.size(), {-1, -1});
        vector<int> parent(nodes.size(), -1);
        dfs(0, sizes, parent);
        return {sizes, parent};
    }
};

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    bor bor;

    string s;
    for (int i = 0; i < n; i++) {
        cin >> s;
        bor.add_str(s);
    }


    vector<pair<int, int>> sizes, sizes_sort;
    vector<int> parent;

    tie(sizes, parent) = bor.get();
    sizes_sort = sizes;
    std::sort(sizes_sort.begin(), sizes_sort.end());

    vector<int> minus(sizes.size(), 0);
    vector<bool> used(sizes.size(), false);

    priority_queue<pair<int, int>> q;

    int ii = 0;
    while (ii < sizes_sort.size() && sizes_sort[ii].first <= k) {
        if (used[ii]) {
            ii++;
            continue;
        }
        int cur = sizes_sort[ii].second;
        while (parent[cur] != -1 && sizes[parent[cur]].first <= k) {
            cur = parent[cur];
            if (used[cur]) {
                break;
            }
        }
        if (used[cur]) {
            ii++;
            continue;
        }
        // cout << cur << " " << sizes[cur].first << endl;
        bor.mark(cur, used);
        used[cur] = false;
        q.push({sizes[cur].first, cur});
        ii++;
    }

    int ans = 0, sum = 0;

    // cout << "!!" << endl;
    while (!q.empty() && sum < n) {
        int w, i;
        tie(w, i) = q.top();
        q.pop();
        if (used[i]) {
            continue;
        }
        // cout << i << " " << sizes[i].first << " " << minus[i] << endl;
        ans++;
        sum += (sizes[i].first - minus[i]);
        if (parent[i] != -1) {
            int m = sizes[i].first - minus[i];
            int cur = parent[i];
            if (sizes[cur].first - minus[cur] - m <= k) {
                while (parent[cur] != -1 && sizes[parent[cur]].first - minus[parent[cur]] - m <= k) {
                    cur = parent[cur];
                }
                bor.mark(cur, used);
                used[cur] = false;
                minus[cur] += m;
                q.push({-(sizes[cur].first - minus[cur]), cur});
            } else {
                minus[cur] += m;
            }
        }
        // bor.mark(i, used);
    }

    cout << ans;

    return 0;
}