#include <bits/stdc++.h>

using namespace std;

struct node {
    int w, s;
    vector<int> go;

    node() : w(0), s(0), go(30, -1) {}
};

struct bor {
    vector<node> nodes;

    bor() : nodes(1, node()) {}

    void add_str(string &s) {
        int cur = 0;
        for (char c : s) {
            if (nodes[cur].go[c - 'a'] != -1) {
                cur = nodes[cur].go[c - 'a'];
            } else {
                nodes.emplace_back();
                nodes[cur].go[c - 'a'] = (int)nodes.size() - 1;
                cur = (int)nodes.size() - 1;
            }
        }
        nodes[cur].w++;
    }

    void build(int i) {
        nodes[i].s = nodes[i].w;
        for (int c = 0; c < 30; c++) {
            if (nodes[i].go[c] != -1) {
                build(nodes[i].go[c]);
                nodes[i].s += nodes[nodes[i].go[c]].s;
            }
        }
    }

    int solve(int k) {
        build(0);
        return solve_rec(0, k) + 1;
    }

    int solve_rec(int i, int k) {
        int ans = 0;
        vector<pair<int, int>> ch;

        for (int c = 0; c < 30; c++) {
            if (nodes[i].go[c] != -1) {
                if (nodes[nodes[i].go[c]].s > k) {
                    ans += solve_rec(nodes[i].go[c], k);
                }
                ch.emplace_back(nodes[nodes[i].go[c]].s, nodes[i].go[c]);
            }
        }

        sort(ch.begin(), ch.end(), greater<>());

        nodes[i].s = nodes[i].w;
        for (auto & child : ch) {
            nodes[i].s += child.first;
        }

        int ind = 0;
        while (nodes[i].s > k) {
            nodes[i].s -= ch[ind].first;
            ans++;
        }

        return ans;
    }
};

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    bor bor;

    string s;
    for (int i = 0; i < n; i++) {
        cin >> s;
        bor.add_str(s);
    }

    cout << bor.solve(k) << endl;

    return 0;
}