#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <string>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <stdio.h>
#include <memory.h>
#include <cstdlib>
#include <stdlib.h>
#include <time.h>
#include <bitset>
#include <random>
#include <chrono>

#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 998244353LL;
const int inf = 1e9;
const ll biginf = 2e18;
const ld pi = acosl(-1);
const ld eps = 1e-9;
const int maxn = 101;
const ll negative_inf = -1e18;
const int alph_size = 26;

void solve() {
    int t;
    cin >> t;
    vector<vector<pii> > v(t);
    map<string, int> ms;
    for (int i = 0; i < t; i++) {
        int l;
        cin >> l;
        for (int j = 0; j < l; j++) {
            string s;
            cin >> s;
            for (int k = 0; k < s.size(); k++) {
                if (s[k] == '=') {
                    string name = s.substr(0, k);
                    if (ms.find(name) == ms.end()) {
                        int sz = ms.size();
                        ms[name] = sz;
                    }
                    v[i].pb(mp(ms[name], atoi(s.substr(k + 1).c_str())));
                    break;
                }
            }
        }
    }
    int k;
    cin >> k;
    vector<int> good(k);
    for (int i = 0; i < k; i++) {
        string name;
        int val;
        cin >> name >> val;
        good[ms[name]] = val;
    }
    vector<vector<int> > marks(t);
    vector<int> pl(t);
    for (int i = 0; i < t; i++) {
        marks[i].resize(v[i].size(), -1);
        pl[i] = v[i].size() - 1;
    }
    vector<int> used(k, false);
    stack<int> order;
    int cnt = 0;
    while (true) {
        bool found = false;
        for (int i = 0; i < t; i++) {
            while (pl[i] >= 0 && used[v[i][pl[i]].first]) {
                pl[i]--;
            }
            if (pl[i] == -1) {
                continue;
            }
            if (good[v[i][pl[i]].first] == v[i][pl[i]].second) {
                found = true;
                marks[i][pl[i]] = v[i][pl[i]].first;
                used[v[i][pl[i]].first] = true;
                order.push(i);
                pl[i]--;
                cnt++;
                break;
            }
        }
        if (!found) {
            cout << "No\n";
            return;
        }
        if (cnt == k) {
            break;
        }
    }
    vector<int> ans;
    vector<int> ptr(t, 0);
    for (int i = 0; i < t; i++) {
        while (ptr[i] < v[i].size() && marks[i][ptr[i]] == -1) {
            ans.pb(i + 1);
            ptr[i]++;
        }
        if (ptr[i] == v[i].size()) {
            continue;
        }
    }
    while (!order.empty()) {
        int i = order.top();
        order.pop();
        ans.pb(i + 1);
        ptr[i]++;
        while (ptr[i] < v[i].size() && marks[i][ptr[i]] == -1) {
            ans.pb(i + 1);
            ptr[i]++;
        }
    }
    cout << "Yes\n";
    for (auto x : ans) {
        cout << x << " ";
    }
}

void multisolve() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; i++) {
        solve();
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}