#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Q = 26;
const int MAX_LEN = 3e5 + 10;
int cur = 1;

struct Node {
    map<char, int> go_to;
    int cnt = 0, prev = 0;
};

void add_string(vector<Node> &trie, const string &s) {
    int sz = s.size();
    int cur_node = 0;
    for (int i = 0; i < sz; i++) {
        if (trie[cur_node].go_to[s[i]] == 0) {
            trie[cur].prev = cur_node;
            trie[cur_node].go_to[s[i]] = cur++;
        }
        cur_node = trie[cur_node].go_to[s[i]];
    }
    trie[cur_node].cnt = 1;
}

pair<int, int> count_sizes(int v, int k, vector<Node> &trie) {
    set<pair<int, int> > st;
    int sum = 0;
    for (auto ch : trie[v].go_to) {
        if (ch.second != 0) {
            pair<int, int> tmp = count_sizes(ch.second,  k, trie);
            st.insert({tmp.first, ch.second});
            sum += tmp.second;
        }
    }
    int cnt = trie[v].cnt;
    if (!st.empty() || trie[v].cnt != 0) sum++;
    while (!st.empty() && (cnt + st.begin()->first) <= k) {
        cnt += st.begin()->first;
        st.erase(st.begin());
        sum--;
    }
    return {cnt, sum};
}

void null_subtree(int v, int h, vector<Node> &trie, set<pair<pair<int, int>, int> > &st) {
    st.erase({{-trie[v].cnt, h}, v});
    trie[v].cnt = 0;
    for (auto ch : trie[v].go_to) {
        if (ch.second != 0 && trie[ch.second].cnt != 0) null_subtree(ch.second, h + 1, trie, st);
    }
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<Node> trie(MAX_LEN);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add_string(trie, s);
    }
    pair<int, int> ans = count_sizes(0, k, trie);
    cout << ans.second;
    return 0;
}