#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Border {
    int m, idx, type;
};

bool cmp(const Border &a, const Border &b) {
    if (a.m != b.m) return a.m < b.m;
    return a.type <= b.type;
}

struct Node {
    int mx = 0, mx_left = 0, mx_right = 0;
    bool is_all = true;
};

void build(int v, int l, int r, vector<Node> &tree, const vector<int> &data) {
    if (l + 1 == r) {
        tree[v].mx = tree[v].mx_left = tree[v].mx_right = data[l];
        tree[v].is_all = (data[l] >= 0);
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, tree, data);
    build(2 * v + 2, m, r, tree, data);
    tree[v].mx_left = tree[2 * v + 1].mx_left;
    if (tree[2 * v + 1].is_all) {
        tree[v].mx_left = max(tree[v].mx_left, tree[2 * v + 1].mx + tree[2 * v + 2].mx_left);
    }
    tree[v].mx_right = tree[2 * v + 2].mx_right;
    if (tree[2 * v + 2].is_all) {
        tree[v].mx_right = max(tree[v].mx_right, tree[2 * v + 2].mx + tree[2 * v + 1].mx_right);
    }
    tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
    if (tree[2 * v + 1].mx_right >= 0 && tree[2 * v + 2].mx_left >= 0) tree[v].mx = max(tree[v].mx, tree[2 * v + 1].mx_right + tree[2 * v + 2].mx_left);
    tree[v].is_all = (tree[2 * v + 1].is_all & tree[2 * v + 2].is_all);
}

void update(int v, int l, int r, int pos, int x, vector<Node> &tree) {
    if (l + 1 == r) {
        tree[v].mx = tree[v].mx_left = tree[v].mx_right = x;
        tree[v].is_all = (x >= 0);
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) update(2 * v + 1, l, m, pos, x, tree); else update(2 * v + 2, m, r, pos, x, tree);
    tree[v].mx_left = tree[2 * v + 1].mx_left;
    if (tree[2 * v + 1].is_all) {
        tree[v].mx_left = max(tree[v].mx_left, tree[2 * v + 1].mx + tree[2 * v + 2].mx_left);
    }
    tree[v].mx_right = tree[2 * v + 2].mx_right;
    if (tree[2 * v + 2].is_all) {
        tree[v].mx_right = max(tree[v].mx_right, tree[2 * v + 2].mx + tree[2 * v + 1].mx_right);
    }
    tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
    if (tree[2 * v + 1].mx_right >= 0 && tree[2 * v + 2].mx_left >= 0) tree[v].mx = max(tree[v].mx, tree[2 * v + 1].mx_right + tree[2 * v + 2].mx_left);
    tree[v].is_all = (tree[2 * v + 1].is_all & tree[2 * v + 2].is_all);
}

int main() {
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        vector<Border> borders;
        vector<int> tmp(n, 0);
        for (int i = 1; i < n; i++) {
            int diff = a[i] - a[i - 1];
            if (diff < m) {
                int in_one = (m - a[i - 1] % m) % m, sep = (m - a[i] % m) % m;
                if (in_one != 0) borders.push_back({in_one, i - 1, 0});
                if (sep != 0) borders.push_back({sep, i - 1, 1});
                if (a[i] / m == a[i - 1] / m) {
                    tmp[i - 1] = 0;
                } else {
                    tmp[i - 1] = 1;
                }
            }
            if (m == diff) {
                tmp[i - 1] = 1;
            }
            if (m < diff && diff < 2 * m) {
                int too_much = (m - a[i] % m) % m, sep = (m - a[i - 1] % m) % m;
                if (too_much != 0) borders.push_back({too_much, i - 1, -1});
                if (sep != 0) borders.push_back({sep, i - 1, 1});
                if (a[i] / m == a[i - 1] / m + 1) {
                    tmp[i - 1] = 1;
                } else {
                    tmp[i - 1] = -1;
                }
            }
            if (2 * m <= diff) {
                tmp[i - 1] = -1;
            }
        }
        stable_sort(borders.begin(), borders.end(), cmp);
        int sz = borders.size();
        vector<Node> seg_tree(4 * n + 1);
        build(0, 0, n, seg_tree, tmp);
        int all_time_max = seg_tree[0].mx + 1, mm = 0;
        for (int i = 0; i < sz; i++) {
            int idx = borders[i].idx, type = borders[i].type;
            update(0, 0, n, idx, type, seg_tree);
            int mx = seg_tree[0].mx;
            if (mx + 1 > all_time_max) {
                all_time_max = mx + 1;
                mm = borders[i].m;
            }
        }
        cout << all_time_max << ' ' << mm << '\n';
    }
    return 0;
}