#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct edge {
    int to;
    int w;
    edge(int to = -1, int w = -1) : to(to), w(w) {}
};

enum dir {
    max_edge,
    min_edge,
    max_diff
};

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> a(n, vector<edge>(0));
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--;
        y--;
        a[x].push_back(edge(y, w));
        a[y].push_back(edge(x, w));
    }
    vector<int> min_dist(n, n);
    vector<int> min_edge(n, 1e9 + 1);
    vector<int> max_edge(n, -1);
    vector<int> max_diff(n, 0);
    vector<int> pred_for_max_diff(n, -1);
    vector<int> pred_for_min_edge(n, -1);
    vector<int> pred_for_max_edge(n, -1);
    vector<dir> where(n, dir::max_diff);
    vector<bool> used(n, 0);

    queue<int> q;
    q.push(0);
    used[0] = 1;
    max_diff[0] = 0;
    min_dist[0] = 0;
    while(!q.empty())
    {
        int cur = q.front();
        q.pop();
        for (const auto& e : a[cur])
        {
            if (min_dist[e.to] > min_dist[cur] + 1) {
                min_dist[e.to] = min_dist[cur] + 1;
                pred_for_max_diff[e.to] = cur;
                pred_for_min_edge[e.to] = cur;
                pred_for_max_edge[e.to] = cur;

                int was = max_diff[cur];
                int through_max = abs(e.w - max_edge[cur]);
                if (max_edge[cur] == 1e9 + 1) {
                    through_max = -1;
                }
                int through_min = abs(e.w - min_edge[cur]);
                if (min_edge[cur] == 1e9 + 1) {
                    through_min = -1;
                }
                max_diff[e.to] = max(was, max(through_max, through_min));

                if (e.w <= min_edge[cur]) {
                    min_edge[e.to] = e.w;
                } else {
                    min_edge[e.to] = min_edge[cur];
                }
                if (e.w >= max_edge[cur]) {
                    max_edge[e.to] = e.w;
                } else {
                    max_edge[e.to] = max_edge[cur];
                }

                if (!used[e.to]) {
                    q.push(e.to);
                    used[e.to] = true;
                }
            } else if (min_dist[e.to] == min_dist[cur] + 1) {
//                min_dist[e.to] = min_dist[cur] + 1;
                if (min_edge[e.to] > e.w) {
                    pred_for_min_edge[e.to] = cur;
                    min_edge[e.to] = e.w;
                }
                if (max_edge[e.to] < e.w) {
                    pred_for_max_edge[e.to] = cur;
                    max_edge[e.to] = e.w;
                }

                int was = max_diff[e.to];
                int through_max = abs(e.w - max_edge[cur]);
                int through_min = abs(e.w - min_edge[cur]);
                max_diff[e.to] = max(was, max(through_max, through_min));
                if (max_diff[e.to] != was) {
                    pred_for_max_diff[e.to] = cur;
                    if (max_diff[e.to] == through_max)
                        where[cur] = dir::max_edge;
                    else
                        where[cur] = dir::min_edge;
                }

                if (!used[e.to]) {
                    q.push(e.to);
                    used[e.to] = true;
                }
            } else {
                continue;
            }
        }
    }
    cout << min_dist[n - 1] << '\n';
    vector<int> ans;
    dir first_flag = where[n - 1];
    int cur = n - 1;
    while(cur != -1) {
        ans.push_back(cur);
        if (first_flag != dir::max_diff) {
            if (first_flag == dir::max_edge) {
                cur = pred_for_max_edge[cur];
            } else {
                cur = pred_for_min_edge[cur];
            }
            continue;
        }
        if (where[cur] != dir::max_diff) {
            first_flag = where[cur];
            if (first_flag == dir::max_edge) {
                cur = pred_for_max_edge[cur];
            } else {
                cur = pred_for_min_edge[cur];
            }
            continue;
        }
        cur = pred_for_max_diff[cur];

    }
    reverse(ans.begin(), ans.end());
    for (const auto& x : ans) {
        cout << x + 1 << " ";
    }


    return 0;
}
