#include <iostream>
#include <vector>

using namespace std;
const std::vector<std::pair<int, int>> q{{0, 0}, {0, 1}, {0, 2},
                                         {1, 0},                    {1, 2},
                                         {2, 0}, {2, 1}, {2, 2},
                                                                               {3, 2},
                                                                               {4, 2}};

const std::vector<std::pair<int, int>> f{{0, 0}, {0, 1}, {0, 2},
                                         {1, 0},
                                         {2, 0}, {2, 1},
                                         {3, 0},
                                         {4, 0}};

std::vector<std::vector<bool>> a;

bool is_f(int i, int j)
{
    bool res = true;
    for (int x = 0; x < 5; x++)
    {
        res &= a[i + x][j];
    }
    return res;
}

void clear_letter(const std::vector<std::pair<int, int>>& letter, int i, int j)
{
    for (const auto& p : letter)
    {
        a[i + p.first][j + p.second] = false;
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    a.resize(n + 10, std::vector<bool>(m + 10, false));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char c;
            cin >> c;
            a[i][j] = (c == '#');
        }
    }
    int res_q = 0, res_f = 0;
    for (int j = 0; j < m; j++)
    {
        for (int i = 0; i < n; i++)
        {
            if (!a[i][j]) continue;
            if (is_f(i, j))
            {
                res_f++;
                clear_letter(f, i, j);
            }
            else
            {
                res_q++;
                clear_letter(q, i, j);
            }
        }
    }
    cout << res_q << " " << res_f;
    return 0;
}
