#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

struct Node {
    bool isT = false;
    vector<int> go = vector<int>(26, -1);
    Node() = default;
};

vector<Node> t;

int k;

void addTrie(string &s) {
    int v = 0;
    for (int i = 0; i < s.size(); ++i) {
        char c = s[i] - 'a';
        if (t[v].go[c] == -1) {
            int nv = t.size();
            t.push_back(Node());
            t[v].go[c] = nv;
        }
        v = t[v].go[c];
    }
    t[v].isT = true;
}

par dfs(int v) {
    vector<par> x(26, par(0, 0));
    ll ost = 0;
    ll ans = 0;
    if (t[v].isT) ost++;
    for (int c = 0; c < 26; ++c) {
        if (t[v].go[c] == -1) continue;
        x[c] = dfs(t[v].go[c]);
        ost += x[c].first;
        ans += x[c].second;
    }
    if (ost == k) {
        return par(0, ans + 1);
    }
    if (ost < k) {
        return par(ost, ans);
    }
    sort(all(x));
    reverse(all(x));
    for (int c = 0; c < 26; ++c) {
        ans++;
        ost -= x[c].first;
        if (ost == k) {
            return par(0, ans + 1);
        }
        if (ost < k) {
            return par(ost, ans);
        }
    }
}

int source() {
    ll n;
    cin >> n >> k;
    string s;
    t.push_back(Node());
    for (int i = 0; i < n; ++i) {
        cin >> s;
        addTrie(s);
    }
    par res = dfs(0);
    int ans = res.second;
    if (res.first > 0) {
        ans++;
    }
    cout << ans;
    return 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    source();
}