#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

vector<vector<par>> g;

const ll INF = 1e18;

int n, m;

void bfs(int start, vector<par> &d1, vector<par> &d2, vector<ll> &p1, vector<ll> &p2, vector<ll> &g1, vector<ll> &g2) {
    queue<ll> q1, q2;
    d1[start] = par(-INF, INF);
    q1.push(start);
    g1[start] = 0;
    while (q1.size()) {
        int v = q1.front();
        q1.pop();
        for (auto to: g[v]) {
            if (g1[to.first] < g1[v] + 1) continue;
            if (g1[to.first] == INF) {
                g1[to.first] = g1[v] + 1;
                q1.push(to.first);
            }
            if (d1[to.first].first <= max(to.second, d1[v].first)) {
                d1[to.first].first = max(to.second, d1[v].first);
                d1[to.first].second = min(to.second, d1[v].second);
                p1[to.first] = v;
            }
        }
    }

    d2[start] = par(INF, -INF);
    q2.push(start);
    g2[start] = 0;
    while (q2.size()) {
        int v = q2.front();
        q2.pop();
        for (auto to : g[v]) {
            if (g2[to.first] < g2[v] + 1) continue;
            if (g2[to.first] == INF) {
                g2[to.first] = g2[v] + 1;
                q2.push(to.first);
            }
            if (d2[to.first].first >= min(to.second, d2[v].first)) {
                d2[to.first].first = min(to.second, d2[v].first);
                d2[to.first].second = max(to.second, d2[v].second);
                p2[to.first] = v;
            }
        }
    }
}

int source() {;
    cin >> n >> m;
    g.resize(n);

    for (int i = 0; i < m; ++i) {
        int v, to, c;
        cin >> v >> to >> c;
        --v; --to;
        g[v].push_back(par(to, c));
        g[to].push_back(par(v, c));
    }
    vector<ll> sp1(n, -1), sp2(n, -1);
    vector<par> sd1(n, par(-INF, INF)), sd2(n, par(INF, -INF));
    vector<ll> sg1(n, INF), sg2(n, INF);

    bfs(0, sd1, sd2, sp1, sp2, sg1, sg2);

    vector<ll> np1(n, -1), np2(n, -1);
    vector<par> nd1(n, par(-INF, INF)), nd2(n, par(INF, -INF));

    vector<ll> ng1(n, INF), ng2(n, INF);

    bfs(n - 1, nd1, nd2, np1, np2, ng1, ng2);

    ll pathlen = sg1[n - 1];

    ll ans = -1;
    int x = -1;
    bool flag = false;
    for (int v = 0; v < n; ++v) {
        /*
        cerr << sd1[v].first << ' ' << sd1[v].second << '\n';
        cerr << sd2[v].first << ' ' << sd2[v].second << '\n';
        cerr << nd1[v].first << ' ' << nd1[v].second << '\n';
        cerr << nd2[v].first << ' ' << nd2[v].second << '\n';
        cerr << '\n';
        */
        if (v == 0) {
            if (ans < nd1[v].first - nd1[v].second) {
                ans = nd1[v].first - nd1[v].second;
                x = v;
                flag = false;
            }
            continue;
        }

        if (v == n - 1) {
            if (ans < sd1[v].first - sd1[v].second) {
                ans = sd1[v].first - sd1[v].second;
                x = v;
                flag = true;
            }
            continue;
        }

        if (sd2[v].first <= nd1[v].second && nd1[v].first >= sd2[v].second) {
            if (ng1[v] + sg2[v] == pathlen && ans < nd1[v].first - sd2[v].first) {
                ans = nd1[v].first - sd2[v].first;
                x = v;
                flag = false;
            }
        }
        if (nd2[v].first <= sd1[v].second && sd1[v].first >= nd2[v].second) {
            if (sg1[v] + ng2[v] == pathlen && ans < sd1[v].first - nd2[v].first) {
                ans = sd1[v].first - nd2[v].first;
                x = v;
                flag = true;
            }
        }
    }
    //cerr << x <<  ' ' << ans << '\n';
    vector<int> path;
    ll cur = x;
    while (cur != -1) {
        path.push_back(cur);
        if (flag) {
            cur = sp1[cur];
        } else {
            cur = sp2[cur];
        }
    }
    reverse(all(path));
    cur = x;
    while (cur != -1) {
        if (flag) {
            cur = np2[cur];
        } else {
            cur = np1[cur];
        }
        if (cur != -1) path.push_back(cur);
    }
    cout << path.size() - 1 << '\n';
    for (auto v : path) {
        cout << v + 1 << ' ';
    }
    return 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    source();
}