//#include <bits/stdc++.h>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

int inf = 2147483647;

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> wb;
    set<pair<pair<int, int>, int>> wbi;
    set<pair<pair<int, int>, int>> bwi;

    auto zo = pair<int, int>{0, 1};
    auto oz = pair<int, int>{1, 0};

    for (int i = 0; i < n; ++i) {
        int w, b;
        cin >> w >> b;
        wb.emplace_back(w, b);
        if (w > 1) wbi.insert({{w, b}, i});
        if (b > 1) bwi.insert({{b, w}, i});
    }

    vector<int> leafes;
    for (int i = 0; i < wb.size(); ++i) {
        if (wb[i] == zo || wb[i] == oz) {
            leafes.push_back(i);
        }
    }

    vector<pair<pair<int, int>, char>> ans;

    while (!leafes.empty()) {
        int i = leafes.back();
        if (wb[i] == oz) {
            auto parent = *wbi.begin();
            ans.push_back({{i, parent.second}, 'W'});
            wbi.erase(parent);
            parent.first.first -= 1;
            if (parent.first.first > 1) {
                wbi.insert(parent);
            } else {
                bwi.erase({{parent.first.second, parent.first.first}, parent.second});
                leafes.push_back(parent.second);
            }
        } else if (wb[i] == zo) {
            auto parent = *bwi.begin();
            ans.push_back({{i, parent.second}, 'B'});
            bwi.erase(parent);
            parent.first.first -= 1;
            if (parent.first.first > 1) {
                bwi.insert(parent);
            } else {
                wbi.erase({{parent.first.second, parent.first.first}, parent.second});
                leafes.push_back(parent.second);
            }
        }
    }

    if (ans.size() != n - 1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for (pair<pair<int, int>, char> p : ans) {
            cout << p.first.first + 1 << " " << p.first.second + 1 << " " << p.second << "\n";
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t-- > 0) solve();

    return 0;
}
