#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <unordered_map>
#include <cstring>

using namespace std;

typedef long long ll;

map<int, int> lr, rl;

int t = 0, T = 0;
int maxx = 0;

void addDay(int day) {
    int l = day, r = day;
    if (rl.count(day - 1)) {
        l = rl[day - 1];
        rl.erase(day - 1);
    }
    if (lr.count(day + 1)) {
        r = lr[day + 1];
        lr.erase(day + 1);
    }
    lr[l] = r;
    rl[r] = l;
    if (r - l > maxx) {
        maxx = r - l;
        T = t;
    }
}

void removeDay(int day) {
    int r = rl.lower_bound(day)->first;
    int l = rl[r];
    lr.erase(l);
    rl.erase(r);
    lr[l] = day - 1;
    rl[day - 1] = l;
    rl[r] = day + 1;
    lr[day + 1] = r;
}

void solve() {
    t = 0;
    lr.clear();
    rl.clear();
    maxx = 0;
    T = 0;
    int n, m;
    cin >> n >> m;
    vector<int> a(n), day(n);
    map<int, int> cnt;
    map<int, vector<int>> newDay;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        day[i] = a[i] / m;
        cnt[day[i]]++;
        if (cnt[day[i]] == 1) {
            addDay(day[i]);
        }
        int d = m - a[i] % m;
        if (d < m) {
            newDay[d].push_back(i);
        }
    }
    for (auto p: newDay) {
        t = p.first;
        for (int x : p.second) {
            int d = day[x];
            cnt[d]--;
            if (cnt[d] == 0) {
                removeDay(d);
            }
        }
        for (int x : p.second) {
            int d = day[x] + 1;
            cnt[d]++;
            if (cnt[d] == 1) {
                addDay(d);
            }
        }
    }
    cout << maxx + 1 << ' ' << T << '\n';
}

bool multitest = true;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //cout.precision(10);
    size_t number_of_tests = 1;
    if (multitest) {
        cin >> number_of_tests;
    }
    for (size_t _ = 0; _ < number_of_tests; ++_) {
        solve();
    }
    return 0;
}