#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <string>
#include <cmath>
#include <map>
#include <random>
#include <chrono>
#include <fstream>
#include <array>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <list>

using namespace std;

#define pb push_back
#define f first
#define s second
#define ull unsigned long long


typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair<int, int> pii;


const int MAXN = 1e5 + 10;
const int MAXM = 21;
ll INF = 1e9 + 10;
ll MOD = 1e9 + 7;
ld EPS = 1e-12;


void fastIO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n, m, dist[MAXN], distback[MAXN];
vector <vector <pii> > v;
pii dp[MAXN];


void bfs() {
    queue <int> q;
    q.push(0);
    fill(dist, dist + n, INF);
    dist[0] = 0;
    for (int i = 0; i < n; i++) {
        dp[i] = {INF, -1};
    }
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto to : v[u]) {
            if (dist[to.f] == INF) {
                dist[to.f] = dist[u] + 1;
                q.push(to.f);
                dp[to.f].f = min(to.s, dp[u].f);
                dp[to.f].s = max(to.s, dp[u].s);
            }
            else if (dist[to.f] == dist[u] + 1) {
                //cout << u << ' ' << to.f << endl;
                dp[to.f].f = min(dp[to.f].f, min(to.s, dp[u].f));
                dp[to.f].s = max(dp[to.f].s, max(to.s, dp[u].s));
            }
        }
    }   
    //for (int i = 0; i < n; i++) {
      //  cout << i << ' '  << dist[i] << ' ' << dp[i].f << ' ' << dp[i].s << endl;
    //}
}

void bfs2() {
    fill(distback, distback + n, INF);
    queue <int> q;
    q.push(n - 1);
    distback[n - 1] = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto to : v[u]) { 
            if (distback[to.f] == INF) {
                distback[to.f] = distback[u] + 1;
                q.push(to.f);
            }     
        }
    }
}
 
int main() {
    fastIO();
    cin >> n >> m;
    v.resize(n);
    for (int i = 0; i < m; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        v[x - 1].pb({y - 1, c});
        v[y - 1].pb({x - 1, c});
    }
    bfs();
    bfs2();
    int ans = -1;
    pii res;
    int w;
    bool frommin;
    for (int i = 0; i < n; i++) {
        for (auto to : v[i]) {
            int ver = to.f, c = to.s;
            if (dist[i] + 1 + distback[ver] != dist[n - 1])
                continue;
            if (i == 0) {
                if (ans == -1) {
                    ans = 0;
                    res = {i, ver};
                }
            }
            else {
                if (c - dp[i].f > ans) {
                    ans = c - dp[i].f;
                    res = {i, ver};
                    w = c;
                    frommin = true;
                }
                if (dp[i].s - c > ans) {
                    ans = dp[i].s - c;
                    res = {i, ver};
                    w = c;
                    frommin = false;
                }
            }
        }
    }
    //cout << ans << ' ' << res.f << ' ' << res.s << endl;
    if (ans == 0) {
        vi path = {0};
        while (path.back() != (n - 1)) {
            int u = path.back();
            for (auto to : v[u]) {
                 if (distback[to.f] == distback[u] - 1) {
                     path.pb(to.f);
                    break;
                }
            }
        }
        cout << path.size() - 1 << endl;
        for (auto it : path)
            cout << it+1 << ' ';
        cout << endl;
        return 0;
    }
    vi path = {res.f};
    while (true) {
        int u = path.back();
        bool found = false;
        for (auto to : v[u]) {
            if (dist[to.f] != dist[u] - 1)
                continue;
            if (frommin && w - to.s == ans) {
                path.pb(to.f);
                found = true;
                break;
            }
            if (!frommin && to.s - w == ans) {
                path.pb(to.f);
                found = true;
                break;
            }
            if (frommin && w - dp[to.f].f == ans) {
                path.pb(to.f);
                break;
            }
            if (!frommin && dp[to.f].s - w == ans) {
                path.pb(to.f);
                break;
            }
        }
        if (found)
            break;
    }
    // for (auto it : path)
    //     cout << it <<  ' ';
    // cout << endl;
    while (path.back() != 0) {
        int u = path.back();
         for (auto to : v[u]) {
             if (dist[to.f] == dist[u] - 1) {
                 path.pb(to.f);
                 break;
             }
         }
    } 
    reverse(path.begin(), path.end());
    path.pb(res.s);
    while (path.back() != (n - 1)) {
        int u = path.back();
        for (auto to : v[u]) {
             if (distback[to.f] == distback[u] - 1) {
                 path.pb(to.f);
                 break;
             }
         }
    }
    cout << path.size() - 1 << endl;
    for (auto it : path)
        cout << it+1 << ' ';
    cout << endl;
    //cout << ans << endl << res.f << ' ' << res.s << endl;

    



    return 0;
}





