#include <bits/stdc++.h>

using namespace std;

struct edge {
    int l, r, c;
};

void bfs(int from, vector<int>& dp, const vector<vector<pair<int, int>>>& g, vector<int>& maxes, vector<int>& ups) {
    queue<int> q;
    dp[from] = 0;
    q.push(from);
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (auto i : g[x]) {
            if (dp[i.first] == -1) {
                dp[i.first] = dp[x] + 1;
                maxes[i.first] = max(maxes[x], i.second);
                ups[i.first] = x;
                q.push(i.first);
            }
            if (dp[i.first] == dp[x] + 1 && max(maxes[x], i.second) > maxes[i.first]) {
                maxes[i.first] = max(maxes[x], i.second);
                ups[i.first] = x;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<edge> edges(m);
    vector<int> pref_dp(n, -1);
    vector<int> suf_dp(n, -1);
    vector<int> pref_up(n, -1);
    vector<int> suf_up(n, -1);
    for (int i = 0; i < m; i++) {
        cin >> edges[i].l >> edges[i].r >> edges[i].c;
        edges[i].l--;
        edges[i].r--;
        g[edges[i].l].push_back({edges[i].r, edges[i].c});
        g[edges[i].r].push_back({edges[i].l, edges[i].c});
        edges.push_back({edges[i].r, edges[i].l, edges[i].c});
    }

    vector<int> dp_in(n, -1);
    vector<int> dp_out(n, -1);
    bfs(0, dp_in, g, pref_dp, pref_up);
    bfs(n - 1, dp_out, g, suf_dp, suf_up);

    if (dp_in[n - 1] == 1) {
        cout << 1 << endl;
        cout << 1 << ' ' << n;
        exit(0);
    }

    int cur = -1;
    int ans = -1;
    for (int i = 0; i < edges.size(); i++) {
        auto x = edges[i];
        if (dp_in[x.l] + dp_out[x.r] + 1 == dp_in[n - 1]) {
            if (cur < max(pref_dp[x.l], suf_dp[x.r]) - x.c) {
                cur = max(pref_dp[x.l], suf_dp[x.r]) - x.c;
                ans = i;
            }
        }
    }

    cout << dp_in[n - 1] << endl;
    vector<int> t;
    t.push_back(edges[ans].l);
    while (t.back() != 0) {
        t.push_back(pref_up[t.back()]);
    }
    vector<int> e;
    e.push_back(edges[ans].r);
    while (e.back() != n - 1) {
        e.push_back(suf_up[e.back()]);
    }
    std::reverse(t.begin(), t.end());
    for (int i : t) cout << i + 1 << ' ';
    for (int i : e) cout << i + 1 << ' ';
}