#include <iostream>
#include <climits>
#include <cstddef>
#include <cmath>
#include <vector>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        clock_t start_clock = clock();
    // #else
    //  freopen(".in", "r", stdin);
    //  freopen(".out", "w", stdout);
    #endif
    
    solve();

    #ifdef HOME
        // system("pause");
        printf("\n\nfinished in %.3f sec", static_cast<float>(clock() - start_clock) / CLOCKS_PER_SEC);
    #endif
}

bool cycle = false;
void dfs(vector<vector<size_t>>& g, vector<size_t>& used, vector<size_t>& order, size_t v) {
    used[v] = 1;
    for (size_t to : g[v]) {
        if (used[to] == 1) {
            cycle = true;
        }
        if (!used[to]) {
            dfs(g, used, order, to);
        }
    }
    order.push_back(v);
    used[v] = 2;
}

void solve() {
    size_t t;
    cin >> t;


    size_t cnt = 0;
    vector<vector<pair<string, int32_t>>> assign(t);
    vector<vector<size_t>> id(t);
    for (size_t i = 0; i != t; ++i) {
        size_t k;
        cin >> k;

        for (size_t j = 0; j != k; ++j) {
            string str;
            cin >> str;

            string var;
            string num;
            size_t l;
            for (l = 0; str[l] != '='; ++l) {
                var += str[l];
            }
            for (l = l + 1; l != str.size(); ++l) {
                num += str[l];
            }

            assign[i].push_back({var, stoi(num)});
            id[i].push_back(cnt);
            ++cnt;
            // cout << var << ' ' << num' << '\n';
        }
    }

    size_t k;
    cin >> k;

    vector<pair<string, int32_t>> final(k);
    for (size_t i = 0; i != k; ++i) {
        cin >> final[i].first >> final[i].second;
    }

    vector<vector<size_t>> g(cnt);
    for (size_t i = 0; i != t; ++i) {
        for (size_t j = 0; j != assign[i].size() - 1; ++j) {
            g[id[i][j]].push_back(id[i][j + 1]);
        }
    }

    for (auto [var, val] : final) {
        vector<size_t> eq;
        vector<size_t> neq;
        for (size_t i = 0; i != t; ++i) {
            for (int j = id[i].size() - 1; j >= 0; --j) {
                if (assign[i][j].first == var) {
                    if (assign[i][j].second == val) {
                        eq.push_back(id[i][j]);
                    } else {
                        neq.push_back(id[i][j]);
                    }
                    break;
                }
            }

            for (size_t from : neq) {
                for (size_t to : eq) {
                    g[from].push_back(to);
                }
            }
        }
    }


    vector<size_t> used(cnt, false);
    vector<size_t> order;
    for (size_t i = 0; i != cnt; ++i) {
        if (!used[i]) {
            dfs(g, used, order, i);
        }
    }

    if (cycle) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        reverse(order.begin(), order.end());
        vector<size_t> rec;
        for (size_t i = 0; i != t; ++i) {
            rec.push_back(id[i].back());
        }
        for (size_t i : order) {
            cout << lower_bound(rec.begin(), rec.end(), i) - rec.begin() + 1 << ' ';
        }
    }
}
