#include <bits/stdc++.h>

using namespace std;

struct wb {
    int w, b;
};

int64_t dfs(int i, int p, const vector<vector<int>> &gr) {
    int64_t sum = 1;
    for (auto e : gr[i]) {
        if (e == p) {
            continue;
        }
        sum += dfs(e, i, gr);
    }
    return sum;
}

bool check(int n, const vector<pair<pair<int, int>, bool>> &_gr) {
    vector<vector<int>> gr(n);
    for (auto [e, _] : _gr) {
        gr[e.first].push_back(e.second);
        gr[e.second].push_back(e.first);
    }
    return dfs(0, -1, gr) == n;
}

void solution() {
    int n;
    cin >> n;
    deque<int> leafs;
    set<pair<int, int>, greater<pair<int, int>>> not_leafs_b, not_leafs_w;
    vector<wb> nodes;
    vector<pair<pair<int, int>, bool>> gr;

    int64_t sum_n = 0;
    for (int i = 0; i < n; ++i) {
        int w, b;
        cin >> w >> b;
        nodes.push_back({w, b});
        sum_n += (int64_t) w;
        sum_n += (int64_t) b;
        if (w + b == 1) {
            leafs.push_back(i);
        }
        else {
            if (w != 0) {
                not_leafs_w.insert({w, i});
            }
            if (b != 0) {
                not_leafs_b.insert({b, i});
            }
        }
    }

    if (sum_n != (n - 1) * 2) {
        cout << "No\n";
        return;
    }

    while (!leafs.empty()) {
        auto leaf = leafs.front();
        leafs.pop_front();

        while (!not_leafs_w.empty()) {
            auto [w, top] = *not_leafs_w.begin();
            if (w == 0 || nodes[top].w + nodes[top].b == 1) {
                not_leafs_w.erase(not_leafs_w.begin());
                continue;
            }
            break;
        }

        while (!not_leafs_b.empty()) {
            auto [b, top] = *not_leafs_b.begin();
            if (b == 0 || nodes[top].w + nodes[top].b == 1) {
                not_leafs_b.erase(not_leafs_b.begin());
                continue;
            }
            break;
        }

        if (leafs.size() == 1 && not_leafs_w.empty() && not_leafs_b.empty()) {
            auto s = leafs.front();

            if (nodes[leaf].w != 0 && nodes[s].w != 0) {
                gr.push_back({{leaf, s}, true});
                nodes[leaf].w = 0;
                nodes[s].w = 0;
                break;
            }
            else if (nodes[leaf].b != 0 && nodes[s].b != 0) {
                gr.push_back({{leaf, s}, false});
                nodes[leaf].b = 0;
                nodes[s].b = 0;
                break;
            }
            else {
                cout << "No\n";
                return;
            }
        }

        auto [w, b] = nodes[leaf];
        assert(w + b == 1);
        nodes[leaf].w = 0;
        nodes[leaf].b = 0;

        int ind;
        if (w == 0) {
            if (not_leafs_b.empty()) {
                cout << "No\n";
                return;
            }
            ind = not_leafs_b.begin()->second;
            --nodes[ind].b;
            gr.push_back({{leaf, ind}, false});
        }
        else {
            if (not_leafs_w.empty()) {
                cout << "No\n";
                return;
            }
            ind = not_leafs_w.begin()->second;
            --nodes[ind].w;
            gr.push_back({{leaf, ind}, true});
        }

        if (nodes[ind].w + nodes[ind].b == 1) {
            leafs.push_back(ind);
        }
    }

//    1
//4
//2 0
//1 1
//1 0
//0 1

    for (auto node : nodes) {
        if (node.b != 0 || node.w != 0) {
            cout << "No\n";
            return;
        }
    }

    if (gr.size() != n - 1) {
        cout << "No\n";
        return;
    }

    if (!check(n, gr)) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";
    for (auto [e, is_w] : gr) {
        cout << e.first + 1 << " " << e.second + 1 << " " << (is_w ? "W" : "B") << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int tt = 0; tt < t; ++tt) {
       solution();
    }

    return 0;
}
