#include <bits/stdc++.h>
using namespace std;

struct Vertex {
    static constexpr int ALPHABET = 26;
    int prv = -1;
    int nxt[ALPHABET];
    bool leaf = false;
    int cnt = 0;
    Vertex() {
        fill(nxt, nxt + ALPHABET, -1);
    }
};

int n, k;
vector<Vertex> t(1);

void add(const string &s) {
    int v = 0;
    for (int i = 0; i < s.size(); ++i) {
        int c = s[i] - 'a';
        if (t[v].nxt[c] == -1) {
            t.emplace_back();
            t[v].nxt[c] = static_cast<int>(t.size()) - 1;
            t.back().prv = v;
        }
        ++t[v].cnt;
        v = t[v].nxt[c];
    }
    ++t[v].cnt;
    t[v].leaf = true;
}

int find(int v) {
    if (t[v].cnt <= k) {
        return v;
    }
    int ans = -1;
    for (int c = 0; c < Vertex::ALPHABET; ++c) {
        if (t[v].nxt[c] != -1) {
            int tmp = find(t[v].nxt[c]);
            if (ans == -1 || t[ans].cnt < t[tmp].cnt) {
                ans = tmp;
            }
        }
    }
    return ans;
}

void del(int v, int val) {
    for (int i = v; i != -1; i = t[i].prv) {
        t[i].cnt -= val;
    }
}

signed main() {
#ifdef LOCAL
    freopen("data", "r", stdin);
#endif
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        add(s);
    }

    int ans = 0;
    while (t[0].cnt) {
        int v = find(0);
        del(v, t[v].cnt);
        ++ans;
    }
    cout << ans << '\n';
}