#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

struct Vertex {
    static const int ALPHABET = 26;
    vector <size_t> next;
    bool isEnd;
    int count;
    Vertex() : next(ALPHABET, -1), isEnd(false), count(0) { }
};
vector<bool> ans;
vector <Vertex> bor(1);
int root = 0;
int k;

void add(const string& s) {
    size_t v = root;
    for (int x : s) {
        bor[v].count++;
        if (bor[v].next[x - 'a'] == -1) {
            bor.emplace_back();
            bor[v].next[x - 'a'] = bor.size() - 1;
        }
        v = bor[v].next[x - 'a'];
    }
    bor[v].count++;
    bor[v].isEnd = true;
}

int dfs(size_t v){
    int res = 0;
    for (size_t u : bor[v].next){
        if (u == -1 || bor[u].count <= k) { continue; }
        bor[v].count -= bor[u].count;
        res += dfs(u);
    }
//    cout << "count=" << bor[v].count << " k=" << k << "\n";
    vector<int> mas;
    for (size_t u : bor[v].next){
        if (u != -1 && bor[u].count > 0){
            mas.push_back(bor[u].count);
        }
    }
    sort(mas.begin(), mas.end(), greater<>());
    for (int x : mas){
//        cout << x << " ";
        if (bor[v].count <= k){
//            ++res;
            break;
        }
        bor[v].count -= x;
        ++res;
    }
    return res;
}

int main() {
    int n;
    cin >> n >> k;
    string s;
    for (int i = 0; i < n; ++i){
        cin >> s;
        add(s);
    }
    int res = dfs(root);
    if (bor[root].count > 0){ ++res; }
    cout << res << "\n";
    return 0;
}
