// #pragma GCC optimize("O3", "unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,lzcnt,abm,bmi,bmi2,mmx,avx,avx2,fma")

// #include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

struct Trie {
    struct Node {
        vector <Node*> children;
        char c;
        int size;
        int left_size;
        bool is_end;

        Node(char c1) {
            children.resize(26, nullptr);
            size = 0;
            is_end = false;
            c = c1;
        }
    };

    Node* root;

    Trie() {
        root = new Node('$');
    }

    void add(string s) {
        Node* v = root;
        for (char c : s) {
            v->size += 1;
            if (v->children[c -'a'] == nullptr) {
                v->children[c - 'a'] = new Node(c);
            }
            v = v->children[c - 'a'];
        }
        v->size += 1;
        v->is_end = true;
    }

    int calc(Node *v, int k) {
        int size = v->size;
        map <int, int> dp;
        dp[0] = 0;
        int max_size = 0;
        for (Node* child : v->children) {
            if (child == nullptr) continue;
            int child_size = child->size, child_op = calc(child, k);
            for (auto [s1, op1] : dp) {
                if (-s1 >= size - k) {
                    continue;
                }
                int new_size = -s1 + child_size;
                int temp = -1;
                if (new_size > size - k) {
                    temp = new_size;
                    new_size = size - k;
                }
                new_size = -new_size;
                int prev_op = 1000000000;
                if (dp.count(new_size)) {
                    prev_op = dp[new_size];
                }
                dp[new_size] = min(prev_op, op1 + child_op + 1);
                if (prev_op > op1 + child_op + 1 && temp != -1) {
                    max_size = temp;
                } else if (prev_op == op1 + child_op + 1 && temp != -1) {
                    max_size = max(max_size, temp);
                }

                new_size = -s1 + child->left_size;
                temp = -1;
                if (new_size > size - k) {
                    temp = new_size;
                    new_size = size - k;
                }
                new_size = -new_size;
                prev_op = 1000000000;
                if (dp.count(new_size)) {
                    prev_op = dp[new_size];
                }
                dp[new_size] = min(prev_op, op1 + child_op);
                if (prev_op > op1 + child_op && temp != -1) {
                    max_size = temp;
                } else if (prev_op == op1 + child_op && temp != -1) {
                    max_size = max(max_size, temp);
                }
            }
        }
        v->left_size = max_size;
        return dp[-(size - k)];
    }
};

signed main() {
    // #ifndef LOCAL
    //     freopen("input.txt", "r", stdin);
    //     freopen("output.txt", "w", stdout);
    // #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n, k;
    cin >> n >> k;
    Trie t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        t.add(s);
    }
    int res = t.calc(t.root, k);
    if (t.root->left_size == n) {
        cout << res;
    } else {
        cout << res + 1;
    }
}