// #pragma GCC optimize("O3", "unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,lzcnt,abm,bmi,bmi2,mmx,avx,avx2,fma")

// #include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

struct Trie {
    struct Node {
        Node* *children;
        char c;
        int size;
        int left_size;
        bool is_end;

        Node(char c1) {
            // children.resize(26, nullptr);
            children = new Node*[26];
            for (int i = 0; i < 26; ++i) {
                children[i] = nullptr;
            }
            size = 0;
            left_size = 0;
            is_end = false;
            c = c1;
        }
    };

    Node* root;

    Trie() {
        root = new Node('$');
    }

    void add(string s) {
        Node* v = root;
        for (char c : s) {
            v->size += 1;
            if (v->children[c -'a'] == nullptr) {
                v->children[c - 'a'] = new Node(c);
            }
            v = v->children[c - 'a'];
        }
        v->size += 1;
        v->is_end = true;
    }

    void calc_dp(map <int, int> &dp, int new_size, int new_value, int size, int k, int* max_size) {
        int temp = -1;
        if (new_size >= size - k) {
            temp = new_size;
            new_size = size - k;
        }
        new_size = -new_size;
        int prev_op = 1000000000;
        if (dp.count(new_size)) {
            prev_op = dp[new_size];
        }
        dp[new_size] = min(prev_op, new_value);
        if (prev_op > new_value && temp != -1) {
            *max_size = temp;
        } else if (prev_op == new_value && temp != -1) {
            *max_size = max(*max_size, temp);
        }
    }

    int calc(Node *v, int k) {
        int size = v->size;
        map <int, int> dp;
        dp[0] = 0;
        for (int i = 0; i < 26; ++i) {
            Node* child = v->children[i];
            if (child == nullptr) continue;
            int child_size = child->size, child_op = calc(child, k);
            for (auto [s1, op1] : dp) {
                calc_dp(dp, -s1 + child_size, op1 + child_op + 1, size, k, &(v->left_size));
                calc_dp(dp, -s1 + child->left_size, op1 + child_op, size, k, &(v->left_size));
            }
        }
        return dp[-(size - k)];
    }
};

signed main() {
    // #ifdef LOCAL
    //     freopen("input.txt", "r", stdin);
    //     freopen("output.txt", "w", stdout);
    // #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n, k;
    cin >> n >> k;
    Trie t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        t.add(s);
    }
    int res = t.calc(t.root, k);
    if (t.root->left_size == n) {
        cout << res;
    } else {
        cout << res + 1;
    }
}