#include <iostream>
#include <vector>
using namespace std;

struct Node {
    int weight;
    int depth;
    Node *prev;
    Node *next[26];
};

Node *create(int depth) {
    Node *node = new Node();
    node->weight = 0;
    node->depth = depth;
    node->prev = nullptr;
    for (int i = 0; i < 26; i++)
        node->next[i] = nullptr;
    return node;
}

struct Bor {
    Node *root;
};

void addWord(Bor &b, string &word) {
    Node *cur = b.root;
    b.root->weight++;
    for (char c : word) {
        if (cur->next[c - 'a'] == nullptr) {
            cur->next[c - 'a'] = create(cur->depth + 1);
            cur->next[c - 'a']->prev = cur;
        }
        cur->next[c - 'a']->weight++;
        cur = cur->next[c - 'a'];
    }
}

Node* recFindMax(Node *cur, int k, Node *curMax) {
    if (cur == nullptr) return curMax;
    if (cur->weight == 0) return curMax;
    if (cur->weight <= k && cur->weight > curMax->weight)
        curMax = cur;

    for (int i = 0; i < 26; i++)
        if (cur->next[i] != nullptr) {
            Node *nextMax = recFindMax(cur->next[i], k, curMax);
            if (nextMax != nullptr && nextMax->weight > curMax->weight)
                curMax = nextMax;
        }
    return curMax;
}

void remove(Bor &b, int k) {
    Node *node = create(0);
    node = recFindMax(b.root, k, node);

    int max = node->weight;
    while (node != nullptr) {
        node->weight -= max;
        node = node->prev;
    }
}

int main()
{
    Bor b;
    b.root = create(0);
    int n, k;
    cin >> n >> k;
    vector <string> words(n);
    for (int i = 0; i < n; i++) {
        cin >> words[i];
        addWord(b, words[i]);
    }

    int cnt = 0;
    while (b.root->weight > 0) {
        if (b.root->weight == 4) {
        }
        remove(b, k);
        cnt++;
    }
    cout << cnt;
}

/*
10 3
abcd
abce
abe
abf
ace
ade
q
w
e
r
*/
