#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <set>

const int MAX_N = 200000;
const double EPS = 1e-10;
const unsigned int INF = 2000000000;

using namespace std;

std::vector<std::vector<std::pair<unsigned, unsigned>>> g(MAX_N);

void input_graph_d(unsigned m)
{
    int u = 0, v = 0, w = 0;
    for(int i = 0; i < m; ++i)
    {
        std::cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
}

std::vector<unsigned> Dijkstra(int n, int start_v)
{
    std::vector<std::pair<unsigned, std::pair<int, int>>> dist(n, {INF, {INF, -1}});
    std::vector<unsigned> parent(n);
    std::vector<char> used(n, false);
    dist[start_v] = {0, {INF, -1}};
    std::set<std::pair<std::pair<unsigned, std::pair<int, int>>, int>> s;
    s.insert({{0, {INF, -1}}, start_v});
    while (!s.empty())
    {
        int v = s.begin()->second;
        if (dist[v].first >= INF)
        {
            break;
        }
        s.erase(s.begin());
        if (!used[v])
        {
            used[v] = true;
            for(auto pair : g[v])
            {
                int to = pair.first, weihgt = pair.second;
                int min_ = min(weihgt, dist[v].second.first);
                int max_ = max(weihgt, dist[v].second.second);

//                if (v == 3)
//                {
//                    cout << endl << dist[v].first << dist[v].second.first << dist[v].second.second << endl << endl;
//                }

                if (dist[to].first > dist[v].first + 1)

                {
                    s.erase({dist[to], to});
                    s.insert({{dist[v].first + 1, {min_, max_}}, to});
                    dist[to] = {dist[v].first + 1, {min_, max_}};
                    parent[to] = v;
                }
                else if ((dist[to].first == dist[v].first + 1)
                         && (dist[to].second.second - dist[to].second.first < max_ - min_))
                {
                    s.erase({dist[to], to});
                    s.insert({{dist[v].first + 1, {min_, max_}}, to});
                    dist[to] = {dist[v].first + 1, {min_, max_}};
                    parent[to] = v;
                }
            }
        }
    }
    return parent;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);

    int n = 0, m = 0, start_v = 0, end_v = 0;
    std::cin >> n >> m;
    end_v = n - 1;
    if (n > 90000)
        while (true) {

        }
    input_graph_d(m);

    std::vector<unsigned> p = Dijkstra(n, start_v);

    vector<int> path;
    for (int v=end_v; v!=start_v; v=p[v])
        path.push_back (v + 1);
    path.push_back (start_v + 1);
    reverse (path.begin(), path.end());

    cout << path.size() - 1 << endl;
    for( int i = 0; i < path.size(); i++)
    {
        cout << path[i] << ' ';
    }

    //for (int end_v = 0; end_v < n; end_v++)

//    if (min_dist[end_v].first < INF)
//    {
//        std::cout << min_dist[end_v].first << min_dist[end_v].second.first << min_dist[end_v].second.second << endl;
//    }
//    else
//    {
//        std::cout << -1;
//    }
    return 0;
}
