class Node():
    def __init__(self, char=None, parent=None):
        self.next = []
        self.value = None
        self.char = char
        self.parent = parent
        self.sm = 0

    def find_node(self, node_char):
        for i in range(len(self.next)):
            if self.next[i].char == node_char:
                return i

    def new_sum(self):
        self.sm = 0
        for el in self.next:
            self.sm += el.sm

    def sort_nodes(self):
        def kerr(el):
            return el.sm
        self.next.sort(key=kerr, reverse=False)

root = Node()

def print_tree(tree):
    print("{", end='')
    for el in tree.next:
        print(f"({el.char} {el.sm}): ", end='')
        print_tree(el)
    print("}, ", end='')

def add(S):
    cur = root
    for c in S:
        index = cur.find_node(c)
        if index is None:
            cur.next.append(Node(c, parent=cur))
        cur.sm += 1
        cur = cur.next[-1]
    cur.sm += 1

def del_node_with_k(prefix, tree, k):
    if tree.sm == k:
        if tree.parent:
            index = tree.parent.find_node(tree.char)
            del tree.parent.next[index]
        return prefix
    if tree.sm < k:
        return None
    tree.sort_nodes()
    for node in tree.next:
        data = del_node_with_k(prefix + node.char, node, k)
        if data:
            node.sm -= k
            return data
    return None

n, k = map(int, input().split())
for i in range(n):
    add(input())
count = 0
k_new = k
while root.sm > k:
    data = del_node_with_k('', root, k_new)
    if data is None:
        k_new -= 1
    else:
        k_new = k
        count += 1
    root.new_sum()
if root.sm > 0:
    count += 1
print(count)
