#pragma comment(linker, "/STACK:128777216")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <tuple>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <cassert>
#include <random>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(v) (int)(v).size()
#define forx(_name, _from, to, value) for (int name = from; name < to; name += value)
#define rforx(_name, from, to, value) for (int name = from; name > to; name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST, _SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-9;
mt19937 rnd(42);

void start() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout.setf(ios::fixed);
#ifdef LOCAL
    //freopen("output.out", "w", stdout);
    freopen("input.in", "r", stdin);
#endif
}

const int MAX_N = (int) 1e7 + 10;
const int MAX_M = (int) 1e6 + 10;
const int MOD = (int) 1e9;
const int INF = (int) 1e9 + 7;

const int MAXN = 5e5;

struct Node {
    ll num = 0;
    vector<int> to = vector<int>(26, -1);
};

Node tree[MAXN];
int pos = 1;

void add_word(string word) {
    int cur = 0;
    for (int i = 0; i < word.length(); ++i) {
        int to = word[i] - 'a';
        if (tree[cur].to[to] == -1) {
            tree[cur].to[to] = pos++;
        }
        cur = tree[cur].to[to];
    }
    tree[cur].num += 1;
}
int n, k;

pair<ll, ll> calc_dp(int vert) {
    pair<ll, ll> res = {0, tree[vert].num};
    vector<pair<ll, ll> > v;

    forn(i, 26) {
        int to = tree[vert].to[i];
        if (to == -1) {
            continue;
        }
        auto p = calc_dp(to);
        res.first += p.first;
        res.second += p.second;
        v.push_back(p);
    }
    sort(v.begin(), v.end(), [](pair<ll, ll> p1, pair<ll, ll> p2){
        return p1.second < p2.second;
    });

    while (res.second > k) {
        ++res.first;
        res.second -= v.back().second;
        v.pop_back();
    }
    if (res.second == k) {
        ++res.first;
        res.second = 0;
    }

    return res;
}

void solve() {
    cin >> n >> k;
    forn(i, n) {
        string s;
        cin >> s;
        add_word(s);
    }
    auto p = calc_dp(0);
    if (p.second > 0) {
        p.first += 1;
    }
    cout << p.first << endl;
}

int main() {
    start();
    solve();
    //multitest();
#ifdef LOCAL
    //cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}
