#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <tuple>
using namespace std;

typedef long long lint;
#define For(i, n) for (int i = 0; i < (n); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) (int)((v).size())

int read()
{
    char c;
    while (true)
    {
        c = getchar();
        if ('0' <= c && c <= '9')
            break;
    }
    int res = c - '0';
    while (true)
    {
        c = getchar();
        if (!('0' <= c && c <= '9'))
            return res;
        res = res * 10 + c - '0';
    }
}

struct Tree
{
    int w, b, id, key;
    Tree() {}
    Tree(int w, int b, int id, int key): w(w), b(b), id(id), key(key) {}
    bool operator < (const Tree& other) const
    {
        if (key != other.key)
            return key < other.key;
        if (w + b != other.w + other.b)
            return w + b < other.w + other.b;
        return id < other.id;
    }
    Tree as_w() const
    {
        return Tree(w, b, id, w);
    }
    Tree as_b() const
    {
        return Tree(w, b, id, b);
    }
};

tuple<int, int, char> ans[300500];

void ml()
{
#ifdef LOCAL
    throw;
#endif
    vector<int> ar;
    while (true)
        ar.push_back(0);
}

void solve()
{
    static set<Tree> w_by_w, b_by_b, wb_by_w, wb_by_b;
    w_by_w.clear();
    b_by_b.clear();
    wb_by_w.clear();
    wb_by_b.clear();
    int n = read();
    For(i, n)
    {
        int w = read();
        int b = read();
        if (w && !b)
            w_by_w.emplace(w, b, i, w);
        if (!w && b)
            b_by_b.emplace(w, b, i, b);
        if (w && b)
        {
            wb_by_w.emplace(w, b, i, w);
            wb_by_b.emplace(w, b, i, b);
        }
    }
    int t = 0;
    while (true)
    {
        Tree cur((int)1e9, (int)1e9, -1, (int)1e9);
        if (!w_by_w.empty())
            cur = min(cur, *w_by_w.begin());
        if (!b_by_b.empty())
            cur = min(cur, *b_by_b.begin());
        if (cur.id == -1)
            break;
        if (cur.w + cur.b > 1)
        {
            printf("No\n");
            return;
        }
        if (cur.w)
        {
            w_by_w.erase(cur);
            Tree cur2(-1, -1, -1, -1);
            if (!w_by_w.empty())
                cur2 = max(cur2, *w_by_w.rbegin());
            if (!wb_by_w.empty())
                cur2 = max(cur2, *wb_by_w.rbegin());
            if (cur2.id == -1)
            {
                printf("No\n");
                return;
            }
            if (cur2.b) {
                wb_by_w.erase(cur2.as_w());
                wb_by_b.erase(cur2.as_b());
            }
            else
                w_by_w.erase(cur2.as_w());
            ans[t++] = { cur.id, cur2.id, 'W' };
            --cur2.w;
            if (cur2.w && !cur2.b)
                w_by_w.emplace(cur2.as_w());
            if (!cur2.w && cur2.b)
                b_by_b.emplace(cur2.as_b());
            if (cur2.w && cur2.b) {
                wb_by_w.emplace(cur2.as_w());
                wb_by_b.emplace(cur2.as_b());
            }
        }
        else
        {
            b_by_b.erase(cur);
            Tree cur2(-1, -1, -1, -1);
            if (!b_by_b.empty())
                cur2 = max(cur2, *b_by_b.rbegin());
            if (!wb_by_b.empty())
                cur2 = max(cur2, *wb_by_b.rbegin());
            if (cur2.id == -1)
            {
                printf("No\n");
                return;
            }
            if (cur2.w) {
                wb_by_w.erase(cur2.as_w());
                wb_by_b.erase(cur2.as_b());
            }
            else
                b_by_b.erase(cur2.as_b());
            ans[t++] = { cur.id, cur2.id, 'B' };
            --cur2.b;
            if (cur2.w && !cur2.b)
                w_by_w.emplace(cur2.as_w());
            if (!cur2.w && cur2.b)
                b_by_b.emplace(cur2.as_b());
            if (cur2.w && cur2.b) {
                wb_by_w.emplace(cur2.as_w());
                wb_by_b.emplace(cur2.as_b());
            }
        }
    }
    if (t + 1 != n)
    {
        printf("No\n");
        return;
    }
    printf("Yes\n");
    For(i, t) {
        int x, y;
        char c;
        tie(x, y, c) = ans[i];
        printf("%d %d %c\n", x + 1, y + 1, c);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = read();
    For(i, t)
        solve();
#ifdef LOCAL
    printf("\n\n%.3f s", (double)clock() / CLOCKS_PER_SEC);
#endif
    return 0;
}