#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <tuple>
using namespace std;

typedef long long lint;
#define For(i, n) for (int i = 0; i < (n); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) (int)((v).size())

int read()
{
    char c;
    while (true)
    {
        c = getchar();
        if ('0' <= c && c <= '9')
            break;
    }
    int res = c - '0';
    while (true)
    {
        c = getchar();
        if (!('0' <= c && c <= '9'))
            return res;
        res = res * 10 + c - '0';
    }
}

struct Tree
{
    int w, b, id, key;
    Tree() {}
    Tree(int w, int b, int id, int key) : w(w), b(b), id(id), key(key) {}
    bool operator < (const Tree& other) const
    {
        if (key != other.key)
            return key < other.key;
        if (w + b != other.w + other.b)
            return w + b < other.w + other.b;
        return id < other.id;
    }
    Tree as_w() const
    {
        return Tree(w, b, id, w);
    }
    Tree as_b() const
    {
        return Tree(w, b, id, b);
    }
};

#ifdef LOCAL
tuple<int, int, char> ans[30500];
#else
tuple<int, int, char> ans[300500];
#endif
set<Tree> w_trees, b_trees;

void ml()
{
#ifdef LOCAL
    throw;
#endif
    vector<int> ar;
    while (true)
        ar.push_back(0);
}

void insert(const Tree& tree)
{
    if (tree.w)
        w_trees.insert(tree.as_w());
    if (tree.b)
        b_trees.insert(tree.as_b());
}

void erase(const Tree& tree)
{
    if (tree.w)
        w_trees.erase(tree.as_w());
    if (tree.b)
        b_trees.erase(tree.as_b());
}

void solve()
{
    w_trees.clear();
    b_trees.clear();
    int n = read();
    int s = 0;
    For(i, n)
    {
        Tree cur;
        cur.w = read();
        cur.b = read();
        s += cur.w + cur.b;
        cur.id = i;
        insert(cur);
    }
    if (s != (n - 1) * 2)
    {
        printf("No\n");
        return;
    }
    int t = 0;
    while (true)
    {
        if (!w_trees.empty() && w_trees.begin()->w == 1 && w_trees.begin()->b == 0)
        {
            Tree cur1 = *w_trees.begin();
            erase(cur1);
            if (w_trees.empty())
            {
                printf("No\n");
                return;
            }
            Tree cur2 = *w_trees.rbegin();
            ans[t++] = { cur1.id, cur2.id, 'W' };
            erase(cur2);
            --cur2.w;
            insert(cur2);
        }
        else if (!b_trees.empty() && b_trees.begin()->w == 0 && b_trees.begin()->b == 1)
        {
            Tree cur1 = *b_trees.begin();
            erase(cur1);
            if (b_trees.empty())
            {
                printf("No\n");
                return;
            }
            Tree cur2 = *b_trees.rbegin();
            ans[t++] = { cur1.id, cur2.id, 'B' };
            erase(cur2);
            --cur2.b;
            insert(cur2);
        }
        else if (w_trees.empty() && b_trees.empty())
            break;
        else
        {
            printf("No\n");
            return;
        }
    }
    if (t + 1 != n)
    {
        printf("No\n");
        return;
    }
    printf("Yes\n");
    For(i, t) {
        int x, y;
        char c;
        tie(x, y, c) = ans[i];
        printf("%d %d %c\n", x + 1, y + 1, c);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = read();
    For(i, t)
        solve();
#ifdef LOCAL
    printf("\n\n%.3f s", (double)clock() / CLOCKS_PER_SEC);
#endif
    return 0;
}