#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

const long long INF = 1e18;

vector<vector<pair<long long, long long>>>g;

struct vertex
{
    long long from;
    long long w;
    long long dist;
    vector<pair<long long, long long>>par;
    vertex()
    {
        from = -1;
        dist = INF;
    }
};

vector<vertex>d;
vector<long long>ans;
vector<long long>flag;
long long raz = -1;
long long coun = 0;

void dfs(long long v, long long ma, long long mi, long long depth)
{
    flag.push_back(v);
    if(v == 0 && ma - mi > raz)
    {
        ans = flag;
        raz = ma - mi;
    }
    for(auto u : d[v].par)
    {
        dfs(u.first, max(ma, u.second), min(mi, u.second), depth + 1);
    }

    flag.pop_back();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long n, m;
    cin >> n >> m;

    g.resize(n);
    d.resize(n);

    for(int i = 0; i < m; i++)
    {
        long long from, to, c;
        cin >> from >> to >> c;
        from--;
        to--;
        g[from].push_back(make_pair(to, c));
        g[to].push_back(make_pair(from, c));
    }

    d[0].dist = 0;

    queue<long long>q;
    q.push(0);
    while(!q.empty())
    {
        long long v = q.front();
        //cout << v << endl;
        q.pop();
        for(auto u : g[v])
        {
            if(d[u.first].dist >= d[v].dist + 1)
            {
                q.push(u.first);

                if(d[u.first].dist == d[v].dist + 1)
                {
                    if(u.first == n-1)
                        coun++;
                    d[u.first].par.push_back(make_pair(v, u.second));
                }else{
                    if(u.first == n-1)
                        coun = 1;
                    d[u.first].dist = d[v].dist + 1;
                    d[u.first].par.clear();
                    d[u.first].par.push_back(make_pair(v, u.second));
                }
            }
        }
    }

    //cout << 1488 << endl;
    dfs(n-1, -1, INF, 0);
    cout << coun << '\n';
    for(int i = ans.size() - 1; i > -1; i--)
        cout << ans[i] + 1 << " ";

}
