﻿#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;


ll dt[50][50];



vector<int> dx = { -1, 0,1, 0 };
vector<int> dy = { 0, -1, 0, 1 };

bool is_max(int y, int x) {
	bool ok = x > 0 && x < 20 && y > 0 && y < 20;

	if (!ok) {
		return false;
	}

	for (int i = 0; i < 4; i++) {
		int nx = x + dx[i];
		int ny = y + dy[i];

		ok &= (dt[y][x] > dt[ny][nx]);
	}

	return ok;
}


bool is_min(int y, int x) {
	bool ok = x > 0 && x < 20 && y > 0 && y < 20;


	if (!ok) {
		return false;
	}

	for (int i = 0; i < 4; i++) {
		int nx = x + dx[i];
		int ny = y + dy[i];

		ok &= (dt[y][x] < dt[ny][nx]);
	}

	return ok;
}

bool is_eq(int y, int x) {
	bool ok = 1;

	for (int i = 0; i < 4; i++) {
		int nx = x + dx[i];
		int ny = y + dy[i];

		if (nx >= 0 && nx <= 20 && ny >= 0 && ny <= 20) {
			ok &= (dt[y][x] == dt[ny][nx]);
		}
	}

	return ok;
}

ll func(int x, int y) {
	//return (x - 3)*(x - 5)*(y - 3)*(y - 5)*(y - 7)*(y - 9)*(y-1);
	//return (x - 1)*(x - 3)*(x - 5)*(y - 1)*(y - 3)*(y - 5);


	//return (x - 3)*(x + 5)*(y + 3)*(y + 5)*(y - 7)*(y - 9);

	return (3 - x)*(x - 5)*(y - 3)*(y - 5)*(y - 7)*(y - 9);
	//;

	//return (x + y + 16)*(x + y + 18)*(x + y - 16)*(x + y - 18); //110
	//return (x + 1)*(x + 3)*(x + 5)*(x + 7)*(y + 1)*(y + 3);
	//return (x + 1)*(x + 3)*(x + 5)*(y - 1)*(y - 3)*(y - 5);

	//return (x + y - 1)*(x + y - 3)*(x + y + 1)*(x + y + 3);

	//return pow((x - 3), 4) + (y - 5) * (y - 5);
}

void solve() {
	for (int i = -10; i <= 10; i++) {
		for (int j = -10; j <= 10; j++) {
			dt[i + 10][j + 10] = func(i, j);
			assert(dt[i + 10][j + 10] < INT_MAX);
			assert(dt[i + 10][j + 10] > INT_MIN);
		}
	}


	int cnt_max = 0, cnt_min = 0, cnt = 0;

	for (int i = 0; i <= 20; i++) {
		for (int j = 0; j <= 20; j++) {
			if (dt[i][j] != 0) {
				if (dt[i][j] < 0)
					cout << "-" << ' ';
				else
					cout << "+" << ' ';
			}
			else
				cout << 0 << ' ';
		}
		cout << en;
	}

	for (int i = -10; i <= 10; i++) {
		for (int j = -10; j <= 10; j++) {
			int y = i + 10;
			int x = j + 10;

			cnt_max += is_max(y, x);
			cnt_min += is_min(y, x);
			cnt += is_eq(y, x);
		}
	}

	cout << "Multiple local maxima = " << (cnt_max > 1 ? "YES" : "NO") << en;
	cout << "Multiple local minima = " << (cnt_min > 1 ? "YES" : "NO") << en;
	cout << "Plateaus = " << (cnt > 0 ? "YES" : "NO") << en;
}

void solve_norm() {
	string mx, mn, plat;
	cin >> mx >> mx >> mx >> mx;
	cin >> mn >> mn >> mn >> mn;
	cin >> plat >> plat;
	//cout << mx << ' ' << mn << ' ' << plat << en;

	bool is_max = (mx == "Yes");
	bool is_min = (mn == "Yes");
	bool is_plat = (plat == "Yes");

	vec<string>ans = {
		"x 3 - 4 ^ y -5 + 2 ^ +", //000
		"1", //001
		"x y + 1 - x y + 3 - *", //010 (x + y - 1)*(x + y - 3);
		"3 x - x 5 - y 3 - y 5 - y 7 - y 9 - * * * * *", //011 (3 - x)*(x - 5)*(y - 3)*(y - 5)*(y - 7)*(y - 9)
		"1 x - y - x y + 3 - *", //100 (1 - x - y)*(x + y - 3)
		"x 3 - x 5 - y 3 - y 5 - y 7 - y 9 - * * * * *", //101 (x - 3)*(x - 5)*(y - 3)*(y - 5)*(y - 7)*(y - 9)
		"x y + 1 - x y + 3 - * x y + 1 + * x y + 3 + *", //110 (x + y - 1)*(x + y - 3)*(x + y + 1)*(x + y + 3)
		"x 1 - x 3 - * x 5 - * y 1 - * y 3 - * y 5 - *", //111 (x - 1)*(x - 3)*(x - 5)*(y - 1)*(y - 3)*(y - 5)
	};

	int mask = is_max * 4 + is_min * 2 + is_plat;
	cout << ans[mask];

}

int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		//solve();
		solve_norm();
	}

}