﻿#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <array>
#include <set>
#include <list>
#include <cmath>
#include <string>
#include <bitset>
#include <queue>
#include <stack>
#include <unordered_map>
#include <map>
#include <iterator>
#ifdef DEBUG__
#include <chrono>
#define FILE__ "test"
#else
//#define FILE__ "negcycle"
#endif

#define int long long
#define float double
using namespace std;

#define loop(i,start,end) for(auto i = start;i < end;i ++)
#define loopi(end) loop(i,0,end)
#define loopj(end) loop(j,0,end)

#define FIRST_SOLUTION__
#ifdef FIRST_SOLUTION__

void solve()
{
	struct point {
		int max;
		int min;
		int v;
		int c;
		point* prev;
	};

	int n, m;
	cin >> n >> m;
	std::vector<vector<std::pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {

		int c1, c2, w;
		cin >> c1 >> c2 >> w;
		g[c1 - 1].push_back({ c2 - 1, w });
		g[c2 - 1].push_back({ c1 - 1, w });
	}
	std::deque<point> q;
	q.push_back({ std::numeric_limits<int32_t>::min(), std::numeric_limits<int32_t>::max(), 0, 0, 0 });

	std::vector<point> u(n, { std::numeric_limits<int32_t>::min(), std::numeric_limits<int32_t>::max(), 0, -1, 0 });
	u[0] = q.front();
	while (!q.empty()) {

		auto data = q.front();
		q.pop_front();

		for (auto& v : g[data.v]) {

			if ((u[v.first].c != -1 && u[v.first].c != data.c + 1) ||
				(std::numeric_limits<int32_t>::max() != u[v.first].min &&
				(u[v.first].max - u[v.first].min) >=
				(std::max(v.second, data.max) - std::min(v.second, data.min))))
				continue;

			q.push_back({
				std::max(v.second, data.max),
				std::min(v.second, data.min),
				v.first,
				data.c + 1,
				new point{
					data.max, data.min, data.v, data.c, data.prev}
			});

			u[v.first] = q.back();
		}
	}

	std::vector<int> path(1, u.back().v + 1);
	auto prev = u.back().prev;
	while (prev) {
		path.push_back(prev->v + 1);
		prev = prev->prev;
	}

	std::reverse(path.begin(), path.end());
	cout << path.size() - 1 << endl;
	for (auto& pa : path)
		cout << pa << " ";

}


#else



void solve()
{
	std::vector<std::vector<int>> plane(21, std::vector<int>(21, 0));
	char useless_buf[64];
	char useable_buf[16];
	std::bitset<3> params;
	//for (int i = 0; i < 3; ++i) {
	//	scanf("%[^:]: %s", useless_buf, useable_buf);
	//	params.set(i, useable_buf[0] == 'Y');
	//}

	for (int i = 0; i < 21; ++i) {
		for (int j = 0; j < 21; ++j) {
			int x = j - 10;
			int y = i - 10;
			plane[i][j] = (x * x * x * x - 4 * x * x) * (y * y * y * y - 4 * y * y);
		}
	}

	/*if (params[0]) {

		plane[21 / 2][21 / 2] += 3;
		plane[21 / 2][21 / 2 + 3] += 3;
	}

	if (params[1]) {

		plane[21 / 2 + 3][21 / 2] -= 3;
		plane[21 / 2 + 3][21 / 2 + 3] -= 3;
	}*/

	for (auto& m : plane) {
		for (auto& l : m)
			cout << l << " ";
		cout << endl;
	}



	return;
}
#endif

std::int32_t main() {
#ifdef DEBUG__
	auto timestamn = std::chrono::system_clock::now();
#else
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
#endif
#ifdef FILE__
	freopen(FILE__".in", "r", stdin);
	//freopen(FILE__".out", "w", stdout);
#endif
	solve();
#ifdef DEBUG__
	cout << endl << "Time elansed: " << chrono::duration_cast<chrono::milliseconds>(std::chrono::system_clock::now() - timestamn).count() << " ms" << endl;
#endif
	return 0;
}
