#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimization("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define int long long
#define all(x) (x).begin(), (x).end()
using namespace std;

const int MOD = 1e9 + 7, P = 31, INF = 1e9, MAXN = 1e2, MAXM = 1e4;
const double EPS = 1e-6;

void find_paths(int v, vector<int>& d, vector<vector<pair<int,int>>>& f) {
	d[v] = 0;
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		for (auto to : f[v]) {
			if (d[to.first] > d[v] + 1) {
				d[to.first] = d[v] + 1;
				q.push(to.first);
			}
		}
	}
}

void find_min_paths(int v, vector<int>& mn, vector<int>& p, vector<vector<pair<int, int>>>& f, vector<int>& d1){
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		for (auto to : f[v]) {
			if (d1[v] + 1 == d1[to.first] && mn[to.first] > min(mn[v], to.second)) {
				mn[to.first] = min(mn[v], to.second);
				p[to.first] = v;
				q.push(to.first);
			}
		}
	}
}

void find_max_paths(int v, vector<int>& mx, vector<int>& p, vector<vector<pair<int, int>>>& f, vector<int>& d1){
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		for (auto to : f[v]) {
			if (d1[v] + 1 == d1[to.first] && mx[to.first] < max(mx[v], to.second)) {
				mx[to.first] = max(mx[v], to.second);
				p[to.first] = v;
				q.push(to.first);
			}
		}
	}
}

vector<int> Rev(int from, int to, vector<int>& p) {
	int v = to;
	vector<int> res;
	while (v != from) {
		res.push_back(p[v]);
		v = p[v];
	}
	return res;
}

signed main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m, a, b, c;
	cin >> n >> m;
	vector<vector<pair<int,int>>> f(n);
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> c;
		f[a - 1].push_back({ b - 1, c });
		f[b - 1].push_back({ a - 1, c });
	}
	vector<int> d1(n, INF), dn(n, INF);
	vector<int> mn1(n, INF), mx1(n), mnn(n, INF), mxn(n), pmn1(n, -1), pmnn(n, -1), pmxn(n, -1), pmx1(n, -1);
	find_paths(0, d1, f);
	find_paths(n - 1, dn, f);
	find_min_paths(0, mn1, pmn1, f, d1);
	find_min_paths(n - 1, mnn, pmnn, f, dn);
	find_max_paths(0, mx1, pmx1, f, d1);
	find_max_paths(n - 1, mxn, pmxn, f, dn);

	int ans_mx = 0, ans_v = 0, k = d1[n - 1];
	bool is_mn1 = 0;
	for (int v = 0; v < n; v++) {
		if (d1[v] + dn[v] == k) {
			if (ans_mx < mx1[v] - mnn[v]) {
				ans_mx = mx1[v] - mnn[v];
				ans_v = v;
				is_mn1 = 0;
			}
			if (ans_mx < mxn[v] - mn1[v]) {
				ans_mx = mxn[v] - mn1[v];
				ans_v = v;
				is_mn1 = 1;
			}
		}
	}
	vector<int> ans, it, rev;
	if (is_mn1) {
		it = Rev(0, ans_v, pmn1);
		rev = Rev(n - 1, ans_v, pmxn);
	}
	else {
		it = Rev(0, ans_v, pmx1);
		rev = Rev(n - 1, ans_v, pmnn);
	}
	for (int i = (int)it.size() - 1; i >= 0; i--)
		ans.push_back(it[i]);
	ans.push_back(ans_v);
	for (int i = 0; i < rev.size(); i++) {
		ans.push_back(rev[i]);
	}
	cout << ans.size() << '\n';
	for (int x : ans)
		cout << x + 1 << ' ';
}