#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define float double
#define double long double

using namespace std;

const int N = 26;

struct Node {
    vector<Node*> children;
    int name = -1, count = 0;

    Node(int name) : name{name} {
        children.resize(26);
    }
};

void add(Node* node, string& s, int i = 0) {
    node->count++;
    //cerr << "node: " << char('a' + node->name) << ' ' << node->count << ' ' << s << ' ' << i << endl;
    if (i == s.size()) {
        return;
    }
    int j = s[i] - 'a';
    if (!node->children[j]) {
        node->children[j] = new Node(j);
    }
    add(node->children[j], s, i + 1);
}

void rm(Node *node, int k, int& ans) {
    //cerr << "rm node: " << char('a' + node->name) << ' ' << node->count << endl;
    for (auto child : node->children) {
        if (child && child->count > k) {
            rm(child, k, ans);
        }
    }
    node->count = 0;
    vector<pair<int, int>> a;
    for (auto child : node->children) {
        if (child) {
            node->count += child->count;
            a.push_back({child->count, child->name});
        }
    }
    sort(a.rbegin(), a.rend());
    //for (auto p : a) {
    //    cerr << p.first << ' ' << char('a' + p.second) << endl;
    //}
    for (auto p : a) {
        if (node->count > k) {
            node->count -= p.first;
            ans++;
            //cerr << "rm " << char('a' + p.second) << ' ' << -p.first << ' ' << ans << endl;
        }
        else {
            break;
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed, ios::floatfield);
    cout.precision(8);
    cerr.tie(0);
    cerr.setf(ios::fixed, ios::floatfield);
    cerr.precision(16);
    int n, k;
    cin >> n >> k;
    auto root = new Node(-1);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(root, s);
    }
    int ans = 0;
    rm(root, k, ans);
    cout << ans + 1 << endl;
}
