﻿#define _USE_MATH_DEFINES

#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <assert.h>

#pragma warning(disable : 4996)

#pragma comment(linker, "/STACK:16777216")

#define en "\n"
#define for0(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e9 + 5;
const ll MOD = 1e9 + 7;
const int NMAX = 3e5 + 1337;
double EPS = 1e-5;
const int MAX_LOGN = 18;

int free_node = 1;
int n, k;

bool used[NMAX];

struct Node
{
	int next[28] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
	int prev = -1;
	int count_in_subtree = 0;
	int count_terminal = 0;
};

Node bor[NMAX];
ll ans = 0;
priority_queue<pair<int, int>> q;
void go(int cur)
{
	if (bor[cur].count_in_subtree <= k)
		q.push({ bor[cur].count_in_subtree , cur });
	
	for (int c = 'a'; c <= 'z'; c++)
	{
		int cn = c - 'a';
		if (bor[cur].next[cn] != 0)
		{
			go(bor[cur].next[cn]);
		}
	}
}

void mark_as_used(int cur)
{
	if (used[cur])
		return;
	used[cur] = 1;
	for (int c = 'a'; c <= 'z'; c++)
	{
		int cn = c - 'a';
		if (bor[cur].next[cn] != 0)
		{
			mark_as_used(bor[cur].next[cn]);
		}
	}
}

void update(int cur)
{
	int _cur = cur;
	int cnt = bor[_cur].count_in_subtree;
	while (_cur != -1)
	{
		int prv = bor[_cur].prev;
		if (prv != -1)
		{
			bor[prv].count_in_subtree -= cnt;
			if (bor[prv].count_in_subtree == 0)
			{
				used[prv] = 1;
			}
			if (bor[prv].count_in_subtree <= k && bor[prv].count_in_subtree > 0 && !used[prv])
			{
				q.push({ bor[prv].count_in_subtree , prv });
			}
		}
		_cur = prv;
	}

	mark_as_used(cur);
}

void solve()
{
	int root = free_node++;
	cin >> n >> k;

	for (int i = 0; i < n; i++)
	{
		string s; cin >> s;
		int cur = root;
		for (char c : s)
		{
			int cn = c - 'a';
			if (bor[cur].next[cn] != 0)
			{
				bor[cur].count_in_subtree++;
				cur = bor[cur].next[cn];
			}
			else
			{
				int nxt = free_node++;
				bor[cur].next[cn] = nxt;
				bor[cur].count_in_subtree++;
				bor[nxt].prev = cur;
				cur = nxt;
			}
		}
		bor[cur].count_in_subtree++;
		bor[cur].count_terminal++;
	}

	go(root);

	while (!q.empty())
	{
		auto pp = q.top(); q.pop();
		int cur = pp.second;
		if (used[cur]) continue;
		
		update(cur);
		ans++;
	}

	cout << ans << en;
}

int main() {

	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12); //anagrams.in
	//freopen("little.in", "r", stdin);
	//freopen("little.out", "w", stdout);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}