// @author: Nayami
#pragma GCC optimise ("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")
#include <bits/stdc++.h>
using namespace std;

#define debug(x) cerr << #x << " = " << x << '\n';
#define int long long
#define all(h) h.begin  (), h.end()
#define fi first
#define se second

int const N = 1e5;
vector<pair<int,int>> gr[N + 1];
int len[N + 1];
vector<int> levels[N + 1];

void bfs(int v){
    len[v] = 1;
    levels[1].push_back(v);
    queue<int> q;
    q.push(v);
    while(!q.empty()){
        int u = q.front();
        q.pop();
        for (auto & to : gr[u]){
            if (!len[to.fi]){
                len[to.fi] = len[u] + 1;
                levels[len[u] + 1].push_back(to.fi);
                q.push(to.fi);
            }
        }
    }
}

void calc(int n){
    // (min_e, max_e) with max_e

    vector<pair<int,int>> max_e(n + 1, {1e18, -1e18});
    vector<pair<int,int>> min_e(n + 1, {1e18, -1e18});
    vector<pair<int,int>> dp(n + 1, {1e18, -1e18});
    vector<int> pr_1(n + 1), pr_2(n + 1), pr_3(n + 1);
    vector<int> t(n + 1, 0);
    pr_1[1] = -1;
    pr_2[1] = -1;
    pr_3[1] = -1;
    for (int l = 1; l < len[n]; ++l){
        for (auto & v : levels[l]){
            for (auto & to : gr[v]){
                int u = to.fi;
                int c = to.se;
                if (len[u] == len[v] + 1){
                    if (max(c ,max_e[v].se) > max_e[u].se){
                        pair<int,int> new_mx = {min(c, max_e[v].fi), max(c, max_e[v].se)};
                        max_e[u] = new_mx;
                        pr_2[u] = v;
                    }
                    if (min(c, min_e[v].fi) < min_e[u].fi){
                        pair<int,int> new_mn = {min(c, min_e[v].fi), max(c, min_e[v].se)};
                        min_e[u] = new_mn;
                        pr_3[u] = v;
                    }
                    int new_mx = max(c, dp[v].se);
                    int new_mn = min(c, dp[v].fi);
                    if (new_mx - new_mn > dp[u].se - dp[u].fi){
                        pr_1[u] = v;
                        dp[u].se = new_mx;
                        dp[u].fi = new_mn;
                    }
                    new_mx = max(c, max_e[v].se);
                    new_mn = min(c, max_e[v].fi);
                    if (new_mx - new_mn > dp[u].se - dp[u].fi){
                        pr_1[u] = u;
                        dp[u].se = new_mx;
                        dp[u].fi = new_mn;
                        t[u] = 2;
                    }
                    new_mx = max(c, min_e[v].se);
                    new_mn = min(c, min_e[v].fi);
                    if (new_mx - new_mn > dp[u].se - dp[u].fi){
                        pr_1[u] = u;
                        dp[u].se = new_mx;
                        dp[u].fi = new_mn;
                        t[u] = 3;
                    }

                }
            }
        }
    }
    int tmp = n;
    vector<int> path;
    while (tmp != -1){
        path.push_back(tmp);
        if (t[tmp] == 0){
            tmp = pr_1[tmp];
        }
        if (t[tmp] == 2){
            t[pr_2[tmp]] = 2;
            tmp = pr_2[tmp];
        }
        if (t[tmp] == 3){
            t[pr_3[tmp]] = 3;
            tmp = pr_3[tmp];
        }
    }
    cout << path.size() - 1 << '\n';
    for (int i = path.size() - 1; i > -1; --i) cout << path[i] << ' ';
}



signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i){
        int v, u, c;
        cin >> v >> u >> c;
        gr[v].emplace_back(make_pair(u, c));
        gr[u].emplace_back(make_pair(v, c));
    }
    bfs(1);
    calc(n);

    return 0;
}