﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;

namespace Olimp
{
    class Program
    {
        static void Main()
        {
            var inputParams = Console.ReadLine().Split().Select(x => int.Parse(x)).ToArray();
            var height = inputParams[0];
            var width = inputParams[1];
            var usedByFMap = new int[height, width];
            var usedByQMap = new int[height, width];
            var picture = new List<string>();
            var countF = 0;
            var countQ = 0;
            for (int i = 0; i < height; i++)
            {
                picture.Add(Console.ReadLine());
            }

            for (int i = 0; i < height - 4; i++)
            {
                for (int j = 0; j < width - 2; j++)
                {
                    if (usedByFMap[i, j] == 0 && ItIsF(picture, usedByFMap, i, j))
                        countF++;
                }
            }

            for (int i = 0; i < height - 4; i++)
            {
                for (int j = 0; j < width - 2; j++)
                {
                    if (GetQThumbprint(picture, i, j).All(x => x == '#'))
                        if (usedByFMap[i, j] == 0 && ItIsQ(picture, usedByFMap, i, j))
                            countQ++;
                }
            }

            Console.WriteLine($"{countQ} {countF}");
        }

        static bool ItIsF(List<string> map, int[,] usedMap, int x, int y)
        {
            if (IsSharp(map[x][y]) &&
                IsSharp(map[x][y + 1]) &&
                IsSharp(map[x][y + 2]) &&
                IsSharp(map[x + 1][y]) &&
                IsSharp(map[x + 2][y]) &&
                IsSharp(map[x + 2][y + 1]) &&
                IsSharp(map[x + 3][y]) &&
                IsSharp(map[x + 4][y]) &&
                !IsSharp(map[x + 1][y + 1]))
            {
                usedMap[x, y]++;
                usedMap[x, y + 1]++;
                usedMap[x, y + 2]++;
                usedMap[x + 1, y]++;
                usedMap[x + 2, y]++;
                usedMap[x + 2, y + 1]++;
                usedMap[x + 3, y]++;
                usedMap[x + 4, y]++;
                return true;
            }

            return false;
        }

        static bool ItIsQ(List<string> map, int[,] usedMap, int x, int y)
        {
            if (IsSharp(map[x][y]) && usedMap[x, y] == 0 &&
                IsSharp(map[x][y + 1]) && usedMap[x, y + 1] == 0 &&
                IsSharp(map[x][y + 2]) && usedMap[x, y + 2] == 0 &&
                IsSharp(map[x + 1][y]) && usedMap[x + 1, y] == 0 &&
                IsSharp(map[x + 1][y + 2]) && usedMap[x + 1, y] == 0 &&
                IsSharp(map[x + 2][y]) && usedMap[x + 2, y] == 0 &&
                IsSharp(map[x + 2][y + 1]) && usedMap[x + 2, y + 1] == 0 &&
                IsSharp(map[x + 2][y + 2]) && usedMap[x + 2, y + 2] == 0 &&
                IsSharp(map[x + 3][y + 2]) && usedMap[x + 3, y + 2] == 0 &&
                IsSharp(map[x + 4][y + 2]) && usedMap[x + 4, y + 2] == 0 &&
                !IsSharp(map[x + 1][y + 1]))
            {
                usedMap[x, y]++;
                usedMap[x, y + 1]++;
                usedMap[x, y + 2]++;
                usedMap[x + 1, y]++;
                usedMap[x + 1, y + 2]++;
                usedMap[x + 2, y]++;
                usedMap[x + 2, y + 1]++;
                usedMap[x + 2, y + 2]++;
                usedMap[x + 3, y + 2]++;
                usedMap[x + 4, y + 2]++;

                return true;
            }

            return false;
        }

        static bool IsSharp(char c)
        {
            return c == '#';
        }

        static char[] GetQThumbprint(List<string> map, int x, int y)
        {
            return new[]
            {
                map[x][y],
                map[x][y + 1],
                map[x][y + 2],
                map[x + 1][y],
                map[x + 1][y + 2],
                map[x + 2][y],
                map[x + 2][y + 1],
                map[x + 2][y + 2],
                map[x + 3][y + 2],
                map[x + 4][y + 2]
            };
        }
    }
}