class Node:
  def __init__(self, key="", parent=None):
    self.children = {}
    self.count = 0
    self.parent = parent
    self.key = key

  def push(self, word):
    self.count += 1 
    if len(word) == 0:
      return

    key = word[0]
    child = self.children.get(key)
    if child is None:
      child = Node(key, self)
      self.children[key] = child
    child.push(word[1:])

  def findMax(self, m):
    if self.count == 0 or (self.count > m and len(self.children) == 0):
      return None

    if self.count <= m:
      return self
    
    max = None
    for key in self.children:
      _max = self.children[key].findMax(m)
      if _max is None: continue
      if max is None or _max.count > max.count:
        max = _max
      
    return max

  def print(self):
    print(" ", self.count)
    for key in self.children:
      print (key, self.children[key].count)

  def remove(self):
    cnt = self.count
    el = self
    while el is not None:
      el.count -= cnt
      el = el.parent

n, m = input().split()
n = int(n)
m = int(m)

tree = Node()
for i in range(n):
  tree.push(input())

sum = 0
child = tree.findMax(m)
while child is not None:
  child.remove()
  child = tree.findMax(m)
  sum += 1

print(sum)