﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using static System.Console;

namespace A
{
    internal static class Program
    {
        private const long Mod = 1_000_000_000 + 7;

        
        private static void Main()
        {
            var maxima = Input();
            var minima = Input();
            var plato = Input();

            var isMaxima = maxima.Last() == 's';
            var isMinima = minima.Last() == 's';
            var isPlato = plato.Last() == 's';

            if (isMaxima)
            {
                if (isMinima)
                {
                    if (isPlato)
                    {
                        Out.WriteLine("No solution");
                    }
                    else
                    {
                        Out.WriteLine("No solution");
                    }
                }
                else
                {
                    if (isPlato)
                    {
                        Out.WriteLine("No solution");
                    }
                    else
                    {
                        Out.WriteLine("No solution");
                    }
                }
            }
            else
            {
                if (isMinima)
                {
                    if (isPlato)
                    {
                        Out.WriteLine("No solution");
                    }
                    else
                    {
                        Out.WriteLine("No solution");
                    }
                }
                else
                {
                    if (isPlato)
                    {
                        Out.WriteLine("1");
                    }
                    else
                    {
                        Out.WriteLine("x 3 - 4 ^ y -5 + 2 ^ +");
                    }
                }
            }
        }
        
        // private static void Main()
        // {
        //     var (n, m) = Input().As<long, long>();
        //
        //     var roads = new Dictionary<long, List<(long index, long cost)>>();
        //     for (var _ = 0; _ < m; _++)
        //     {
        //         var (i, j, cost) = Input().As<long, long, long>();
        //         if (!roads.ContainsKey(i))
        //             roads[i] = new List<(long index, long cost)>();
        //         roads[i].Add((j, cost));
        //
        //         if (!roads.ContainsKey(j))
        //             roads[j] = new List<(long index, long cost)>();
        //         roads[j].Add((i, cost));
        //     }
        //
        //     Out.WriteLine(FindShortestRouteLen(roads, n));
        // }

        private static long FindShortestRouteLen(Dictionary<long, List<(long index, long cost)>> graph,
            long end)
        {
            var visited = new HashSet<long>();

            var queue = new LinkedList<(long index, long depth)>();
            queue.AddFirst((1, 0));
            
            while (queue.Count != 0)
            {
                var curr = queue.First.Value;
                queue.RemoveFirst();

                
                foreach (var (index, cost) in graph[curr.index])
                {
                    if (!visited.Contains(index))
                        queue.AddLast((index, curr.depth + 1));
                }

                visited.Add(curr.index);
                if (curr.index == end)
                {
                    return curr.depth;
                }
            }

            return 0;
        }

        private static long Solve(long number)
        {
            if (number == 1)
                return 1;

            if (number == 2)
                return 1;

            var half = (number - 1) / 2;

            while (half != 1)
            {
                var gcd = Gcd(half, number);

                if (gcd == 1)
                    return half;
                half--;
            }

            return half;
        }

        public static long Gcd(long a, long b)
        {
            while (a != 0 && b != 0)
                if (a > b)
                    a %= b;
                else
                    b %= a;

            return a | b;
        }

        private static long GetC(long n, long M, long m, long c)
        {
            return (long)Math.Round(((float)n - m * M) / c);
        }

        #region stdutils

#if FILE_OUTOUT
        private static readonly string ProjectDirectory =
            Directory.GetParent(Environment.CurrentDirectory).Parent.Parent.FullName;

        private static readonly string OutPutFileName = Path.Combine(ProjectDirectory, "output.txt");
        private static readonly string InputFileName = Path.Combine(ProjectDirectory, "input.txt");

        static Program()
        {
            File.Delete(OutPutFileName);

            var writer = new StreamWriter(OutPutFileName, true);
            writer.AutoFlush = true;
            SetOut(writer);

            var reader = new StreamReader(InputFileName);
            SetIn(reader);
        }
#endif
        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static void Print(string value)
        {
            Out.WriteLine(value);
        }


        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static string Input()
        {
            return In.ReadLine()?.Trim() ?? throw new Exception("Empty input");
        }


        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static T As<T>(this string str) where T : IConvertible
        {
            if (typeof(T) == typeof(int))
                return (T)(object)int.Parse(str);
            if (typeof(T) == typeof(long))
                return (T)(object)long.Parse(str);
            if (typeof(T) == typeof(string))
                return (T)(object)str;
            if (typeof(T) == typeof(short))
                return (T)(object)short.Parse(str);

            return (T)Convert.ChangeType(str, typeof(T));
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static T[] AsArray<T>(this string str, char separator = ' ') where T : IConvertible
        {
            return str.Split(separator).Select(As<T>).ToArray();
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static (T1, T2) As<T1, T2>(this string str, char separator = ' ')
            where T1 : IConvertible where T2 : IConvertible
        {
            var items = str.Split(separator);

            return (items[0].As<T1>(), items[1].As<T2>());
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static (T1, T2, T3) As<T1, T2, T3>(this string str, char separator = ' ') where T1 : IConvertible
            where T2 : IConvertible
            where T3 : IConvertible
        {
            var items = str.Split(separator);

            return (items[0].As<T1>(), items[1].As<T2>(), items[2].As<T3>());
        }


        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        private static (T1, T2, T3, T4) As<T1, T2, T3, T4>(this string str, char separator = ' ')
            where T1 : IConvertible
            where T2 : IConvertible
            where T3 : IConvertible
            where T4 : IConvertible
        {
            var items = str.Split(separator);

            return (items[0].As<T1>(), items[1].As<T2>(), items[2].As<T3>(), items[3].As<T4>());
        }

        #endregion
    }
}