from typing import Dict, List


class PrefixTree:
    def __init__(self, char: str):
        self.char = char
        self.inner_count: int = 0
        self.next_nodes: Dict[str, PrefixTree] = dict()
        self.from_what: PrefixTree = None  # option
        self.is_visited = False
        self.is_deleted = False

    def add_file(self, filename):
        self.inner_count += 1
        if filename == '':
            return
        first_char = filename[0]
        if first_char not in self.next_nodes:
            self.next_nodes[first_char] = PrefixTree(first_char)
        next_node = self.next_nodes[first_char]
        next_node.add_file(filename[1:])
        next_node.from_what = self

    def __repr__(self):
        return "'" + self.char + "'"


split_char = ' '
(count, max_files) = [int(x) for x in input().split()]
tree = PrefixTree(' ')
for _ in range(count):
    raw = input()
    tree.add_file(raw)

result = 0
queue: List[PrefixTree] = [tree, ]
visited: List[PrefixTree] = []
while len(queue) > 0:
    node = queue.pop()
    if node.inner_count <= 0 or (
            node.from_what is not None and node.from_what.is_deleted):
        continue
    if node.inner_count <= max_files:
        result += 1
        past = node
        max_deleted = 0
        while past is not None and past.inner_count <= max_files and not past.is_deleted:
            past.is_deleted = True
            max_deleted = past.inner_count
            past.inner_count = 0
            past = past.from_what
        for v in visited:
            v.inner_count -= max_deleted
        continue
    node.is_visited = True
    visited.append(node)
    queue.append(node)
    next_nodes = [v for v in node.next_nodes.values()]
    next_nodes.sort(key=lambda x: x.inner_count)
    queue.extend(next_nodes)
print(result)
