﻿using System;
using System.Diagnostics.CodeAnalysis;

namespace Contest
{
    class Contest
    {
        private static bool[,] qShape = new bool[5, 3]
        {
            { true, true, true },
            { true, false, true },
            { true, true, true },
            { false, false, true },
            { false, false, true }
        };

        private static bool[,] fShape = new bool[5, 3]
        {
            { true, true, true },
            { true, false, false },
            { true, true, false },
            { true, false, false },
            { true, false, false }
        };

        private static void Main()
        {
            var dimensions = Console.ReadLine().Split();
            var n = int.Parse(dimensions[0]);
            var m = int.Parse(dimensions[1]);
            var matrix = new bool[n, m+3];
            var payRespects = 0;
            var qCounter = 0;

            for (var y = 0; y < n; y++)
            {
                var newLine = Console.ReadLine();
                for (var x = 0; x < m; x++)
                    matrix[y, x] = newLine[x] == '#';
            }

            for (var y = n - 1; y >= 0; y--)
            for (var x = m - 1; x >= 0; x--)
            {
                if (!matrix[y, x]) continue;
                var foundSym = FindAndRemoveLetter(x, y, matrix);
                
                if (foundSym == 'q')
                    qCounter++;
                else
                    payRespects++;
            }
            
            Console.WriteLine($"{qCounter} {payRespects}");
        }

        private static char FindAndRemoveLetter(int xDelta, int yDelta, bool[,] matrix)
        {
            var isF = false;
            if (matrix[yDelta,xDelta] && matrix[yDelta-1,xDelta] && matrix[yDelta-2, xDelta] && matrix[yDelta-2,xDelta+1] && matrix[yDelta-3, xDelta] && matrix[yDelta-4, xDelta] && matrix[yDelta-4,xDelta+1] && matrix[yDelta-4,xDelta+2] && !matrix[yDelta-3,xDelta+1])
            {
                isF = true;
                matrix[yDelta, xDelta] = false;
                matrix[yDelta-1,xDelta] = false; matrix[yDelta-2, xDelta] =false; matrix[yDelta-2,xDelta+1] =false; matrix[yDelta-3, xDelta] =false; matrix[yDelta-4, xDelta] =false; matrix[yDelta-4,xDelta+1] =false;
                matrix[yDelta - 4, xDelta + 2] = false;
            }

            else
            {
                matrix[yDelta, xDelta] = false;
                matrix[yDelta - 1, xDelta] = false;
                matrix[yDelta - 2, xDelta] = false;
                matrix[yDelta - 2, xDelta - 1] = false;
                matrix[yDelta - 2, xDelta - 2] = false;
                matrix[yDelta - 3, xDelta] = false;
                matrix[yDelta - 3, xDelta - 2] = false;
                matrix[yDelta - 4, xDelta] = false;
                matrix[yDelta - 4, xDelta - 1] = false;
                matrix[yDelta - 4, xDelta - 2] = false;
            }

            return isF ? 'f' : 'q';
        }
    }
}