﻿using System;

namespace L_Sharp
{
    class Program
    {
        static void outMass(char[,] mass, int n, int m)
        {
            for(int i = 0; i < n; i++)
            {
                Console.WriteLine();
                for(int j = 0; j < m; j++)
                {
                    Console.Write($"{mass[i, j]} ");
                }
            }
        }
        static bool formF(char[,] mass, int x, int y)
        {
            bool check = true;
            for(int i = 1; i < 5; i++)
            {
                if (mass[x + i, y] != '#') check = false;
            }
            if (mass[x, y + 1] != '#' || mass[x, y + 2] != '#') check = false;
            if (mass[x + 2, y + 1] != '#') check = false;
            return check;
        }
        static bool formQ(char[,] mass, int x, int y, int n)
        {
            if (x + 4 >= n) return false;
            bool check = true;
            for (int i = 0; i < 5; i++)
            {
                if (mass[x + i, y + 2] != '#') check = false;
            }
            if (mass[x + 1, y] != '#' || mass[x + 2, y] != '#') check = false;
            if (mass[x + 2, y + 1] != '#' || mass[x, y + 1] != '#') check = false;
            return check;
        }

        static void paintF(char[,] mass, int x, int y)
        {
            for (int i = 0; i < 5; i++)
            {
                mass[x + i, y] = 'f';
            }
            mass[x, y + 1] = 'f';
            mass[x, y + 2] = 'f';
            mass[x + 2, y + 1] = 'f';
        }
        static void paintQ(char[,] mass, int x, int y)
        {
            for (int i = 0; i < 5; i++)
            {
                mass[x + i, y + 2] = 'q';
            }
            for (int i = 0; i < 3; i++)
            {
                mass[x + i, y] = 'q';
            }
            mass[x, y + 1] = 'q';
            mass[x + 2, y + 1] = 'q';
        }

        static char checkLetter(char[,] mass, int x, int y, int n, int m)
        {
            if (formF(mass, x, y))
            {
                if (y < 2) return 'f';
                if (!formQ(mass, x + 3, y - 2, n)) return 'f';
                if (x > 3 && !formQ(mass, x - 3, y - 2, n)) return 'f';
                if (formQ(mass, x + 3, y - 2, n)) return '1';
                if (x > 3 && formQ(mass, x - 3, y - 2, n)) return '2';
            }
            else return 'q';
            return 'z';
        }
        static void Main(string[] args)
        {
            string [] x = Console.ReadLine().Split(' ');
            int n = Convert.ToInt32(x[0]);
            int m = Convert.ToInt32(x[1]);
            char[,] mass = new char[n, m];
            int q = 0, f = 0;

            for (int i = 0; i < n; i++)
            {
                string temp = Console.ReadLine();
                for(int j = 0; j < m; j++)
                {
                    mass[i,j] = temp[j];
                }
            }

            for(int i = 0; i < n; i++)
            {
                for(int j = 0; j < m; j++)
                {
                    char temp;
                    if (mass[i, j] == '#' && mass[i + 1, j + 1] == '.')
                    {
                        temp = checkLetter(mass, i, j, n, m);
                        if (temp == 'f')
                        {
                            paintF(mass, i, j);
                            f++;
                            //outMass(mass, n, m);
                        }
                        else if(temp == 'q')
                        {
                            paintQ(mass, i, j);
                            q++;
                            //outMass(mass, n, m);
                        }
                        else if(temp == '1')
                        {
                            paintQ(mass, i, j);
                            paintQ(mass, i + 3, j - 2);
                            q += 2;
                            //outMass(mass, n, m);
                        }
                        else if(temp == '2')
                        {
                            paintQ(mass, i - 3, j - 2);
                            paintQ(mass, i - 2, j + 1);
                            paintQ(mass, i + 2, j);
                            q += 3;
                            //outMass(mass, n, m);
                        }
                    }
                }
            }
            Console.WriteLine($"{q} {f}");
        }
    }
}
