import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        System.out.println(new Item(scanner.nextLine(), scanner.nextLine()).getAnswer());
    }

    private static class Item {
        private final int first_date;
        private final Type first_format;
        private final int second_date;
        private final Type second_format;

        public Item(String input1, String input2) {
            first_format = getFormat(input1);
            second_format = getFormat(input2);

            first_date = getDate(input1, first_format);
            second_date = getDate(input2, second_format);
        }

        private Type getFormat(String input) {
            return input.contains("BC") ? Type.BC : Type.AD;
        }

        private int getDate(String input, Type type) {
            return type == Type.BC ? Integer.parseInt(input.split(" ")[0]) : Integer.parseInt(input.split(" ")[1]);
        }

        public int getAnswer() {
            if (first_format == second_format) {
                return Math.max(first_date, second_date) - Math.min(first_date, second_date);
            } else {
                return first_date + second_date - 1;
            }
        }

        enum Type {
            BC,
            AD
        }
    }
}