#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <utility>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unordered_map<int, int> row;
typedef vector<row> graph;


// vector<vector<ll>> g;
// vector<char> used;
// vector<ll> mt;
struct elem {
	elem(int v = 0, int dist = 0, int min_c = 0, int max_c = 0)
		: vertex(v), dist(dist), min_c(min_c), max_c(max_c) {}

	int vertex;
	int dist;
	int min_c;
	int max_c;
};

ostream& operator<<(ostream& out, elem el) {
		out << el.vertex << " " << el.dist << " " << el.min_c << " " << el.max_c;
		return out;
}

int main()
{
  ios_base::sync_with_stdio(false);
  cin.tie();
  cout.tie();

  // ll n, l, v;
	// cin >> n >> l >> v;
	// vector<ll> vs(n);
	// for(int i = 0; i < n; ++i)
	// 	cin >> vs[i];
	

	// ld first_case = 0;
	// ld second_case = 0;
	// for(int i = 0; i < n; ++i) {
	// 	first_case += l / vs[i];
	// 	second_case += 2 * (l / (vs[i] + v));
	// }

	// cout << setprecision(9) << fixed << first_case / n << " " << second_case / n << endl;

	int n, m;
	cin >> n >> m;
	graph g(n);
	for(int i = 0; i < m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		--u;
		--v;
		g[u][v] = c;
		g[v][u] = c;
	}

	queue<elem> q;
	vector<int> used(n, -1);
	vector<vector<elem>> result(n);
	used[0] = 0;
	q.emplace(0, 0, 1e9 + 1, -1);
	while(!q.empty()) {
		auto el = q.front();
		q.pop();
		used[el.vertex] = true;

		for(const pair<int, int>& v : g[el.vertex]) {
			if(used[v.first] == -1 || used[v.first] == el.dist + 1) {
				elem new_el = { v.first, el.dist + 1, min(el.min_c, v.second), max(el.max_c, v.second) };
				q.push(new_el);
				new_el.vertex = el.vertex;
				result[v.first].push_back(new_el);
			}
		}
	}

	std::vector<int> real_result;
	real_result.push_back(n - 1);
	elem cur = *std::min_element(result[n - 1].begin(), result[n - 1].end(), [](const elem& el1, const elem& el2) {
		if(el1.dist != el2.dist) {
			return el1.dist < el2.dist;
		}

		return abs(el1.max_c - el1.min_c) > abs(el2.max_c - el2.min_c);
	});
	int color = g[n - 1][cur.vertex];


	while(cur.vertex != 0) {
		// cout << cur << endl;
		real_result.push_back(cur.vertex);
		auto it = find_if(result[cur.vertex].begin(), result[cur.vertex].end(), [&cur, &color, &g](const elem& el) {
			if(el.dist != cur.dist - 1) {
				return false;
			}
			
			// int c = -1;
			// int c = g[cur.vertex][el.vertex];
			// for(auto pix : g[cur.vertex]) {
			// 	if(pix.first == el.vertex) {
			// 		c = pix.second;
			// 		break;
			// 	}
			// }
			// cout << c << ": " << el << endl;
			
			if(el.min_c == cur.min_c && el.max_c == cur.max_c) {
				return true;
			}
			if(el.min_c == cur.min_c && color == cur.max_c) {
				return true;
			}
			if(color == cur.min_c && el.max_c == cur.max_c) {
				return true;
			}
			return false;
		});
		if(it == result[cur.vertex].end()) {
			throw 1;
		}
		color = g[cur.vertex][it->vertex];
		cur = *it;
	}
	real_result.push_back(0);
	cout << real_result.size() - 1 << endl;
	for(int i = real_result.size() - 1; i >= 0; --i) {
		cout << real_result[i] + 1 << " ";
	}
	cout << endl;
}