#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cctype>
#include <map>
#include <cassert>
#include <set>
#include <numeric>
#include <iomanip>
#include <deque>
#include <random>
#include <list>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 1'100'000;
const int INF = 1e9 + 7;
const int M = 998244353;
const ll LINF = 1e18;

void Bfs(int start, vector <vector <pair <int, int>>>& graph, vector <pair <int, int>>& p, vector <pair <pair <int, int>, int>> &dist) {
	deque <int> deq = {start};

	dist[start] = { {INF, -INF}, 0 };

	while (!deq.empty()) {
		int t = deq.front();
		deq.pop_front();
		for (auto i : graph[t]) {
			if (dist[t].second + 1 <= dist[i.first].second) {
				
				if (dist[t].second + 1 < dist[i.first].second) {
					dist[i.first].first = { INF, -INF };
					p[i.first] = { -1,-1 };
					deq.push_back(i.first);
				}

				dist[i.first].second = dist[t].second + 1;
				if (dist[i.first].first.first > min(i.second, dist[t].first.first)) {
					dist[i.first].first.first = min(i.second, dist[t].first.first);
					p[i.first].first = t;
				}
				if (dist[i.first].first.second < max(i.second, dist[t].first.second)) {
					dist[i.first].first.second = max(i.second, dist[t].first.second);
					p[i.first].second = t;
				}

			}
		}
	}
}


void Solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <pair <int, int>>> g(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		g[a - 1].push_back({ b - 1,c });
		g[b - 1].push_back({ a - 1,c });
	}

	vector <pair <pair <int, int>, int>> d1(n, { {INF,-INF}, INF }),
		dn(n, { {INF, -INF}, INF });
	vector <pair <int, int>> p1(n, { -1,-1 }), pn(n, { -1,-1 });

	Bfs(0, g, p1, d1);
	Bfs(n - 1, g, pn, dn);

	int optD = d1[n - 1].second;
	int bestmn = 0;
	int bestmx = 0;

	for (int i = 1; i < n; i++) {
		if (d1[i].second + dn[i].second != optD)
			continue;
		if (dn[bestmn].first.second - d1[bestmn].first.first < dn[i].first.second - d1[i].first.first)
			bestmn = i;
		if (d1[bestmx].first.second - dn[bestmx].first.first < d1[i].first.second - dn[i].first.first)
			bestmx = i;
	}

	if (dn[bestmn].first.second - d1[bestmn].first.first > d1[bestmx].first.second - dn[bestmx].first.first) {
		vector <int> pathN;
		int ndx = bestmn;
		while (pn[ndx].second != -1) {
			pathN.push_back(pn[ndx].second);
			ndx = pn[ndx].second;
		}

		ndx = bestmn;
		vector <int> path1;
		while (p1[ndx].first != -1) {
			path1.push_back(p1[ndx].first);
			ndx = p1[ndx].first;
		}
		reverse(path1.begin(), path1.end());
		cout << optD << endl;
		for (auto i : path1)
			cout << i+1 << " ";
		cout << bestmn+1;
		for (auto i : pathN)
			cout << " " << i+1;
		cout << endl;

	}
	else {
		vector <int> pathN;
		int ndx = bestmx;
		while (pn[ndx].first != -1) {
			pathN.push_back(pn[ndx].first);
			ndx = pn[ndx].first;
		}

		ndx = bestmx;
		vector <int> path1;
		while (p1[ndx].second != -1) {
			path1.push_back(p1[ndx].second);
			ndx = p1[ndx].second;
		}
		reverse(path1.begin(), path1.end());
		cout << optD << endl;
		for (auto i : path1)
			cout << i+1 << " ";
		cout << bestmx+1;
		for (auto i : pathN)
			cout << " " << i+1;
		cout << endl;
	}
}

int main() {
#ifdef _DEBUG
	std::freopen("input.txt", "r", stdin);
	std::freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}
