﻿#include <iostream>
#include <string>
#include <map>
#include <unordered_map>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <queue>

using namespace std;

int n;
map<pair<int, int>, long long> colors;
unordered_map<int, vector<int>> graph;
long long mx_diff = 0;
vector<int> best_path;

struct Step {
	int cur, len;
	vector<int> path;
};

void bfs(int s, int t) {
	vector<int> dist(n, n);
	vector<int> p(n, -1);
	dist[s] = 0;
	queue<int> q;
	q.push(s);

	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : graph[v]) {
			if (dist[u] > dist[v] + 1) {
				p[u] = v;
				dist[u] = dist[v] + 1;
				q.push(u);
			}
		}
	}

	vector<int> path;
	while (t != -1) {
		path.push_back(t);
		t = p[t];
	}

	vector<Step> stack;
	stack.push_back(Step{ n - 1, (int)path.size() - 1, {n - 1} });
	while (!stack.empty()) {
		const auto step = stack.back();
		stack.pop_back();

		if (step.len == 0) {
			long long mn = 1e18, mx = -1;
			for (size_t j = 0; j < step.path.size() - 1; j++)
			{
				auto c = colors[make_pair(step.path[j], step.path[j + 1])];
				if (c > mx)
					mx = c;
				if (c < mn)
					mn = c;
			}
			if ((mx - mn) > mx_diff) {
				mx_diff = mx - mn;
				best_path = step.path;
			}
			continue;
		}

		for (int next : graph[step.cur]) {
			if (dist[next] == step.len - 1) {
				auto new_path = step.path;
				new_path.push_back(next);
				stack.push_back({ next, step.len - 1, new_path });
			}
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

    int m;
    cin >> n >> m;
	for (size_t i = 0; i < m; i++)
	{
		int v, u;
		long long c;
		cin >> v >> u >> c;
		v -= 1;
		u -= 1;
		colors[{ v, u }] = c;
		colors[{ u, v }] = c;

		if (graph.find(u) == graph.end())
			graph[u] = vector<int>();
		graph[u].push_back(v);
		if (graph.find(v) == graph.end())
			graph[v] = vector<int>();
		graph[v].push_back(u);
	}

	bfs(0, n - 1);

	cout << best_path.size() - 1 << endl;
	for (int i = best_path.size() - 1; i >= 0; i--)
	{
		cout << best_path[i] + 1 << ' ';
	}
	cout << endl;
}