class Tree {
    val children = mutableMapOf<Char, Tree>()
    var count = 0

    fun deleteWordsByPrefix(canDelete: Int): Int {
        if (count <= canDelete) {
            val wasCount = count
            count = 0
            return wasCount
        }
        var maxVal = -1
        var maxTree: Tree? = null
        var keyOfMaxTree: Char? = null

        children.entries.forEach { c ->
            if (c.value.count > maxVal) {
                maxVal = c.value.count
                maxTree = c.value
                keyOfMaxTree = c.key
            }
        }
        val deletedCount = maxTree!!.deleteWordsByPrefix(canDelete)
        count -= deletedCount
        if (maxTree!!.count == 0) children.remove(keyOfMaxTree)
        return deletedCount
    }
}

tailrec fun addWord(curTree: Tree, word: String, position: Int) {
    curTree.count++
    if (position >= word.length)
        return
    if (!curTree.children.containsKey(word[position]))
        curTree.children[word[position]] = Tree()
    addWord(curTree.children[word[position]]!!, word, position + 1)
}

fun main() {
    val line1 = readLine()!!.split(" ").map { it.toInt() }
    val root = Tree()
    val amount = line1[0]
    val canDelete = line1[1]
    for (i in 0 until amount) {
        val word = readLine()!!
        addWord(root, word, 0)
    }
    var neededDeletes = 0
    while (root.count != 0) {
        neededDeletes++
        root.deleteWordsByPrefix(canDelete)
    }

    println(neededDeletes)
}