#include <iostream>
#include <limits>
#include <cstdint>
#include <cmath>

using namespace std;

int main() {
	int64_t n, m, c;
	cin >> n >> m >> c;

	int64_t M = n / m;
	int64_t C = n / c;

	int64_t approx = numeric_limits<int64_t>::max();
	int64_t ma = 0, ca = 0;

	for (int i = 0; i < M + 1; i++) {
		int64_t Ci_floor = floor(1.0 * (n - m * i) / c);
		int64_t Ci_ceil = ceil(1.0 * (n - m * i) / c);
		int64_t df = abs(Ci_floor * c + i * m - n);
		int64_t dc = abs(Ci_ceil * c + i * m - n);

		if (df < approx) {
			approx = df;
			ma = i;
			ca = Ci_floor;
		}

		if (dc < approx) {
			approx = dc;
			ma = i;
			ca = Ci_ceil;
		}
	}

	for (int j = 0; j < M + 1; j++) {
		int64_t Mi_floor = floor(1.0 * (n - j * c) / m);
		int64_t Mi_ceil = ceil(1.0 * (n - j * c) / m);
		int64_t df = abs(Mi_floor * m + j * c - n);
		int64_t dc = abs(Mi_ceil * m + j * c - n);

		if (df < approx) {
			approx = df;
			ma = Mi_floor;
			ca = j;
		}

		if (dc < approx) {
			approx = dc;
			ma = Mi_ceil;
			ca = j;
		}
	}

	cout << ma << " " << ca;

	return 0;
}