﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace ICPC_sharp
{
    class Program
    {
        static void Main(string[] args)
        {
            var st = Console.ReadLine().Split();
            var n = int.Parse(st[0]);
            var k = int.Parse(st[1]);
            var g = new PrefixGraph();
            for (var i = 0; i < n; i++)
            {
                var s = Console.ReadLine();
                g.AddChild(s, 0);
            }
            Console.WriteLine(g.RemoveStart(k));
        }
    }

    class PrefixGraph
    {
        public int ChildCount;
        public Dictionary<char, PrefixGraph> Children = new Dictionary<char, PrefixGraph>();

        public void AddChild(string s, int pos)
        {
            ChildCount++;
            if (pos == s.Length)
                return;
            if (!Children.ContainsKey(s[pos]))
                Children[s[pos]] = new PrefixGraph();
            Children[s[pos]].AddChild(s, pos + 1);
        }

        public int RemoveStart(int k)
        {
            var del = 0;
            while (ChildCount > 0)
            {
                Remove(k);
                del += 1;
            }
            return del;
        }


        public int Remove(int k)
        {
            if (ChildCount <= k)
            {
                var deleted = ChildCount;
                ChildCount = 0;
                return deleted;
            }

            var child = Children.Values.OrderByDescending(c => c.ChildCount).First();
            var res = child.Remove(k);
            ChildCount -= res;
            return res;
        }

        public override string ToString()
        {
            return "Children: " + ChildCount;
        }
    }
}