#include <bits/stdc++.h>

#define pb push_back
#define sz(x) (int)x.size()
#define whole(x) x.begin(), x.end()
#define rwhole(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)3e5 + 2;
const int INF = (int)1e9 + 7;
const ll linf = (ll)1e14;

int n, m;

int a[305][305], used[305][305];
set<pair<int, pair<int, int>>> g[305][305];

bool can(int i, int j) {
    return ((1 <= i && i <= n) && (1 <= j && j <= m));
}

bool is_q(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 2; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j + 2)) return false;
        sum += a[i + d][j + 2];
    }
    return (sum == 10);
}

void mark_q(int i, int j, pair<int, pair<int, int>> root) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
        g[i][j + d].erase(root);
    }
    for (int d = 1; d <= 2; ++d) {
        used[i + d][j] = 1;
        g[i + d][j].erase(root);
    }
    used[i + 2][j + 1] = 1;
    g[i + 2][j + 1].erase(root);
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j + 2] = 1;
        g[i + d][j + 2].erase(root);
    }
}

void fill_q(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        g[i][j + d].insert({0, {i, j}});
    }
    for (int d = 1; d <= 2; ++d) {
        g[i + d][j].insert({0, {i, j}});
    }
    g[i + 2][j + 1].insert({0, {i, j}});
    for (int d = 1; d <= 4; ++d) {
        g[i + d][j + 2].insert({0, {i, j}});        
    }
}

bool is_f(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    return (sum == 8);
}

void mark_f(int i, int j, pair<int, pair<int, int>> root) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
        g[i][j + d].erase(root);
    }
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j] = 1;
        g[i + d][j].erase(root);
    }
    used[i + 2][j + 1] = 1;
    g[i + 2][j + 1].erase(root);
}

void fill_f(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        g[i][j + d].insert({1, {i, j}});
    }
    for (int d = 1; d <= 4; ++d) {
        g[i + d][j].insert({1, {i, j}});
    }
    g[i + 2][j + 1].insert({1, {i, j}});
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return sz(g[a.first][a.second]) < sz(g[b.first][b.second]);
}

void solve() {  
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            char ch; cin >> ch;
            if (ch == '#') a[i][j] = 1;
            else a[i][j] = 0;
        }
    }

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (is_f(i, j)) {
                fill_f(i, j);
            }
            if (is_q(i, j)) {
                fill_q(i, j);
            }
        }
    }

    vector<pair<int, int>> all;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (g[i][j].empty()) continue;
            all.pb({i, j});
        }
    }

    sort(whole(all), &cmp);

    int cnt_q = 0, cnt_f = 0;
    for (auto p : all) {
        if (used[p.first][p.second]) continue;
        pair<int, pair<int, int>> cur = *g[p.first][p.second].begin();
        if (cur.first == 0) ++cnt_q, mark_q(cur.second.first, cur.second.second, cur);
        else ++cnt_f, mark_f(cur.second.first, cur.second.second, cur);
    }

    cout << cnt_q << " " << cnt_f << "\n";
}

int main() {
    int tt = 1;
    while (tt--) solve();
    return 0;
}

/*
   for (int ii = 1; ii <= n; ++ii) {
                    for (int jj = 1; jj <= m; ++jj) {
                        cout << used[ii][jj] << " ";
                    }
                    cout << "\n";
                }
                cout << "\n";
*/