#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef vector<int> vi;

vector<pair<int, int>> fCells = {
        {0, 0}, {0, 1}, {0, 2},
        {1, 0},
        {2, 0}, {2, 1},
        {3, 0},
        {4, 0}
};

vector<pair<int, int>> qCells = {
        {0, 0}, {0, 1}, {0, 2},
        {1, 0},                 {1, 2},
        {2, 0}, {2, 1}, {2, 2},
                                        {3, 2},
                                        {4, 2}
};

int n, m;
int fres = -1, qres = -1;

bool isValid(vector<string> mat) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mat[i][j] == '#') return false;
        }
    }
    return true;
}

bool setF(int i, int j, vector<string>& mat, int fcount, int qcount) {
    if (i + 4 >= n) return false;
    if (j + 2 >= m) return false;
    for (auto p: fCells) {
        if (mat[i + p.first][j+ p.second] != '#') return false;
    }
    return true;
}

bool setQ(int i, int j, vector<string>& mat, int fcount, int qcount) {
    if (i + 4 >= n) return false;
    if (j + 2 >= m) return false;
    for (auto p: qCells) {
        if (mat[i + p.first][j+ p.second] != '#') return false;
    }
    return true;
}

void rec(int i, int j, vector<string>& mat, int fcount, int qcount) {
//    cerr << i << ' ' << j << endl;
    if (j == m) {
        i++;
        j = 0;
    }
    if (fres != -1) return;
    if (i == n-1 && j == m-1) {
        if ((mat[i][j] == '.' || mat[i][j] == 'u') && isValid(mat)) {
            fres = fcount;
            qres = qcount;
        }
        return;
    }

    // if empty or already used, go next cell
    if (mat[i][j] == '.' || mat[i][j] == 'u') {
        rec(i, j+1, mat, fcount, qcount);
    }

    if (mat[i][j] == '#') {
        int count = 0;
        if (setF(i, j, mat, fcount, qcount)) {
            for (auto p: fCells) {
                mat[i + p.first][j+ p.second] = 'u';
            }
            rec(i, j+3, mat, fcount+1, qcount);

            for (auto p: fCells) {
                mat[i + p.first][j+ p.second] = '.';
            }
            count++;
        }
        if (setQ(i, j, mat, fcount, qcount)) {
            for (auto p: qCells) {
                mat[i + p.first][j+ p.second] = 'u';
            }
            rec(i, j+3, mat, fcount, qcount+1);

            for (auto p: qCells) {
                mat[i + p.first][j+ p.second] = '.';
            }
            count++;
        }
        if (count == 0) return;
    }
}

int main() {
    cin >> n >> m;
    vector<string> in(n);
    for (int i = 0; i < n; i++) cin >> in[i];
    rec(0, 0, in, 0, 0);
    cout << qres << ' ' << fres << endl;
}