# include <iostream>
# include <vector>
# define sz(x) (int)((x).size())

# define all(x) x.begin(), x.end()
 
using namespace std; 
using ll = long long;

int a[305][305];
int n, m;

void markQ(int i, int j) {
  vector<int> dx = {0, 1, 2, 0, 2, 0, 1, 2, 3, 4};
  vector<int> dy = {0, 0, 0, 1, 1, 2, 2, 2, 2, 2};
  for (int d = 0; d < dx.size(); d++) {
    a[i + dx[d]][j + dy[d]] = 0;
  }
}

void markF(int i, int j) {
  vector<int> dx = {0, 1, 2, 3, 4, 0, 2, 0};
  vector<int> dy = {0, 0, 0, 0, 0, 1, 1, 2};
  for (int d = 0; d < dx.size(); d++) {
    a[i + dx[d]][j + dy[d]] = 0;
  }
}

bool isQ(int i, int j) {
  vector<int> dx = {0, 1, 2, 0, 2, 0, 1, 2, 3, 4};
  vector<int> dy = {0, 0, 0, 1, 1, 2, 2, 2, 2, 2};
  int sum = 0;
  for (int d = 0; d < dx.size(); d++) {
    sum += a[i + dx[d]][j + dy[d]];
  }
  return sum == dx.size();
}

bool isF(int i, int j) {
  vector<int> dx = {0, 1, 2, 3, 4, 0, 2, 0};
  vector<int> dy = {0, 0, 0, 0, 0, 1, 1, 2};
  int sum = 0;
  for (int d = 0; d < dx.size(); d++) {
    sum += a[i + dx[d]][j + dy[d]];
  }
  return sum == dx.size();
}

void show() {
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      cout << a[i][j] << ' ';
    }
    cout << endl;
  }
  cout << endl;
}

int Q = 0, F = 0;

bool isEnd() {
  int x = 5, y = 3;
  for (int i = 1; i <= n - x + 1; i++) {
    for (int j = 1; j <= m - y + 1; j++) {
      bool q = isQ(i, j);
      bool f = isF(i, j);
      if (q && f) {
        continue;
      } else if (q) {
        markQ(i, j);
        Q++;
      } else if (f) {
        markF(i, j);
        F++;
      }
    }
  }

  int zeros = 0;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      zeros += 1 - a[i][j];
    }
  }

  return zeros == n * m;
}

void solve() {
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      char x;
      cin >> x;
      a[i][j] = (x == '#');
    }
  }

  while (!isEnd()) { }

  cout << Q << ' ' << F << endl;
}
 
int main(){
  //freopen("input.in", "r", stdin);
  //freopen("output.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  //int t = 1; cin >> t; while (t--)
  solve();
  return 0;
}
